'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDayPicker = require('react-day-picker');

var _reactDayPicker2 = _interopRequireDefault(_reactDayPicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Translate month names
var MONTHS = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

var CalendarYear = function (_Component) {
  (0, _inherits3.default)(CalendarYear, _Component);

  function CalendarYear(props) {
    (0, _classCallCheck3.default)(this, CalendarYear);

    var _this = (0, _possibleConstructorReturn3.default)(this, (CalendarYear.__proto__ || Object.getPrototypeOf(CalendarYear)).call(this, props));

    var year = props.calendarios[0];
    if (props.initCalendario) {
      year = props.initCalendario;
    }

    _this.state = {
      year: year,
      calendarios: []
    };
    _this.showPrevious = _this.showPrevious.bind(_this);
    _this.showNext = _this.showNext.bind(_this);
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(CalendarYear, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.calendarios.length !== 0 && this.state.calendarios.length === 0) {
        var year = nextProps.calendarios[0];
        if (nextProps.initCalendario) {
          year = nextProps.initCalendario;
        }

        nextProps.changeCalendario(year);
        this.setState({
          year: year,
          calendarios: nextProps.calendarios
        });
      }
    }
  }, {
    key: 'showPrevious',
    value: function showPrevious() {
      this.props.changeCalendario(this.state.year - 1);
      this.setState({
        year: this.state.year - 1
      });
    }
  }, {
    key: 'showNext',
    value: function showNext() {
      this.props.changeCalendario(this.state.year + 1);
      this.setState({
        year: this.state.year + 1
      });
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, modifiers, _ref) {
      var disabled = _ref.disabled,
          selected = _ref.selected;

      if (disabled) {
        return;
      }
      this.props.onSelected && this.props.onSelected((0, _moment2.default)(day));
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'YearCalendar' },
        this.props.calendarios.length !== 0 && _react2.default.createElement(
          'h1',
          null,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year - 1)] && _react2.default.createElement(
            'a',
            { onClick: this.showPrevious },
            this.state.year - 1
          ),
          this.state.year,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year + 1)] && _react2.default.createElement(
            'a',
            { onClick: this.showNext },
            this.state.year + 1
          )
        ),
        this.props.calendarios.length !== 0 && _react2.default.createElement('hr', null),
        !this.props.fetching && this.props.fetchingDias && this.props.calendarios.length !== 0 && _react2.default.createElement(_reactDayPicker2.default, {
          locale: 'es',
          months: MONTHS,
          weekdaysLong: WEEKDAYS_LONG,
          weekdaysShort: WEEKDAYS_SHORT,
          onDayClick: this.handleDayClick,
          canChangeMonth: false,
          month: new Date(this.state.year, 0, 1),
          numberOfMonths: 12,
          modifiers: this.props.modifiers,
          renderDay: this.props.renderDay && this.props.renderDay
        }),
        this.props.fetching && _react2.default.createElement(
          'h3',
          { style: { color: '#596464' } },
          'Cargando ...'
        ),
        !this.props.fetching && this.props.calendarios.length === 0 && _react2.default.createElement(
          'p',
          { style: { color: '#596464' } },
          _react2.default.createElement(
            'strong',
            null,
            'No existen calendarios cargados'
          )
        )
      );
    }
  }]);
  return CalendarYear;
}(_react.Component);

CalendarYear.defaultProps = {
  calendarios: []
};

CalendarYear.propTypes = {
  calendarios: _propTypes2.default.array,
  initCalendario: _propTypes2.default.number,
  fetching: _propTypes2.default.bool,
  fetchingDias: _propTypes2.default.bool,
  onSelected: _propTypes2.default.func,
  renderDay: _propTypes2.default.func,
  changeCalendario: _propTypes2.default.func,
  modifiers: _propTypes2.default.object
};

exports.default = CalendarYear;