'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Card = function (_Component) {
  (0, _inherits3.default)(Card, _Component);

  function Card(props) {
    (0, _classCallCheck3.default)(this, Card);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this, props));

    _this.state = {
      propOpen: props.open,
      collapseOpen: !props.animated ? true : props.open,
      textCollapse: !props.animated ? '' : props.open ? 'ocultar contenido' : 'mostrar contenido'
    };
    _this.toggle = _this.toggle.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Card, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.open !== this.state.propOpen) {
        this.setState({
          collapseOpen: nextProps.open,
          propOpen: nextProps.open
        });
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.setState({
        collapseOpen: !this.state.collapseOpen,
        textCollapse: !this.state.collapseOpen ? 'ocultar contenido' : 'mostrar contenido'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactstrap.Col,
        {
          className: 'col-12',
          style: { padding: this.props.fullWidth && 0 },
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        _react2.default.createElement(
          'div',
          {
            className: 'card' + (this.props.outlineColor ? ' card-outline-' + this.props.outlineColor : '') + (this.props.topColor ? ' card-accent-' + this.props.topColor : '') + (this.props.cardColor ? ' card-inverse card-' + this.props.cardColor : '')
          },
          this.props.title && _react2.default.createElement(
            'div',
            { className: 'card-header',
              onClick: this.props.animated && this.toggle,
              style: { cursor: this.props.animated ? 'pointer' : 'default' }
            },
            this.props.icon && _react2.default.createElement(_Icon2.default, this.props.icon),
            this.props.title,
            this.props.nextTitle,
            this.props.animated && _react2.default.createElement(
              'small',
              null,
              _react2.default.createElement(
                'strong',
                null,
                '\xA0\xA0(click para ',
                this.state.textCollapse,
                ')'
              )
            )
          ),
          _react2.default.createElement(
            _reactstrap.Collapse,
            { isOpen: this.state.collapseOpen },
            _react2.default.createElement(
              'div',
              {
                className: 'card-block' + (this.props.fullWidth ? ' row' : '')
              },
              this.props.children
            ),
            this.props.footer && _react2.default.createElement(
              'div',
              { className: 'card-footer' },
              this.props.footer
            )
          )
        )
      );
    }
  }]);
  return Card;
}(_react.Component);

Card.defaultProps = {
  size: {},
  animated: false,
  open: false,
  fullWidth: false
};

Card.propTypes = {
  size: _propTypes2.default.object,
  animated: _propTypes2.default.bool,
  open: _propTypes2.default.bool,
  fullWidth: _propTypes2.default.bool,
  icon: _propTypes2.default.object,
  title: _propTypes2.default.any,
  nextTitle: _propTypes2.default.any,
  outlineColor: _propTypes2.default.string,
  topColor: _propTypes2.default.string,
  cardColor: _propTypes2.default.string,
  footer: _propTypes2.default.any,
  children: _propTypes2.default.any
};

exports.default = Card;