'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reduxForm = require('redux-form');

var _ramda = require('ramda');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _FieldSwitch = require('../FieldSwitch');

var _FieldSwitch2 = _interopRequireDefault(_FieldSwitch);

var _FieldDate = require('../FieldDate');

var _FieldDate2 = _interopRequireDefault(_FieldDate);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Translate weekdays header
var WEEKDAYS_SHORT = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

var FieldDateEvent = function (_Component) {
  (0, _inherits3.default)(FieldDateEvent, _Component);

  function FieldDateEvent(props) {
    (0, _classCallCheck3.default)(this, FieldDateEvent);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FieldDateEvent.__proto__ || Object.getPrototypeOf(FieldDateEvent)).call(this, props));

    var repeticiones = [];
    for (var i = 1; i <= 52; i++) {
      repeticiones.push(i);
    }

    var inputsDays = {};
    for (var j = 0; j <= 6; j++) {
      inputsDays[j] = false;
    }

    _this.state = {
      showOverlay: false,
      value: { semanas: 1, desde: '', hasta: '', dias: [] },
      inputsDays: inputsDays,
      repeticionPorSemana: repeticiones,
      formatStringValue: '',
      showErrors: ''
    };
    _this.handleOpenDatepickerEvent = _this.handleOpenDatepickerEvent.bind(_this);
    _this.handleCleanDatepickerEvent = _this.handleCleanDatepickerEvent.bind(_this);
    _this.handlerOnSelectedDay = _this.handlerOnSelectedDay.bind(_this);
    _this.handlerChangeRepeticionSemana = _this.handlerChangeRepeticionSemana.bind(_this);
    _this.hideOverlay = _this.hideOverlay.bind(_this);
    _this.cleanFechaHasta = _this.cleanFechaHasta.bind(_this);

    _this._renderDays = _this._renderDays.bind(_this);
    _this.handlerChangeDay = _this.handlerChangeDay.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FieldDateEvent, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value === '') {
        var _repeticiones = [];
        for (var i = 1; i <= 52; i++) {
          _repeticiones.push(i);
        }

        var _inputsDays = {};
        for (var j = 0; j <= 6; j++) {
          _inputsDays[j] = false;
        }

        this.setState({
          showOverlay: false,
          value: { semanas: 1, desde: '', hasta: '', dias: [] },
          inputsDays: _inputsDays,
          repeticionPorSemana: _repeticiones,
          formatStringValue: '',
          showErrors: ''
        });
      }
    }
  }, {
    key: 'handleCleanDatepickerEvent',
    value: function handleCleanDatepickerEvent() {
      var _this2 = this;

      this.setState({ value: '' }, function () {
        return _this2.props.input.onChange('');
      });
    }
  }, {
    key: 'handleOpenDatepickerEvent',
    value: function handleOpenDatepickerEvent() {
      this.setState({ showOverlay: true });
    }
  }, {
    key: 'handlerOnSelectedDay',
    value: function handlerOnSelectedDay(field, value) {
      var _this3 = this;

      this.setState({
        value: (0, _ramda.merge)(this.state.value, (0, _defineProperty3.default)({}, field, value))
      }, function () {
        if (field === 'desde') {
          _this3.cleanFechaHasta();
        }
        _this3.props.input.onChange(_this3.state.value);
      });
    }
  }, {
    key: 'handlerChangeRepeticionSemana',
    value: function handlerChangeRepeticionSemana(value) {
      var _this4 = this;

      this.setState({
        value: (0, _ramda.merge)(this.state.value, { semanas: parseInt(value, 10) })
      }, function () {
        return _this4.props.input.onChange(_this4.state.value);
      });
    }
  }, {
    key: 'cleanFechaHasta',
    value: function cleanFechaHasta() {
      var _this5 = this;

      this.setState({
        value: (0, _ramda.merge)(this.state.value, { hasta: '' })
      }, function () {
        return _this5.props.input.onChange(_this5.state.value);
      });
    }
  }, {
    key: 'hideOverlay',
    value: function hideOverlay() {
      var showErrors = '';
      if (this.state.value && this.state.value.desde === '' && this.state.value.hasta === '') {
        showErrors += 'Ingrese desde y hasta';
      }
      if (this.state.value && this.state.value.desde === '' && this.state.value.hasta !== '') {
        showErrors += 'Ingrese desde';
      }
      if (this.state.value && this.state.value.desde !== '' && this.state.value.hasta === '') {
        showErrors += 'Ingrese hasta';
      }

      var hayAlgunDia = false;
      var dias = ', todos los ';
      for (var propiedad in this.state.inputsDays) {
        if (this.state.inputsDays[propiedad]) {
          hayAlgunDia = true;
          dias += WEEKDAYS_SHORT[propiedad] + ', ';
        }
      }

      if (!hayAlgunDia) {
        showErrors += showErrors !== '' ? ', ingrese algún día' : 'ingrese algún día';
      }

      if (showErrors !== '') {
        this.setState({
          showErrors: showErrors
        });
      } else {
        var formatStringValue = 'del ' + this.state.value.desde + ' hasta el ' + this.state.value.hasta;
        formatStringValue += dias.slice(0, -2);
        formatStringValue += ', cada ' + this.state.value.semanas + (this.state.value.semanas === 1 ? ' semana' : ' semanas');

        this.setState({
          showOverlay: false,
          showErrors: showErrors,
          formatStringValue: formatStringValue
        });
      }
    }
  }, {
    key: '_renderDays',
    value: function _renderDays(day, key) {
      var _this6 = this;

      return _react2.default.createElement(_FieldSwitch2.default, {
        key: 'dia-' + key,
        name: 'dia-' + key,
        label: day,
        type: 'checkbox',
        right: true,
        horizontal: true,
        size: 'sm',
        input: { value: this.state.inputsDays[key] },
        onChanged: function onChanged(value) {
          return _this6.handlerChangeDay(value, key);
        }
      });
    }
  }, {
    key: 'handlerChangeDay',
    value: function handlerChangeDay(value, key) {
      var _this7 = this;

      var inputsDays = this.state.inputsDays;
      inputsDays[key] = value;

      // CONVIERTO EL OBJETO A UN ARRAY DE ID SOLOS
      var inputsRedux = [];
      for (var propiedad in inputsDays) {
        if (inputsDays[propiedad]) {
          inputsRedux.push(parseInt(propiedad, 10));
        }
      }

      this.setState({
        inputsDays: inputsDays,
        value: (0, _ramda.merge)(this.state.value, { dias: inputsRedux })
      }, function () {
        _this7.props.input.onChange(_this7.state.value);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this8 = this;

      return _react2.default.createElement(
        _reactstrap.FormGroup,
        { color: !this.props.meta.touched ? '' : this.props.meta.valid ? '' : 'danger' },
        this.props.label && _react2.default.createElement(
          _reactstrap.Label,
          { 'for': this.props.label.replace(/ /g, '') },
          this.props.label,
          ' ',
          this.props.required && _react2.default.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        _react2.default.createElement(
          _reactstrap.InputGroup,
          null,
          _react2.default.createElement('input', {
            className: 'form-control',
            readOnly: true,
            type: 'text',
            ref: function ref(input) {
              _this8.input = input;
            },
            placeholder: this.props.placeholder,
            value: this.state.formatStringValue
          }),
          this.props.disabled && this.props.motiveDisabled && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip(this.props.motiveDisabled)
            },
            _react2.default.createElement(
              _reactstrap.InputGroupAddon,
              { style: { cursor: 'not-allowed' }
              },
              _react2.default.createElement(_Icon2.default, {
                bootstrap: 'calendar'
              })
            )
          ),
          this.props.disabled && !this.props.motiveDisabled && _react2.default.createElement(
            _reactstrap.InputGroupAddon,
            {
              style: { cursor: 'not-allowed' }
            },
            _react2.default.createElement(_Icon2.default, {
              bootstrap: 'calendar'
            })
          ),
          !this.props.disabled && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Abrir calendario')
            },
            _react2.default.createElement(
              _reactstrap.InputGroupAddon,
              {
                style: { cursor: 'pointer' },
                onClick: this.handleOpenDatepickerEvent },
              _react2.default.createElement(_Icon2.default, {
                bootstrap: 'calendar'
              })
            )
          ),
          !this.props.required && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Limpiar')
            },
            _react2.default.createElement(
              _reactstrap.InputGroupAddon,
              { style: { cursor: 'pointer' }, onClick: this.handleCleanDatepickerEvent },
              _react2.default.createElement(_Icon2.default, {
                bootstrap: 'close'
              })
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { style: {
              position: 'absolute',
              background: 'white',
              boxShadow: '0 2px 5px rgba(0, 0, 0, .15)',
              width: 510,
              height: 330,
              zIndex: 10,
              display: this.state.showOverlay ? 'block' : 'none'
            }
          },
          _react2.default.createElement(
            'div',
            { className: 'DayPicker-repeat',
              style: { float: 'left', width: 90, margin: '1rem 1rem 0px' }
            },
            _react2.default.createElement(
              'label',
              { style: { marginBottom: 10 } },
              'Repetir ',
              _react2.default.createElement(
                'span',
                { className: 'text-danger' },
                '*'
              )
            ),
            WEEKDAYS_SHORT.map(this._renderDays)
          ),
          _react2.default.createElement(
            'div',
            { style: { float: 'left', width: 350, margin: '1rem' } },
            _react2.default.createElement(_reduxForm.Field, (0, _extends3.default)({
              required: true,
              name: 'desde',
              type: 'text',
              label: 'Desde',
              formato: this.props.formato,
              input: { value: this.state.value.desde }
            }, this.props.configDesde, {
              component: _FieldDate2.default,
              onSelected: function onSelected(value) {
                _this8.handlerOnSelectedDay('desde', value);
              }
            })),
            _react2.default.createElement(_reduxForm.Field, (0, _extends3.default)({
              required: true,
              name: 'hasta',
              type: 'text',
              label: 'Hasta',
              formato: this.props.formato,
              input: { value: this.state.value.hasta },
              disabled: !this.state.value.desde,
              motiveDisabled: 'Seleccione primero desde',
              initialMonth: (0, _moment2.default)(this.state.value.desde, 'DD/MM/YYYY', true).toDate(),
              disabledDays: [{
                before: (0, _moment2.default)(this.state.value.desde, 'DD/MM/YYYY', true).toDate()
              }]
            }, this.props.configHasta, {
              component: _FieldDate2.default,
              onSelected: function onSelected(value) {
                _this8.handlerOnSelectedDay('hasta', value);
              }
            })),
            _react2.default.createElement(
              _reactstrap.FormGroup,
              null,
              _react2.default.createElement(
                _reactstrap.Label,
                { 'for': 'repeticionPorSemana' },
                'Se repite cada \xA0',
                _react2.default.createElement(
                  'select',
                  { name: 'repeticionPorSemana',
                    style: {
                      width: 70,
                      color: '#607d8b',
                      backgroundColor: '#fff',
                      backgroundImage: 'none',
                      backgroundClip: 'padding-box',
                      border: '1px solid rgba(0, 0, 0, 0.15)',
                      borderRadius: 0,
                      transition: 'border-color ease-in-out 0.15s, box-shadow ease-in-out 0.15s'
                    },
                    value: this.state.value.semanas,
                    onChange: function onChange(e) {
                      _this8.handlerChangeRepeticionSemana(e.currentTarget.value);
                    }
                  },
                  this.state.repeticionPorSemana.map(function (v, k) {
                    return _react2.default.createElement(
                      'option',
                      { key: k, value: v },
                      v
                    );
                  })
                ),
                '\xA0 semana/s'
              )
            ),
            this.state.showErrors !== '' && _react2.default.createElement(
              'wrapper',
              {
                id: 'customError',
                className: 'animated fadeInUp'
              },
              _react2.default.createElement(
                _reactstrap.Alert,
                {
                  color: 'danger'
                },
                this.state.showErrors
              )
            ),
            _react2.default.createElement(
              'div',
              { style: { position: 'absolute', width: 350, bottom: 20 } },
              _react2.default.createElement(
                'span',
                { className: 'pull-left text-danger' },
                '* Campos requeridos'
              ),
              _react2.default.createElement(
                _reactstrap.Button,
                {
                  className: 'pull-right',
                  size: 'sm',
                  color: 'success',
                  onClick: this.hideOverlay
                },
                'Listo'
              )
            )
          )
        ),
        this.props.meta.touched && this.props.meta.error && _react2.default.createElement(
          _reactstrap.FormFeedback,
          null,
          this.props.meta.error
        )
      );
    }
  }]);
  return FieldDateEvent;
}(_react.Component);

FieldDateEvent.defaultProps = {};

FieldDateEvent.propTypes = {
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  placeholder: _propTypes2.default.string,
  formato: _propTypes2.default.string,
  configDesde: _propTypes2.default.object,
  configHasta: _propTypes2.default.object,
  disabled: _propTypes2.default.bool,
  motiveDisabled: _propTypes2.default.string
};

exports.default = FieldDateEvent;