'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepcopy = require('deepcopy');

var _deepcopy2 = _interopRequireDefault(_deepcopy);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _reactInteractive = require('react-interactive');

var _reactInteractive2 = _interopRequireDefault(_reactInteractive);

var _reactDragDropContainer = require('./react-drag-drop-container');

var _Callout = require('../Callout');

var _Callout2 = _interopRequireDefault(_Callout);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldDragDropBoxes = function (_Component) {
  (0, _inherits3.default)(FieldDragDropBoxes, _Component);

  function FieldDragDropBoxes(props) {
    (0, _classCallCheck3.default)(this, FieldDragDropBoxes);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FieldDragDropBoxes.__proto__ || Object.getPrototypeOf(FieldDragDropBoxes)).call(this, props));

    var itemsBox1 = [];
    var itemsBox2 = [];
    if (props.input && Array.isArray(props.input.value)) {
      itemsBox1 = props.input.value;
    } else if (props.input && (0, _typeof3.default)(props.input.value) === 'object') {
      if (props.input.value.box1) {
        itemsBox1 = props.input.value.box1;
      }
      if (props.input.value.box2) {
        itemsBox2 = props.input.value.box2;
      }
    }

    _this.state = {
      itemsBox1: itemsBox1,
      itemsBox2: itemsBox2,
      stylesZonas: {
        box1: {},
        box2: {}
      }
    };
    _this.handlerOnHit = _this.handlerOnHit.bind(_this);
    _this.handlerMostrarZonas = _this.handlerMostrarZonas.bind(_this);
    _this.handlerOcultarZonas = _this.handlerOcultarZonas.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FieldDragDropBoxes, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.props.input && this.props.input.onChange({ box1: this.state.itemsBox1, box2: this.state.itemsBox2 });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input && nextProps.input.value && nextProps.input.value.box1 && this.state.itemsBox1.length !== nextProps.input.value.box1.length) {
        this.setState({
          itemsBox1: nextProps.input.value.box1
        });
      }
      if (nextProps.input && nextProps.input.value && nextProps.input.value.box2 && this.state.itemsBox2.length !== nextProps.input.value.box2.length) {
        this.setState({
          itemsBox2: nextProps.input.value.box2
        });
      }
    }
  }, {
    key: 'handlerOnHit',
    value: function handlerOnHit(_ref, box) {
      var _this2 = this;

      var item = _ref.item,
          index = _ref.index;

      var itemsBox1 = (0, _deepcopy2.default)(this.state.itemsBox1);
      var itemsBox2 = (0, _deepcopy2.default)(this.state.itemsBox2);
      if (box === 'box1') {
        itemsBox1.push(item);
        itemsBox2.splice(index, 1);
      } else {
        itemsBox2.push(item);
        itemsBox1.splice(index, 1);
      }
      this.setState({
        itemsBox1: itemsBox1,
        itemsBox2: itemsBox2
      }, function () {
        _this2.handlerOcultarZonas();
        _this2.props.input && _this2.props.input.onChange({ box1: itemsBox1, box2: itemsBox2 });
        _this2.props.onChanged && _this2.props.onChanged({ box1: itemsBox1, box2: itemsBox2 });
      });
    }
  }, {
    key: 'handlerMostrarZonas',
    value: function handlerMostrarZonas(zona) {
      var stylesZonas = this.state.stylesZonas;
      stylesZonas[zona] = { border: '2px dashed #757879' };
      this.setState({
        stylesZonas: stylesZonas
      });
    }
  }, {
    key: 'handlerOcultarZonas',
    value: function handlerOcultarZonas() {
      this.setState({
        stylesZonas: {
          box1: {},
          box2: {}
        }
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var styles = {
        border: '2px solid #757879',
        minHeight: 100,
        cursor: 'default'
      };
      return _react2.default.createElement(
        _reactstrap.Row,
        null,
        _react2.default.createElement(
          _reactstrap.Col,
          { className: 'col-12' },
          this.props.label && _react2.default.createElement(
            _reactstrap.Label,
            {
              'for': this.props.label.replace(/ /g, ''),
              className: this.props.meta && this.props.meta.touched && this.props.meta.error ? 'text-danger' : ''
            },
            this.props.label,
            ' ',
            this.props.required && _react2.default.createElement(
              'span',
              { className: 'text-danger' },
              '*'
            ),
            '\xA0',
            this.props.info && this.props.info !== '' && _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                placement: 'right',
                overlay: this._renderTooltip(this.props.info)
              },
              _react2.default.createElement(
                'wrapper',
                null,
                _react2.default.createElement(_Icon2.default, { bootstrap: 'info' })
              )
            )
          )
        ),
        _react2.default.createElement(
          _reactstrap.Col,
          { className: 'col-12', lg: '6' },
          _react2.default.createElement(
            'h6',
            null,
            _react2.default.createElement(
              _reactstrap.Badge,
              { color: 'success' },
              this.state.itemsBox1.length,
              ' ',
              this.state.itemsBox1.length === 1 ? 'elemento' : 'elementos'
            )
          ),
          _react2.default.createElement(
            _reactDragDropContainer.DropTarget,
            {
              targetKey: 'box1',
              onHit: function onHit(e) {
                return _this3.handlerOnHit(e.dragData, 'box1');
              }
            },
            _react2.default.createElement(
              'div',
              { style: (0, _extends3.default)({}, styles, this.state.stylesZonas.box1) },
              this.state.itemsBox1.map(function (item, index) {
                return _react2.default.createElement(
                  _reactDragDropContainer.DragDropContainer,
                  {
                    key: 'itemsBox1-' + index,
                    targetKey: 'box2',
                    returnToBase: true,
                    noDragging: item.disabled,
                    dragData: { item: item, index: index },
                    onDragStart: function onDragStart() {
                      return _this3.handlerMostrarZonas('box2');
                    },
                    onDragEnd: _this3.handlerOcultarZonas
                  },
                  _react2.default.createElement(
                    _reactInteractive2.default,
                    {
                      as: 'div',
                      hover: {
                        background: '#164525',
                        color: 'white',
                        boxShadow: '0px 3px 10px 0px rgba(50, 50, 50, 0.75)',
                        transition: '.2s all ease-in-out'
                      },
                      style: {
                        width: '100%',
                        transition: '.2s all ease-out'
                      }
                    },
                    _react2.default.createElement(_Callout2.default, {
                      fullWidth: true,
                      title: function title() {
                        return _this3.props.showData(item);
                      },
                      color: 'success',
                      style: { margin: '-10px 0' }
                    })
                  )
                );
              })
            )
          )
        ),
        _react2.default.createElement(
          _reactstrap.Col,
          { className: 'col-12', lg: '6' },
          _react2.default.createElement(
            'h6',
            null,
            _react2.default.createElement(
              _reactstrap.Badge,
              { color: 'success' },
              this.state.itemsBox2.length,
              ' ',
              this.state.itemsBox2.length === 1 ? 'elemento' : 'elementos'
            )
          ),
          _react2.default.createElement(
            _reactDragDropContainer.DropTarget,
            {
              targetKey: 'box2',
              onHit: function onHit(e) {
                return _this3.handlerOnHit(e.dragData, 'box2');
              }
            },
            _react2.default.createElement(
              'div',
              { style: (0, _extends3.default)({}, styles, this.state.stylesZonas.box2) },
              this.state.itemsBox2.map(function (item, index) {
                return _react2.default.createElement(
                  _reactDragDropContainer.DragDropContainer,
                  {
                    key: 'itemsBox2-' + index,
                    targetKey: 'box1',
                    returnToBase: true,
                    noDragging: item.disabled,
                    dragData: { item: item, index: index },
                    onDragStart: function onDragStart() {
                      return _this3.handlerMostrarZonas('box1');
                    },
                    onDragEnd: _this3.handlerOcultarZonas
                  },
                  _react2.default.createElement(
                    _reactInteractive2.default,
                    {
                      as: 'div',
                      hover: {
                        background: '#164525',
                        color: 'white',
                        boxShadow: '0px 3px 10px 0px rgba(50, 50, 50, 0.75)',
                        transition: '.2s all ease-in-out'
                      },
                      style: {
                        width: '100%',
                        transition: '.2s all ease-out'
                      }
                    },
                    _react2.default.createElement(_Callout2.default, {
                      fullWidth: true,
                      title: function title() {
                        return _this3.props.showData(item);
                      },
                      color: 'success',
                      style: { margin: '-10px 0' }
                    })
                  )
                );
              })
            )
          )
        ),
        _react2.default.createElement(
          _reactstrap.Col,
          { className: 'col-12' },
          this.props.meta && this.props.meta.touched && this.props.meta.error && _react2.default.createElement(
            _reactstrap.FormFeedback,
            { className: 'text-danger' },
            this.props.meta.error
          )
        )
      );
    }
  }]);
  return FieldDragDropBoxes;
}(_react.Component);

FieldDragDropBoxes.defaultProps = {};

FieldDragDropBoxes.propTypes = {
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  onChanged: _propTypes2.default.func,
  showData: _propTypes2.default.func,
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  info: _propTypes2.default.string
};

exports.default = FieldDragDropBoxes;