'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DropTarget = function (_React$Component) {
  (0, _inherits3.default)(DropTarget, _React$Component);

  function DropTarget(props) {
    (0, _classCallCheck3.default)(this, DropTarget);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DropTarget.__proto__ || Object.getPrototypeOf(DropTarget)).call(this, props));

    _this.elem = null;
    _this.handleDrop = _this.handleDrop.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(DropTarget, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.elem.addEventListener(this.props.targetKey + 'DragEnter', function (e) {
        _this2.props.onDragEnter(e);
      }, false);
      this.elem.addEventListener(this.props.targetKey + 'DragLeave', function (e) {
        _this2.props.onDragLeave(e);
      }, false);
      this.elem.addEventListener(this.props.targetKey + 'Drop', function (e) {
        _this2.handleDrop(e);
      }, false);
    }
  }, {
    key: 'createEvent',
    value: function createEvent(eventName, eventData) {
      // utility to create an event
      var e = void 0;
      if (typeof window.CustomEvent !== 'function') {
        // we are in IE 11 and must use old-style method of creating event
        e = document.createEvent('CustomEvent');
        e.initCustomEvent(eventName, true, true, {});
      } else {
        e = new CustomEvent(eventName, { bubbles: true, cancelable: true }); // eslint-disable-line
      }
      Object.assign(e, eventData);
      return e;
    }
  }, {
    key: 'handleDrop',
    value: function handleDrop(e) {
      // tell the drop source about the drop, then do the callback
      var evt = this.createEvent(this.props.targetKey + 'Dropped', { dropElem: this.elem, dropData: this.props.dropData });
      e.sourceElem.dispatchEvent(evt);
      this.props.onHit(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'span',
        { ref: function ref(t) {
            _this3.elem = t;
          } },
        this.props.children
      );
    }
  }]);
  return DropTarget;
}(_react2.default.Component);

DropTarget.propTypes = {
  children: _react2.default.PropTypes.node.isRequired,

  // needs to match the targetKey in the DragDropContainer
  targetKey: _react2.default.PropTypes.string,

  // data that gets sent back to the DragDropContainer and shows up in its onDrop() callback event
  dropData: _react2.default.PropTypes.object,

  // callbacks
  onDragEnter: _react2.default.PropTypes.func,
  onDragLeave: _react2.default.PropTypes.func,
  onHit: _react2.default.PropTypes.func
};

DropTarget.defaultProps = {
  targetKey: 'ddc',
  onDragEnter: function onDragEnter() {},
  onDragLeave: function onDragLeave() {},
  onHit: function onHit() {
    return function () {};
  },
  dropData: {}
};

exports.default = DropTarget;