'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _reactInputMask = require('react-input-mask');

var _reactInputMask2 = _interopRequireDefault(_reactInputMask);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _renderTooltip(text) {
  return _react2.default.createElement(
    _reactBootstrap.Tooltip,
    { id: 'tooltip' },
    _react2.default.createElement(
      'strong',
      null,
      text
    )
  );
}

var FieldInputMask = function FieldInputMask(_ref) {
  var label = _ref.label,
      input = _ref.input,
      autocomplete = _ref.autocomplete,
      componentClass = _ref.componentClass,
      byField = _ref.byField,
      onSelect = _ref.onSelect,
      stylesInput = _ref.stylesInput,
      props = (0, _objectWithoutProperties3.default)(_ref, ['label', 'input', 'autocomplete', 'componentClass', 'byField', 'onSelect', 'stylesInput']);
  return _react2.default.createElement(_reactInputMask2.default, (0, _extends3.default)({
    id: label ? label.replace(/ /g, '') : input.name.replace(/ /g, ''),
    className: 'form-control',
    autoComplete: autocomplete ? 'on' : 'off',
    type: componentClass,
    style: stylesInput,
    value: input ? !byField ? input.value : input.value[byField] : null,
    onChange: function onChange(event) {
      input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
    } //eslint-disable-line
    , onBlur: input && input.onBlur,
    onFocus: input && input.onFocus
  }, props));
};

FieldInputMask.defaultProps = {
  autocomplete: false
};

FieldInputMask.propTypes = {
  label: _propTypes2.default.string,
  byField: _propTypes2.default.any,
  componentClass: _propTypes2.default.string,
  input: _propTypes2.default.object,
  onSelect: _propTypes2.default.func,
  autocomplete: _propTypes2.default.bool,
  stylesInput: _propTypes2.default.object
};

var FieldInput = function FieldInput(_ref2) {
  var label = _ref2.label,
      input = _ref2.input,
      autocomplete = _ref2.autocomplete,
      componentClass = _ref2.componentClass,
      byField = _ref2.byField,
      onSelect = _ref2.onSelect,
      stylesInput = _ref2.stylesInput,
      props = (0, _objectWithoutProperties3.default)(_ref2, ['label', 'input', 'autocomplete', 'componentClass', 'byField', 'onSelect', 'stylesInput']);
  return _react2.default.createElement(_reactstrap.Input, (0, _extends3.default)({
    id: label ? label.replace(/ /g, '') : input.name.replace(/ /g, ''),
    autoComplete: autocomplete ? 'on' : 'off',
    type: componentClass,
    style: stylesInput,
    value: input ? !byField ? input.value : input.value[byField] : null,
    onChange: function onChange(event) {
      input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
    } //eslint-disable-line
    , onBlur: input && input.onBlur,
    onFocus: input && input.onFocus
  }, props));
};

FieldInput.defaultProps = {
  autocomplete: false
};

FieldInput.propTypes = {
  label: _propTypes2.default.string,
  byField: _propTypes2.default.any,
  componentClass: _propTypes2.default.string,
  input: _propTypes2.default.object,
  onSelect: _propTypes2.default.func,
  autocomplete: _propTypes2.default.bool,
  stylesInput: _propTypes2.default.object
};

var FieldGroup = function FieldGroup(_ref3) {
  var horizontal = _ref3.horizontal,
      required = _ref3.required,
      meta = _ref3.meta,
      info = _ref3.info,
      className = _ref3.className,
      props = (0, _objectWithoutProperties3.default)(_ref3, ['horizontal', 'required', 'meta', 'info', 'className']);
  return _react2.default.createElement(
    _reactstrap.FormGroup,
    {
      color: meta && !meta.touched ? '' : meta && meta.valid ? '' : 'danger',
      row: horizontal ? true : undefined,
      className: className
    },
    props.label && _react2.default.createElement(
      _reactstrap.Label,
      {
        'for': props.label.replace(/ /g, ''),
        xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
        sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
        md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
        lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
        xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
      },
      props.label,
      ' ',
      required && _react2.default.createElement(
        'span',
        { className: 'text-danger' },
        '*'
      ),
      '\xA0',
      info && info !== '' && _react2.default.createElement(
        _reactBootstrap.OverlayTrigger,
        {
          placement: 'right',
          overlay: _renderTooltip(info)
        },
        _react2.default.createElement(
          'wrapper',
          null,
          _react2.default.createElement(_Icon2.default, { bootstrap: 'info' })
        )
      )
    ),
    horizontal && _react2.default.createElement(
      _reactstrap.Col,
      {
        xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
        sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
        md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
        lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
        xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
      },
      props.mask && FieldInputMask(props),
      !props.mask && FieldInput(props),
      meta && meta.touched && meta.error && _react2.default.createElement(
        _reactstrap.FormFeedback,
        null,
        meta.error
      )
    ),
    !horizontal && props.mask && FieldInputMask(props),
    !horizontal && !props.mask && FieldInput(props),
    !horizontal && meta && meta.touched && meta.error && _react2.default.createElement(
      _reactstrap.FormFeedback,
      null,
      meta.error
    )
  );
};

FieldGroup.defaultProps = {};

FieldGroup.propTypes = {
  label: _propTypes2.default.string,
  mask: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  meta: _propTypes2.default.object,
  horizontal: _propTypes2.default.object,
  info: _propTypes2.default.string,
  className: _propTypes2.default.string
};

exports.default = FieldGroup;