'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _ramda = require('ramda');

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StylesInput = {
  padding: '8px 0 0.3rem',
  backgroundColor: 'transparent',
  outline: 'none',
  border: 'none',
  borderBottom: '1px solid rgba(0, 0, 0, 0.15)',
  textAlign: 'center',
  display: 'inline-block'
};

var FieldTime = function (_Component) {
  (0, _inherits3.default)(FieldTime, _Component);

  function FieldTime(props) {
    (0, _classCallCheck3.default)(this, FieldTime);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FieldTime.__proto__ || Object.getPrototypeOf(FieldTime)).call(this, props));

    var value = {
      hora: '00',
      minutos: '00'
    };
    if (props.input.value && props.input.value !== '') {
      value = props.input.value.split(':');
      value = {
        hora: value[0],
        minutos: value[1]
      };
    }

    _this.state = {
      value: value,
      hora: _this.generateTime(24),
      minutos: _this.generateTime(60)
    };
    _this.handlerChangeHora = _this.handlerChangeHora.bind(_this);
    _this.handlerChangeMinutos = _this.handlerChangeMinutos.bind(_this);
    _this.setValue = _this.setValue.bind(_this);
    _this._renderInput = _this._renderInput.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FieldTime, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value && nextProps.input.value !== '' && !(0, _deepEqual2.default)(nextProps.input.value, this.state.value)) {
        var value = nextProps.input.value.split(':');
        value = {
          hora: value[0],
          minutos: value[1]
        };
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: 'generateTime',
    value: function generateTime(hasta) {
      var cantidad = [];
      for (var i = 0; i < hasta; i++) {
        if (i < 10) {
          i = '0' + i;
        }
        cantidad.push(i.toString());
      }
      return cantidad;
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'handlerChangeHora',
    value: function handlerChangeHora(e) {
      var _this2 = this;

      this.setState({
        value: (0, _ramda.merge)(this.state.value, { hora: e.currentTarget.value })
      }, function () {
        _this2.setValue();
      });
    }
  }, {
    key: 'handlerChangeMinutos',
    value: function handlerChangeMinutos(e) {
      var _this3 = this;

      this.setState({
        value: (0, _ramda.merge)(this.state.value, { minutos: e.currentTarget.value })
      }, function () {
        _this3.setValue();
      });
    }
  }, {
    key: 'setValue',
    value: function setValue() {
      var value = this.state.value.hora + ':' + this.state.value.minutos;
      this.props.input && this.props.input.onChange && this.props.input.onChange(value);
      this.props.onChanged && this.props.onChanged(value);
    }
  }, {
    key: '_renderInput',
    value: function _renderInput() {
      return _react2.default.createElement(
        'div',
        { style: { display: 'flex' } },
        _react2.default.createElement(
          'select',
          {
            style: StylesInput,
            className: 'form-control',
            value: this.state.value.hora,
            onChange: this.handlerChangeHora
          },
          this.state.hora.map(function (h, k) {
            return _react2.default.createElement(
              'option',
              { key: k, value: h },
              h
            );
          })
        ),
        _react2.default.createElement(
          'span',
          { className: 'font-xl' },
          ':'
        ),
        _react2.default.createElement(
          'select',
          {
            style: StylesInput,
            className: 'form-control',
            value: this.state.value.minutos,
            onChange: this.handlerChangeMinutos
          },
          this.state.minutos.map(function (m, k) {
            return _react2.default.createElement(
              'option',
              { key: k, value: m },
              m
            );
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          horizontal = _props.horizontal,
          required = _props.required,
          meta = _props.meta,
          info = _props.info,
          className = _props.className,
          props = (0, _objectWithoutProperties3.default)(_props, ['horizontal', 'required', 'meta', 'info', 'className']);

      return _react2.default.createElement(
        _reactstrap.FormGroup,
        {
          color: meta ? !meta.touched ? '' : meta.valid ? '' : 'danger' : '',
          row: horizontal ? true : undefined,
          className: className
        },
        props.label && _react2.default.createElement(
          _reactstrap.Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && _react2.default.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          ),
          '\xA0',
          info && info !== '' && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'right',
              overlay: this._renderTooltip(info)
            },
            _react2.default.createElement(
              'wrapper',
              null,
              _react2.default.createElement(_Icon2.default, { bootstrap: 'info' })
            )
          )
        ),
        horizontal && _react2.default.createElement(
          _reactstrap.Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderInput(),
          meta && meta.touched && meta.error && _react2.default.createElement(
            _reactstrap.FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderInput(),
        !horizontal && meta && meta.touched && meta.error && _react2.default.createElement(
          _reactstrap.FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);
  return FieldTime;
}(_react.Component);

FieldTime.defaultProps = {};

FieldTime.propTypes = {
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  meta: _propTypes2.default.object,
  horizontal: _propTypes2.default.object,
  info: _propTypes2.default.string,
  className: _propTypes2.default.string,
  onChanged: _propTypes2.default.func,
  input: _propTypes2.default.object
};

exports.default = FieldTime;