'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MenuTopMotion = function (_Component) {
  (0, _inherits3.default)(MenuTopMotion, _Component);

  function MenuTopMotion(props) {
    (0, _classCallCheck3.default)(this, MenuTopMotion);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MenuTopMotion.__proto__ || Object.getPrototypeOf(MenuTopMotion)).call(this, props));

    _this.state = {
      buttons: null
    };
    return _this;
  }

  (0, _createClass3.default)(MenuTopMotion, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.isOpen === true) {
        document.body.classList.add('modal-open');

        var buttons = [];
        if (nextProps.buttons && Array.isArray(nextProps.buttons.props.children)) {
          nextProps.buttons.props.children.map(function (b, bk) {
            if (b) {
              b = _react2.default.cloneElement(b, {
                key: 'button-' + bk,
                style: { flex: 1 }
              });
              buttons.push(b);
            }
            return b;
          });
        } else {
          var btn = _react2.default.cloneElement(nextProps.buttons, {
            key: 'button',
            style: { flex: 1 }
          });
          buttons.push(btn);
        }
        buttons.push(_react2.default.createElement(
          _reactstrap.Button,
          {
            style: { flex: 1 },
            key: 'close',
            size: 'md',
            onClick: function onClick() {
              return _this2.props.closeMenu(false);
            },
            name: 'close'
          },
          'Cerrar'
        ));

        this.setState({
          buttons: buttons
        });
      } else {
        document.body.classList.remove('modal-open');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'wrapper',
        {
          className: 'MenuTopMotion',
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 1s,opacity 1s linear' : ''
          }
        },
        this.props.backlock && _react2.default.createElement('div', {
          onClick: function onClick() {
            return _this3.props.closeMenu(false);
          },
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 0.5s,opacity 0.5s linear' : ''
          },
          className: 'modal-backdrop fade ' + (this.props.isOpen ? 'show' : '')
        }),
        _react2.default.createElement(
          _reactstrap.Navbar,
          { color: this.props.backgroundColor,
            toggleable: true,
            className: 'animated-3 ' + (this.props.isOpen ? this.props.animation.open : this.props.animation.close)
          },
          this.props.children,
          _react2.default.createElement(
            'wrapper',
            {
              style: {
                display: 'flex',
                alignSelf: 'flex-start',
                flexWrap: 'wrap'
              }
            },
            this.state.buttons
          )
        )
      );
    }
  }]);
  return MenuTopMotion;
}(_react.Component);

MenuTopMotion.defaultProps = {
  backlock: true,
  backgroundColor: 'faded',
  animation: { open: 'slideInDown', close: 'slideOutUp' }
};

MenuTopMotion.propTypes = {
  backgroundColor: _propTypes2.default.string,
  backlock: _propTypes2.default.bool,
  animation: _propTypes2.default.object,
  isOpen: _propTypes2.default.bool,
  closeMenu: _propTypes2.default.func,
  children: _propTypes2.default.any,
  buttons: _propTypes2.default.any
};

exports.default = MenuTopMotion;