'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Modal = function (_Component) {
  (0, _inherits3.default)(Modal, _Component);

  function Modal(props) {
    (0, _classCallCheck3.default)(this, Modal);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.state = {
      close: false
    };
    _this._renderHeader = _this._renderHeader.bind(_this);
    _this._renderBody = _this._renderBody.bind(_this);
    _this._renderFooter = _this._renderFooter.bind(_this);
    _this.close = _this.close.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Modal, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpen) {
        document.body.classList.add('modal-open');
      }
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      return _react2.default.createElement(
        _reactstrap.ModalHeader,
        { toggle: !this.props.noHeaderBtnClose && this.close },
        this.props.title
      );
    }
  }, {
    key: '_renderBody',
    value: function _renderBody() {
      return _react2.default.createElement(
        _reactstrap.ModalBody,
        null,
        this.props.titleBody && _react2.default.createElement(
          'p',
          null,
          this.props.titleBody
        ),
        this.props.children
      );
    }
  }, {
    key: '_renderFooter',
    value: function _renderFooter() {
      return _react2.default.createElement(
        _reactstrap.ModalFooter,
        null,
        this.props.preFooter,
        !this.props.noFooterBtnClose && _react2.default.createElement(
          _reactstrap.Button,
          {
            disabled: this.props.fetching,
            onClick: this.close,
            style: { marginRight: 5 }
          },
          'Cerrar'
        ),
        this.props.footer
      );
    }
  }, {
    key: 'close',
    value: function close() {
      var _this2 = this;

      if (this.props.animation.out) {
        this.setState({
          close: true
        }, function () {
          setTimeout(function () {
            _this2.props.close();
            _this2.setState({
              close: false
            });
          }, 300);
        });
      } else {
        this.props.close();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactstrap.Modal,
        {
          isOpen: this.props.isOpen,
          backdrop: 'static',
          size: this.props.size,
          className: (this.props.color ? 'modal-' + this.props.color : '') + (this.props.animation.in && !this.state.close ? ' animated ' + this.props.animation.in : ' ') + (this.props.animation.out && this.state.close ? ' animated ' + this.props.animation.out : ' ')
        },
        this.props.title && this._renderHeader(),
        this._renderBody(),
        !this.props.noFooter && this._renderFooter()
      );
    }
  }]);
  return Modal;
}(_react.Component);

Modal.defaultProps = {
  isOpen: false,
  noHeaderBtnClose: false,
  noFooterBtnClose: false,
  noFooter: false,
  size: 'md',
  animation: {}
};

Modal.propTypes = {
  size: _propTypes2.default.string,
  title: _propTypes2.default.string,
  titleBody: _propTypes2.default.string,
  color: _propTypes2.default.string,
  isOpen: _propTypes2.default.bool,
  noHeaderBtnClose: _propTypes2.default.bool,
  noFooterBtnClose: _propTypes2.default.bool,
  noFooter: _propTypes2.default.bool,
  fetching: _propTypes2.default.bool,
  close: _propTypes2.default.func.isRequired,
  children: _propTypes2.default.any,
  footer: _propTypes2.default.any,
  preFooter: _propTypes2.default.any,
  animation: _propTypes2.default.object
};

exports.default = Modal;