'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _withTooltip = require('./withTooltip');

var _withTooltip2 = _interopRequireDefault(_withTooltip);

var _withColumnsTag = require('./withColumnsTag');

var _withColumnsTag2 = _interopRequireDefault(_withColumnsTag);

var _withSortLimitFilterPageFunctions = require('./withSortLimitFilterPageFunctions');

var _withSortLimitFilterPageFunctions2 = _interopRequireDefault(_withSortLimitFilterPageFunctions);

var _withLimit = require('./withLimit');

var _withLimit2 = _interopRequireDefault(_withLimit);

var _withFilter = require('./withFilter');

var _withFilter2 = _interopRequireDefault(_withFilter);

var _withSort = require('./withSort');

var _withSort2 = _interopRequireDefault(_withSort);

var _withPage = require('./withPage');

var _withPage2 = _interopRequireDefault(_withPage);

var _withPageDetail = require('./withPageDetail');

var _withPageDetail2 = _interopRequireDefault(_withPageDetail);

var _withMultiFilter = require('./withMultiFilter');

var _withMultiFilter2 = _interopRequireDefault(_withMultiFilter);

var _withPrint = require('./withPrint');

var _withPrint2 = _interopRequireDefault(_withPrint);

var _withTable = require('./withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _withFixHeader = require('./withFixHeader');

var _withFixHeader2 = _interopRequireDefault(_withFixHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Table = function (_Component) {
  (0, _inherits3.default)(Table, _Component);

  function Table(props) {
    (0, _classCallCheck3.default)(this, Table);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.state = {};
    return _this;
  }

  (0, _createClass3.default)(Table, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'wrapper',
        {
          className: 'componentTable',
          style: (0, _extends3.default)({ display: 'block' }, this.props.style)
        },
        this.props._renderMultiFilter(),
        (this.props.limit || this.props.filter) && _react2.default.createElement(
          _reactstrap.Row,
          { className: 'table_filtros' },
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderLimit()
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderFilter()
          )
        ),
        this.props._renderColumnsTag(),
        this.props.fixHeader && this.props._renderTableFixHeader(),
        !this.props.fixHeader && this.props._renderTable(),
        this.props.pagination && !this.props.fetching && _react2.default.createElement(
          _reactstrap.Row,
          null,
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '7' },
            this.props._renderPage()
          ),
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12', lg: '5' },
            this.props._renderPageDetail()
          )
        ),
        (this.props.print || this.props.otherOptions) && !this.props.fetching && _react2.default.createElement(
          _reactstrap.Row,
          null,
          _react2.default.createElement(
            _reactstrap.Col,
            { className: 'col-12' },
            this.props._renderPrintButton(),
            !this.props.popupWindow && this.props.otherOptions
          )
        ),
        this.props._renderPrint()
      );
    }
  }]);
  return Table;
}(_react.Component);

Table.defaultProps = {};

Table.propTypes = {
  // withColumnsTag
  _renderColumnsTag: _propTypes2.default.func,
  // withLimit
  _renderLimit: _propTypes2.default.func,
  // withFilter
  _renderFilter: _propTypes2.default.func,
  // withPage
  _renderPage: _propTypes2.default.func,
  // withPageDetail
  _renderPageDetail: _propTypes2.default.func,

  // withMultiFilter
  _renderMultiFilter: _propTypes2.default.func,
  // withPrint
  _renderPrintButton: _propTypes2.default.func,
  _renderPrint: _propTypes2.default.func,
  // withTable
  _renderTable: _propTypes2.default.func,
  // withFixHeader
  _renderTableFixHeader: _propTypes2.default.func,

  style: _propTypes2.default.object,
  filter: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object]),
  limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object]),
  pagination: _propTypes2.default.object,
  fixHeader: _propTypes2.default.bool,
  print: _propTypes2.default.bool,
  otherOptions: _propTypes2.default.any,
  popupWindow: _propTypes2.default.bool,
  fetching: _propTypes2.default.bool
};

exports.default = (0, _withTooltip2.default)((0, _withColumnsTag2.default)((0, _withSortLimitFilterPageFunctions2.default)((0, _withLimit2.default)((0, _withFilter2.default)((0, _withSort2.default)((0, _withPage2.default)((0, _withPageDetail2.default)((0, _withMultiFilter2.default)((0, _withPrint2.default)((0, _withTable2.default)((0, _withFixHeader2.default)(Table))))))))))));