'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = withFilter;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _FieldDate = require('../FieldDate');

var _FieldDate2 = _interopRequireDefault(_FieldDate);

var _FieldDateTime = require('../FieldDateTime');

var _FieldDateTime2 = _interopRequireDefault(_FieldDateTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withFilter(Component) {
  var withFilter = function (_React$Component) {
    (0, _inherits3.default)(withFilter, _React$Component);

    function withFilter(props) {
      (0, _classCallCheck3.default)(this, withFilter);

      var _this = (0, _possibleConstructorReturn3.default)(this, (withFilter.__proto__ || Object.getPrototypeOf(withFilter)).call(this, props));

      var selectFilterType = null;
      var selectFilterValue = null;
      var filter = null;
      if (props.filter && (0, _typeof3.default)(props.filter) === 'object' && props.filter.options) {
        filter = [];
        var saveFirstActive = true;
        for (var prop in props.filter.options) {
          filter.push(prop);
          if (saveFirstActive) {
            selectFilterValue = prop;
            selectFilterType = props.filter.options[prop];
            saveFirstActive = false;
          }
        }
      }

      _this.state = {
        filter: filter,
        selectFilterType: selectFilterType,
        selectFilterValue: selectFilterValue,
        inputFilterValue: ''
      };
      _this.handlerOnChangeSelectFilter = _this.handlerOnChangeSelectFilter.bind(_this);
      _this.handlerOnClickFindFilter = _this.handlerOnClickFindFilter.bind(_this);
      _this.handlerOnChangeInput = _this.handlerOnChangeInput.bind(_this);
      _this._renderSelectFilter = _this._renderSelectFilter.bind(_this);
      _this._renderFilter = _this._renderFilter.bind(_this);
      return _this;
    }

    (0, _createClass3.default)(withFilter, [{
      key: 'handlerOnChangeInput',
      value: function handlerOnChangeInput(value) {
        this.setState({
          inputFilterValue: value
        });
      }
    }, {
      key: 'handlerOnClickFindFilter',
      value: function handlerOnClickFindFilter(prop, value) {
        var _this2 = this;

        var filter = [];
        if (value && value !== '') {
          if (this.props.filter.output && this.props.filter.output[prop]) {
            var _filter$push;

            filter.push((_filter$push = {}, (0, _defineProperty3.default)(_filter$push, this.props.outputDefault.p || 'p', this.props.filter.output[prop].prop || prop), (0, _defineProperty3.default)(_filter$push, this.props.outputDefault.v || 'v', this.props.filter.output[prop].value ? typeof this.props.filter.output[prop].value === 'function' ? this.props.filter.output[prop].value(value) : this.props.filter.output[prop].value : value), (0, _defineProperty3.default)(_filter$push, this.props.outputDefault.t || 't', this.props.filter.output[prop].type || (this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined)), (0, _defineProperty3.default)(_filter$push, this.props.outputDefault.e || 'e', this.props.filter.output[prop].exp ? this.props.filter.output[prop].exp : undefined), _filter$push));
          } else {
            var _filter$push2;

            filter.push((_filter$push2 = {}, (0, _defineProperty3.default)(_filter$push2, this.props.outputDefault.p || 'p', prop), (0, _defineProperty3.default)(_filter$push2, this.props.outputDefault.v || 'v', value), (0, _defineProperty3.default)(_filter$push2, this.props.outputDefault.t || 't', this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined), _filter$push2));
          }
        }

        this.setState({
          inputFilterValue: value
        }, function () {
          return _this2.props.setActiveFilter(filter);
        });
      }
    }, {
      key: 'handlerOnChangeSelectFilter',
      value: function handlerOnChangeSelectFilter(value) {
        var _this3 = this;

        if (this.state.selectFilterType) {
          this.setState({
            selectFilterValue: value,
            selectFilterType: this.props.filter.options[value],
            inputFilterValue: ''
          }, function () {
            if (_this3.state.selectFilterType === 'text' || _this3.state.selectFilterType === 'number') {
              _this3.inputFilter.focus();
            }
          });
        } else {
          this.inputFilter.focus();
        }
      }
    }, {
      key: '_renderSelectFilter',
      value: function _renderSelectFilter(opt, kOpt) {
        return _react2.default.createElement(
          'option',
          {
            key: 'opt' + kOpt,
            value: opt
          },
          this.props.tHead[opt]
        );
      }
    }, {
      key: '_renderFilter',
      value: function _renderFilter() {
        var _this4 = this;

        if (this.props.filter) {
          return _react2.default.createElement(
            'div',
            { className: 'pull-right' },
            _react2.default.createElement(
              _reactstrap.InputGroup,
              null,
              _react2.default.createElement(
                _reactstrap.InputGroupButton,
                null,
                _react2.default.createElement(
                  'select',
                  {
                    style: { width: '100%' },
                    className: 'form-control',
                    value: this.state.selectFilterValue,
                    onChange: function onChange(e) {
                      return _this4.handlerOnChangeSelectFilter(e.currentTarget.value);
                    }
                  },
                  this.state.filter.map(this._renderSelectFilter)
                )
              ),
              this.state.selectFilterType && this.state.selectFilterType === 'date' && _react2.default.createElement(_FieldDate2.default, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && this.state.selectFilterType === 'datetime' && _react2.default.createElement(_FieldDateTime2.default, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && Array.isArray(this.state.selectFilterType) && _react2.default.createElement(
                'select',
                {
                  className: 'form-control',
                  value: this.state.inputFilterValue,
                  onChange: function onChange(e) {
                    return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                },
                _react2.default.createElement('option', { value: '' }),
                this.state.selectFilterType.map(function (v, k) {
                  return _react2.default.createElement(
                    'option',
                    { key: 'option-' + k, value: v.value || v },
                    v.label || v
                  );
                })
              ),
              (!this.state.selectFilterType || this.state.selectFilterType === 'text' || this.state.selectFilterType === 'number') && _react2.default.createElement('input', {
                type: this.state.selectFilterType,
                ref: function ref(input) {
                  _this4.inputFilter = input;
                },
                className: 'form-control',
                onChange: function onChange(e) {
                  return _this4.handlerOnChangeInput(e.currentTarget.value);
                },
                onKeyPress: function onKeyPress(e) {
                  if (e.which === 13 || e.charCode === 13 || e.keyCode === 13) {
                    _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                }
              }),
              _react2.default.createElement(
                _reactBootstrap.OverlayTrigger,
                {
                  placement: 'top',
                  overlay: this.props._renderTooltip('Buscar')
                },
                _react2.default.createElement(
                  _reactstrap.InputGroupAddon,
                  {
                    style: { cursor: 'pointer' },
                    onClick: function onClick(e) {
                      return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, _this4.state.inputFilterValue);
                    }
                  },
                  _react2.default.createElement(_Icon2.default, {
                    bootstrap: 'magnifier'
                  })
                )
              )
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, (0, _extends3.default)({
          _renderFilter: this._renderFilter
        }, this.props));
      }
    }]);
    return withFilter;
  }(_react2.default.Component);

  withFilter.defaultProps = {
    tHead: {},
    outputDefault: {}
  };

  withFilter.propTypes = {
    filter: _propTypes2.default.object,
    tHead: _propTypes2.default.object,
    outputDefault: _propTypes2.default.object,
    _renderTooltip: _propTypes2.default.func,
    setActiveFilter: _propTypes2.default.func
  };

  return withFilter;
}