'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = withPage;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withPage(Component) {
  var withPage = function (_React$Component) {
    (0, _inherits3.default)(withPage, _React$Component);

    function withPage(props) {
      (0, _classCallCheck3.default)(this, withPage);

      var _this = (0, _possibleConstructorReturn3.default)(this, (withPage.__proto__ || Object.getPrototypeOf(withPage)).call(this, props));

      var items = 0;
      if (props.tBodyObject.length !== 0 && props.pagination) {
        if (props.limit) {
          items = Math.ceil(props.pagination.total / props.activeLimit);
        } else if (props.pagination.perPage && props.pagination.total) {
          items = Math.ceil(props.pagination.total / props.pagination.perPage);
        }
      }

      _this.state = {
        items: items
      };
      _this.handlerOnChange = _this.handlerOnChange.bind(_this);
      _this._renderPage = _this._renderPage.bind(_this);
      return _this;
    }

    (0, _createClass3.default)(withPage, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.props.pagination.init) {
          this.props.setActivePage(1);
        }
        if (this.props.pagination.restart && this.props.pagination.returnRestart) {
          this.props.pagination.returnRestart();
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.tBodyObject.length !== 0 && nextProps.pagination) {
          var items = 0;
          if (nextProps.limit) {
            items = Math.ceil(nextProps.pagination.total / nextProps.activeLimit);
          } else if (nextProps.pagination.perPage && nextProps.pagination.total) {
            items = Math.ceil(nextProps.pagination.total / nextProps.pagination.perPage);
          }
          this.setState({
            items: items
          });
        }
        if (nextProps.pagination.restart && nextProps.pagination.returnRestart) {
          nextProps.setActivePage(1);
          nextProps.pagination.returnRestart();
        }
      }
    }, {
      key: 'handlerOnChange',
      value: function handlerOnChange(activePage) {
        if (activePage !== this.props.activePage) {
          this.props.setActivePage(activePage);
        }
      }
    }, {
      key: '_renderPage',
      value: function _renderPage() {
        if (this.props.pagination && !this.props.fetching && this.props.tBodyObject.length !== 0 && this.state.items !== 0) {
          return _react2.default.createElement(
            'nav',
            null,
            _react2.default.createElement(_reactBootstrap.Pagination, (0, _extends3.default)({}, this.props.pagination.configPagination, {
              items: this.state.items,
              activePage: this.props.activePage,
              onSelect: this.handlerOnChange
            }))
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, (0, _extends3.default)({
          _renderPage: this._renderPage
        }, this.props));
      }
    }]);
    return withPage;
  }(_react2.default.Component);

  withPage.defaultProps = {
    pagination: { init: false },
    tBodyObject: [],
    fetching: false
  };

  withPage.propTypes = {
    pagination: _propTypes2.default.object,
    tBodyObject: _propTypes2.default.array,
    fetching: _propTypes2.default.bool,
    activePage: _propTypes2.default.number,
    activeLimit: _propTypes2.default.number,
    setActivePage: _propTypes2.default.func,
    limit: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.object])
  };

  return withPage;
}