'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = withPrint;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _objectPath = require('object-path');

var _objectPath2 = _interopRequireDefault(_objectPath);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactPopout = require('react-popout');

var _reactPopout2 = _interopRequireDefault(_reactPopout);

var _reactDraggable = require('react-draggable');

var _reactDraggable2 = _interopRequireDefault(_reactDraggable);

var _reactCsv = require('react-csv');

var _jspdf = require('jspdf');

var _jspdf2 = _interopRequireDefault(_jspdf);

require('jspdf-autotable');

var _reactstrap = require('reactstrap');

require('react-bootstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withPrint(Component) {
  var withPrint = function (_React$Component) {
    (0, _inherits3.default)(withPrint, _React$Component);

    function withPrint(props) {
      (0, _classCallCheck3.default)(this, withPrint);

      var _this = (0, _possibleConstructorReturn3.default)(this, (withPrint.__proto__ || Object.getPrototypeOf(withPrint)).call(this, props));

      var tHead = [];
      for (var prop in props.tHead) {
        tHead.push({ key: prop, value: props.tHead[prop] });
      }

      _this.state = {
        tHead: tHead,
        popupWindow: false,
        popupWindowTitle: '',
        csv: { data: [], filename: '' },
        pdf: { data: '', filename: '' }
      };
      _this.handleColumnStart = _this.handleColumnStart.bind(_this);
      _this.handleColumnStop = _this.handleColumnStop.bind(_this);
      _this.handlePrintOpen = _this.handlePrintOpen.bind(_this);
      _this.handlePrintClose = _this.handlePrintClose.bind(_this);
      _this.handleGenerateCSV = _this.handleGenerateCSV.bind(_this);
      _this.handleGeneratePDF = _this.handleGeneratePDF.bind(_this);
      _this.tHeadGenerate = _this.tHeadGenerate.bind(_this);
      _this.tBodyGenerate = _this.tBodyGenerate.bind(_this);
      _this._renderResize = _this._renderResize.bind(_this);
      _this._renderTablePrint = _this._renderTablePrint.bind(_this);
      _this._renderTHEADprint = _this._renderTHEADprint.bind(_this);
      _this._renderTBODYprint = _this._renderTBODYprint.bind(_this);
      _this._renderLinesPrint = _this._renderLinesPrint.bind(_this);
      _this._renderPrint = _this._renderPrint.bind(_this);
      _this._renderPrintButton = _this._renderPrintButton.bind(_this);
      return _this;
    }

    (0, _createClass3.default)(withPrint, [{
      key: 'tHeadGenerate',
      value: function tHeadGenerate() {
        var _this2 = this;

        var tHead = [];
        this.state.tHead.map(function (vThead) {
          if (!_this2.props.columnsTagPrint || _this2.props.columnsTagPrint[vThead.key] === undefined || _this2.props.columnsTagPrint[vThead.key]) {
            tHead.push(vThead);
          }
          return vThead;
        });
        return tHead;
      }
    }, {
      key: 'tBodyGenerate',
      value: function tBodyGenerate(tHead) {
        var _this3 = this;

        var tBodys = [];
        this.props.tBodyObject.map(function (vTbody, tBodyK) {
          var tBody = [];
          tHead.map(function (vThead) {
            if (_this3.props.tBodyDefault[vThead.key] && (_objectPath2.default.get(vTbody, vThead.key) === undefined || _objectPath2.default.get(vTbody, vThead.key) === '')) {
              tBody.push(_this3.props.tBodyDefault[vThead.key]);
              return vThead;
            }
            var valueData = void 0;
            if (_this3.props.tBodyFormatCSV[vThead.key]) {
              valueData = _this3.props.tBodyFormatCSV[vThead.key](vTbody, tBodyK);
              tBody.push(valueData);
              return vThead;
            } else if (_this3.props.tBodyFormat[vThead.key]) {
              valueData = _this3.props.tBodyFormat[vThead.key](vTbody, tBodyK);
              if (typeof valueData === 'string') {
                tBody.push(valueData);
                return vThead;
              }
            }
            if (_objectPath2.default.get(vTbody, vThead.key) === true || _objectPath2.default.get(vTbody, vThead.key) === false) {
              valueData = _objectPath2.default.get(vTbody, vThead.key) === true ? 'SI' : 'NO';
              tBody.push(valueData);
              return vThead;
            }

            tBody.push(_objectPath2.default.get(vTbody, vThead.key));
            return vThead;
          });
          tBodys.push(tBody);
          return vTbody;
        });
        return tBodys;
      }
    }, {
      key: 'handleGeneratePDF',
      value: function handleGeneratePDF(childWindow) {
        var pdf = { data: '', filename: '' };
        var tHead = this.tHeadGenerate();
        var tBody = this.tBodyGenerate(tHead);
        tHead = tHead.map(function (v) {
          return v.value;
        });

        var doc = new _jspdf2.default('landscape', 'pt');
        var options = {
          theme: 'striped',
          styles: {
            overflow: 'linebreak'
          },
          headerStyles: {
            fillColor: [38, 50, 56]
          },
          margin: {
            top: 10,
            left: 10,
            right: 10,
            bottom: 10
          }
        };
        doc.setFontSize(12);
        doc.setFont('helvetica');
        doc.setTextColor(38, 50, 56);
        doc.autoTable(tHead, tBody, options);
        pdf.data = doc.output('dataurlstring');
        pdf.filename = this.state.popupWindowTitle + ' (' + (0, _moment2.default)().format('DD-MM-YYYY HH-mm') + 'hs).pdf';
        this.setState({
          pdf: pdf
        });
      }
    }, {
      key: 'handleGenerateCSV',
      value: function handleGenerateCSV() {
        var csv = { data: [], filename: '' };
        var tHead = this.tHeadGenerate();
        var tBody = this.tBodyGenerate(tHead);
        tHead = tHead.map(function (v) {
          return v.value;
        });
        csv.data.push(tHead);
        tBody.map(function (v) {
          csv.data.push(v);
          return v;
        });
        csv.filename = this.state.popupWindowTitle + ' (' + (0, _moment2.default)().format('DD-MM-YYYY HH-mm') + 'hs).csv';
        this.setState({
          csv: csv
        });
      }
    }, {
      key: 'handlePrintClose',
      value: function handlePrintClose() {
        this.setState({
          popupWindow: false
        });
      }
    }, {
      key: 'handlePrintOpen',
      value: function handlePrintOpen() {
        this.props.setColumnsTagPrint();
        var popupWindowTitle = 'REPORTE - ' + document.querySelector('head title').innerHTML;
        this.setState({
          popupWindowTitle: popupWindowTitle,
          popupWindow: true
        });
      }
    }, {
      key: 'handleColumnStart',
      value: function handleColumnStart(e) {
        this.position = e.pageX;
        this.element = e.currentTarget;
        if (this.element.parentNode.style.width === '') {
          this.element.parentNode.style.width = this.element.parentNode.clientWidth + 'px';
        }
      }
    }, {
      key: 'handleColumnStop',
      value: function handleColumnStop(e) {
        var withParent = this.element.parentNode.clientWidth;
        this.element.parentNode.style.width = withParent + e.pageX - this.position + 'px';
        this.element.style.right = parseInt(this.element.style.right.replace('px', ''), 10) + e.pageX - this.position + 'px';
        this.element = null;
      }
    }, {
      key: '_renderResize',
      value: function _renderResize() {
        return _react2.default.createElement(
          _reactDraggable2.default,
          {
            axis: 'x',
            onStart: this.handleColumnStart,
            onStop: this.handleColumnStop
          },
          _react2.default.createElement('div', {
            className: 'hidden-print',
            style: {
              position: 'absolute',
              right: 0,
              top: 0,
              height: 13,
              background: '#343a40',
              width: 3,
              cursor: 'col-resize'
            }
          })
        );
      }
    }, {
      key: '_renderTablePrint',
      value: function _renderTablePrint() {
        var _this4 = this;

        return _react2.default.createElement(
          'table',
          {
            ref: function ref(refTable) {
              _this4.refTable = refTable;
            },
            className: 'table table-hover table-md' + (this.props.striped ? 'table-striped ' : '') + (this.props.condensed ? 'table-condensed ' : '') + (this.props.bordered ? 'table-bordered ' : ''),
            style: { position: 'relative' }
          },
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              this.state.tHead.map(this._renderTHEADprint)
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            !this.props.fetching && this.props.tBodyObject.map(this._renderTBODYprint)
          ),
          _react2.default.createElement(
            'tfoot',
            null,
            _react2.default.createElement(
              'tr',
              null,
              this.props.fetching && _react2.default.createElement(
                'th',
                { colSpan: Object.keys(this.props.tHead).length + 1 },
                'Cargando ...'
              ),
              !this.props.fetching && this.props.tBodyObject.length === 0 && _react2.default.createElement(
                'th',
                { colSpan: Object.keys(this.props.tHead).length + 1 },
                this.props.txtSinResultados
              )
            )
          )
        );
      }
    }, {
      key: '_renderTHEADprint',
      value: function _renderTHEADprint(data, key) {
        if (!this.props.columnsTagPrint || this.props.columnsTagPrint[data.key] === undefined || this.props.columnsTagPrint[data.key]) {
          return _react2.default.createElement(
            'th',
            {
              key: key,
              style: this.props.tBodyStyle[data.key]
            },
            data.value,
            this.props.resize && this._renderResize()
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderTBODYprint',
      value: function _renderTBODYprint(data, key) {
        var _this5 = this;

        var tBody = [];
        this.state.tHead.map(function (v) {
          if (_this5.props.tBodyDefault[v.key] && (_objectPath2.default.get(data, v.key) === undefined || _objectPath2.default.get(data, v.key) === '')) {
            tBody.push({ key: v.key, value: _this5.props.tBodyDefault[v.key] });
            return v;
          }

          if (_this5.props.tBodyFormat[v.key]) {
            var valueData = _this5.props.tBodyFormat[v.key](data, key);
            tBody.push({ key: v.key, value: valueData });
            return v;
          }

          tBody.push({ key: v.key, value: _objectPath2.default.get(data, v.key) });
          return v;
        });

        return _react2.default.createElement(
          'tr',
          { key: key, className: this.props.tBodyStyleTR && this.props.tBodyStyleTR(data, key) },
          tBody.map(this._renderLinesPrint)
        );
      }
    }, {
      key: '_renderLinesPrint',
      value: function _renderLinesPrint(data, key) {
        if (!this.props.columnsTagPrint || this.props.columnsTagPrint[data.key] === undefined || this.props.columnsTagPrint[data.key]) {
          return _react2.default.createElement(
            'td',
            { key: key,
              style: this.props.tBodyStyle[data.key]
            },
            data.value
          );
        }
      }
    }, {
      key: '_renderPrintButton',
      value: function _renderPrintButton() {
        if (this.props.print && this.props.tBodyObject.length !== 0) {
          return _react2.default.createElement(
            'div',
            { style: { display: 'flex' } },
            !this.state.popupWindow && _react2.default.createElement(
              _reactstrap.Button,
              {
                style: { flex: 1 },
                color: 'success',
                onClick: this.handlePrintOpen
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'printer' }),
              ' Modo impresi\xF3n'
            ),
            this.state.popupWindow && _react2.default.createElement(
              _reactstrap.Button,
              {
                style: { flex: 1 },
                color: 'dark',
                onClick: this.handlePrintClose
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'close' }),
              ' Cerrar modo impresi\xF3n'
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderPrint',
      value: function _renderPrint() {
        var _this6 = this;

        if (this.state.popupWindow) {
          return _react2.default.createElement(
            _reactPopout2.default,
            {
              options: { width: '1200px', height: '600px' },
              title: this.state.popupWindowTitle,
              onClosing: this.handlePrintClose
            },
            function (childWindow) {
              return _react2.default.createElement(
                'wrapper',
                null,
                _react2.default.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/font-awesome.min.css',
                  crossOrigin: 'anonymous'
                }),
                _react2.default.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/simple-line-icons.css',
                  crossOrigin: 'anonymous'
                }),
                _react2.default.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/style.css',
                  crossOrigin: 'anonymous'
                }),
                _react2.default.createElement(
                  _reactstrap.Container,
                  { fluid: true, className: 'mt-h mb-h' },
                  _react2.default.createElement(
                    _reactstrap.Row,
                    { className: 'hidden-print mb-h' },
                    _react2.default.createElement(
                      _reactstrap.Col,
                      { className: 'col-12' },
                      _react2.default.createElement(
                        _reactstrap.Button,
                        {
                          color: 'success',
                          onClick: function onClick() {
                            return childWindow.print();
                          }
                        },
                        _react2.default.createElement(_Icon2.default, { bootstrap: 'printer' }),
                        ' Imprimir'
                      ),
                      ' \xA0',
                      _react2.default.createElement(
                        _reactstrap.Button,
                        {
                          style: { position: 'relative' },
                          color: 'success'
                        },
                        _react2.default.createElement(_Icon2.default, { awesome: 'file-excel-o' }),
                        ' Excel',
                        _react2.default.createElement(_reactCsv.CSVLink, {
                          style: {
                            position: 'absolute',
                            top: 0,
                            bottom: 0,
                            left: 0,
                            right: 0
                          },
                          data: _this6.state.csv.data,
                          filename: _this6.state.csv.filename,
                          onClick: _this6.handleGenerateCSV
                        })
                      ),
                      ' \xA0',
                      _react2.default.createElement(
                        _reactstrap.Button,
                        {
                          style: { position: 'relative' },
                          color: 'success'
                        },
                        _react2.default.createElement(_Icon2.default, { awesome: 'file-pdf-o' }),
                        ' PDF',
                        _react2.default.createElement('a', {
                          style: {
                            position: 'absolute',
                            top: 0,
                            bottom: 0,
                            left: 0,
                            right: 0
                          },
                          href: _this6.state.pdf.data,
                          download: _this6.state.pdf.filename,
                          onClick: function onClick() {
                            return _this6.handleGeneratePDF(childWindow);
                          }
                        })
                      )
                    )
                  ),
                  _this6.props._renderColumnsTagPrint(),
                  _react2.default.createElement(
                    _reactstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactstrap.Col,
                      { className: 'col-12' },
                      _this6._renderTablePrint()
                    )
                  ),
                  _react2.default.createElement(
                    _reactstrap.Row,
                    { className: 'hidden-print mt-q' },
                    _react2.default.createElement(
                      _reactstrap.Col,
                      { className: 'col-12' },
                      _this6.props._renderPageDetail()
                    )
                  )
                )
              );
            }
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, (0, _extends3.default)({
          _renderPrint: this._renderPrint,
          _renderPrintButton: this._renderPrintButton,
          popupWindow: this.state.popupWindow
        }, this.props, {
          tHead: this.state.tHead
        }));
      }
    }]);
    return withPrint;
  }(_react2.default.Component);

  withPrint.defaultProps = {
    tBodyStyle: {},
    tBodyDefault: {},
    tBodyFormat: {},
    tBodyFormatCSV: {}
  };

  withPrint.propTypes = {
    // withColumnsTag
    _renderColumnsTagPrint: _propTypes2.default.func,
    columnsTagPrint: _propTypes2.default.object,
    setColumnsTagPrint: _propTypes2.default.func,
    // withPageDetail
    _renderPageDetail: _propTypes2.default.func,

    resize: _propTypes2.default.bool,
    tHead: _propTypes2.default.object,
    striped: _propTypes2.default.bool,
    condensed: _propTypes2.default.bool,
    bordered: _propTypes2.default.bool,
    tBodyObject: _propTypes2.default.array,
    tBodyDefault: _propTypes2.default.object,
    tBodyFormat: _propTypes2.default.object,
    tBodyFormatCSV: _propTypes2.default.object,
    tBodyStyle: _propTypes2.default.object,
    tBodyStyleTR: _propTypes2.default.func,
    fetching: _propTypes2.default.bool,
    txtSinResultados: _propTypes2.default.string,
    print: _propTypes2.default.bool
  };

  return withPrint;
}