'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ramda = require('ramda');

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableCard = function (_Component) {
  (0, _inherits3.default)(TableCard, _Component);

  function TableCard(props) {
    (0, _classCallCheck3.default)(this, TableCard);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TableCard.__proto__ || Object.getPrototypeOf(TableCard)).call(this, props));

    _this.state = {
      rows: [],
      datalist: [],
      dropdownOpen: {},
      collapseOpen: {},
      cardView: { active: 1, size: 3 },
      menu: []
    };
    _this.toggleCollapse = _this.toggleCollapse.bind(_this);
    _this.toggleDropdown = _this.toggleDropdown.bind(_this);
    _this.handlerChangeCardView = _this.handlerChangeCardView.bind(_this);
    _this.calculoRows = _this.calculoRows.bind(_this);
    _this._renderDropdownItems = _this._renderDropdownItems.bind(_this);
    _this._renderRow = _this._renderRow.bind(_this);
    _this._renderCard = _this._renderCard.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(TableCard, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.datalist.length !== 0 && nextProps.datalist.length !== this.state.datalist.length) {
        var menu = [];
        var countMenuEnabled = 0;
        nextProps.datalist.map(function (value, key) {
          if (nextProps.menu && nextProps.menu.length !== 0) {
            nextProps.menu.map(function (m1, k1) {
              if (typeof m1 === 'function') {
                m1 = m1(value);
                if (Array.isArray(m1)) {
                  m1.map(function (m2, k2) {
                    if (m2.enabled || m2.enabled(value)) {
                      menu.push(m2);
                    }

                    if ((m2.enabled || m2.enabled(value)) && !m2.header) {
                      countMenuEnabled++;
                    }

                    return m2;
                  });
                } else {
                  if (m1.enabled || m1.enabled(value)) {
                    menu.push(m1);
                  }

                  if ((m1.enabled || m1.enabled(value)) && !m1.header) {
                    countMenuEnabled++;
                  }
                }
              } else {
                if (m1.enabled || m1.enabled(value)) {
                  menu.push(m1);
                }
                if ((m1.enabled || m1.enabled(value)) && !m1.header) {
                  countMenuEnabled++;
                }
              }
              return m1;
            });
          }
          return value;
        });

        if (!countMenuEnabled) {
          menu = [];
        }
        this.setState({
          menu: menu
        }, function () {
          _this2.calculoRows(nextProps.datalist);
        });
      }
      if (nextProps.fetching && this.state.datalist.length !== 0) {
        this.setState({
          rows: [],
          datalist: []
        });
      }
    }
  }, {
    key: 'toggleCollapse',
    value: function toggleCollapse(key) {
      this.setState({
        collapseOpen: (0, _ramda.merge)(this.state.collapseOpen, (0, _defineProperty3.default)({}, key, !this.state.collapseOpen[key]))
      });
    }
  }, {
    key: 'toggleDropdown',
    value: function toggleDropdown(key) {
      this.setState({
        dropdownOpen: (0, _ramda.merge)(this.state.dropdownOpen, (0, _defineProperty3.default)({}, key, !this.state.dropdownOpen[key]))
      });
    }
  }, {
    key: 'handlerChangeCardView',
    value: function handlerChangeCardView(cardView) {
      var _this3 = this;

      this.setState({ cardView: cardView }, function () {
        _this3.calculoRows(_this3.props.datalist);
      });
    }
  }, {
    key: 'calculoRows',
    value: function calculoRows(data) {
      var rows = [];
      var datalist = [];
      var perRow = void 0;
      if (this.props.size) {
        perRow = 12 / parseInt(this.props.size, 10);
      } else {
        perRow = 12 / parseInt(this.state.cardView.size, 10);
      }
      var count = 0;
      data.map(function (val, key) {
        if (key === 0) {
          rows.push('row');
        }

        if (count === 0) {
          datalist.push([]);
        }

        count++;
        if (perRow >= count) {
          datalist[datalist.length - 1].push(val);
        }

        if (perRow <= count) {
          if (data.length - 1 !== key) {
            rows.push('row');
          }
          count = 0;
        }
        return val;
      });
      this.setState({
        rows: rows,
        datalist: datalist
      });
    }
  }, {
    key: '_renderDropdownItems',
    value: function _renderDropdownItems(m, k, c) {
      if (typeof m === 'function') {
        m = m(c);
        if (Array.isArray(m)) {
          var opciones = [];
          m.map(function (menu, key) {
            if (menu.enabled === undefined || typeof menu.enabled === 'boolean' && menu.enabled === false || typeof menu.enabled === 'function' && !menu.enabled(c)) {
              return false;
            }

            opciones.push(_react2.default.createElement(
              _reactstrap.DropdownItem,
              {
                key: k + '' + key,
                header: menu.header,
                divider: menu.divider,
                disabled: menu.disabled,
                style: { cursor: 'pointer' },
                onClick: function onClick() {
                  return menu.onClick(c);
                }
              },
              typeof menu.label === 'function' ? menu.label(c) : menu.label ? menu.label : 'Falta el label'
            ));
            return menu;
          });
          return opciones;
        }
      }
      if (m.enabled === undefined || typeof m.enabled === 'boolean' && m.enabled === false || typeof m.enabled === 'function' && !m.enabled(c)) {
        return false;
      }
      return _react2.default.createElement(
        _reactstrap.DropdownItem,
        {
          key: k,
          header: m.header,
          divider: m.divider,
          disabled: m.disabled,
          style: { cursor: 'pointer' },
          onClick: function onClick() {
            return m.onClick(c);
          }
        },
        typeof m.label === 'function' ? m.label(c) : m.label ? m.label : 'Falta el label'
      );
    }
  }, {
    key: '_renderRow',
    value: function _renderRow(r, kr) {
      var _this4 = this;

      return _react2.default.createElement(
        _reactstrap.Row,
        { key: kr },
        this.state.datalist[kr].map(function (c, kc) {
          return _this4._renderCard(c, kc, kr);
        })
      );
    }
  }, {
    key: '_renderCard',
    value: function _renderCard(c, kc, kr) {
      var _this5 = this;

      return _react2.default.createElement(
        _reactstrap.Col,
        {
          key: kr + '' + kc,
          className: 'col-12'
          // lg={this.props.size}
          , style: { transition: '.3s all ease-in-out' },
          lg: this.state.cardView.size
        },
        _react2.default.createElement(
          'div',
          { className: 'card ' + (typeof this.props.color === 'string' ? 'card-inverse card-' + this.props.color : '') + (typeof this.props.color === 'function' ? this.props.color(c) : '')
          },
          _react2.default.createElement(
            'div',
            { className: 'card-block' },
            (this.props.icon || this.state.menu.length !== 0) && _react2.default.createElement(
              'div',
              { className: 'h1 text-muted text-right mb-2' },
              this.state.menu.length !== 0 && _react2.default.createElement(
                _reactstrap.Dropdown,
                { isOpen: this.state.dropdownOpen[kr + '' + kc], toggle: function toggle() {
                    return _this5.toggleDropdown(kr + '' + kc);
                  } },
                _react2.default.createElement(
                  _reactstrap.DropdownToggle,
                  { style: { float: 'left', fontSize: 20, cursor: 'pointer', left: -5, position: 'relative' }, tag: 'span' },
                  _react2.default.createElement(_Icon2.default, { bootstrap: 'options-vertical' })
                ),
                _react2.default.createElement(
                  _reactstrap.DropdownMenu,
                  { style: { top: 30 } },
                  this.props.menu.map(function (m, k) {
                    return _this5._renderDropdownItems(m, k, c);
                  })
                )
              ),
              this.props.icon && (0, _typeof3.default)(this.props.icon) === 'object' && _react2.default.createElement(_Icon2.default, this.props.icon),
              this.props.icon && typeof this.props.icon === 'function' && this.props.icon(c)
            ),
            this.props.body && this.props.body(c),
            this.props.titulo && typeof this.props.titulo === 'string' && !this.props.body && _react2.default.createElement(
              'div',
              { className: 'h4 mb-0',
                style: {
                  textOverflow: 'ellipsis',
                  overflow: 'hidden'
                }
              },
              this.props.titulo
            ),
            this.props.titulo && typeof this.props.titulo === 'function' && !this.props.body && _react2.default.createElement(
              'div',
              { className: 'h4 mb-0',
                style: {
                  textOverflow: 'ellipsis',
                  overflow: 'hidden'
                }
              },
              this.props.titulo(c)
            ),
            this.props.subtitulo && typeof this.props.subtitulo === 'string' && !this.props.body && _react2.default.createElement(
              'small',
              { className: 'text-muted text-uppercase font-weight-bold' },
              this.props.subtitulo
            ),
            this.props.subtitulo && typeof this.props.subtitulo === 'function' && !this.props.body && _react2.default.createElement(
              'small',
              { className: 'text-muted text-uppercase font-weight-bold' },
              this.props.subtitulo(c)
            ),
            this.props.progressBar && this.props.progressBar(c),
            this.props.verMas && this.props.verMas.enabled !== undefined && (typeof this.props.verMas.enabled === 'boolean' && this.props.verMas.enabled || typeof this.props.verMas.enabled === 'function' && this.props.verMas.enabled(c)) && _react2.default.createElement(
              'wrapper',
              { style: { marginTop: 7, display: 'block' } },
              _react2.default.createElement(
                _reactstrap.Button,
                {
                  block: true,
                  size: 'sm',
                  color: (typeof this.props.verMas.btnColor === 'string' ? this.props.verMas.btnColor : '') + (typeof this.props.verMas.btnColor === 'function' ? this.props.verMas.btnColor(c) : ''),
                  onClick: function onClick() {
                    return _this5.toggleCollapse(kr + '' + kc);
                  }
                },
                _react2.default.createElement(_Icon2.default, { awesome: this.state.collapseOpen[kr + '' + kc] ? 'chevron-up' : 'chevron-down' })
              ),
              _react2.default.createElement(
                _reactstrap.Collapse,
                { isOpen: this.state.collapseOpen[kr + '' + kc] },
                this.props.verMas.body && _react2.default.createElement(
                  'div',
                  { className: 'card-block row' },
                  this.props.verMas.body(c)
                ),
                this.props.verMas.footer && _react2.default.createElement(
                  'div',
                  { className: 'card-footer' },
                  this.props.verMas.footer(c)
                )
              )
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return _react2.default.createElement(
        'wrapper',
        null,
        !this.props.size && _react2.default.createElement(
          _reactstrap.ButtonGroup,
          null,
          _react2.default.createElement(
            _reactstrap.Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 1, size: 3 });
              },
              active: this.state.cardView.active === 1
            },
            _react2.default.createElement(_Icon2.default, { awesome: 'th' })
          ),
          _react2.default.createElement(
            _reactstrap.Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 2, size: 6 });
              },
              active: this.state.cardView.active === 2
            },
            _react2.default.createElement(_Icon2.default, { awesome: 'th-large' })
          ),
          _react2.default.createElement(
            _reactstrap.Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 3, size: 12 });
              },
              active: this.state.cardView.active === 3
            },
            _react2.default.createElement(_Icon2.default, { awesome: 'th-list' })
          )
        ),
        !this.props.size && _react2.default.createElement('hr', null),
        !this.props.fetching && this.state.rows.map(this._renderRow),
        !this.props.fetching && this.props.datalist.length === 0 && _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(
            'strong',
            null,
            this.props.txtSinResultados
          )
        ),
        this.props.fetching && _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(
            'strong',
            null,
            'Cargando ...'
          )
        )
      );
    }
  }]);
  return TableCard;
}(_react.Component);

TableCard.defaultProps = {
  datalist: [],
  menu: []
};

TableCard.propTypes = {
  size: _propTypes2.default.string,
  datalist: _propTypes2.default.array,
  menu: _propTypes2.default.array,
  icon: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object]),
  color: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  titulo: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  subtitulo: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  body: _propTypes2.default.func,
  progressBar: _propTypes2.default.func,
  verMas: _propTypes2.default.object,
  txtSinResultados: _propTypes2.default.string,
  fetching: _propTypes2.default.bool
};

exports.default = TableCard;