import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Alert, Badge, Button, ButtonGroup, Col, Collapse, Container, Dropdown, DropdownItem, DropdownMenu, DropdownToggle, FormFeedback, FormGroup, Input, InputGroup, InputGroupAddon, InputGroupButton, Jumbotron, Label, Modal, ModalBody, ModalFooter, ModalHeader, Nav, NavItem, NavLink, Navbar, Row, TabContent, TabPane } from 'reactstrap';
import { Link } from 'react-router-dom';
import classnames from 'classnames';
import { OverlayTrigger, Pagination, Tooltip } from 'react-bootstrap';
import deepcopy from 'deepcopy';
import moment from 'moment';
import DayPicker from 'react-day-picker';
import { merge } from 'ramda';
import objectPath from 'object-path';
import PopoutWindow from 'react-popout';
import Draggable from 'react-draggable';
import { CSVLink } from 'react-csv';
import JsPDF from 'jspdf';
import 'jspdf-autotable';
import { Sticky, StickyContainer } from 'react-sticky';
import InputMask from 'react-input-mask';
import Dropzone from 'react-dropzone';
import deepEqual from 'deep-equal';
import Alert$1 from 'react-s-alert';
import ReactDOM from 'react-dom';
import { Motion, spring } from 'react-motion';
import Interactive from 'react-interactive';
import ScrollToTop from 'react-scroll-up';

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classCallCheck = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;

exports.default = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};
});

var _classCallCheck = unwrapExports(classCallCheck);

var _global = createCommonjsModule(function (module) {
// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global = module.exports = typeof window != 'undefined' && window.Math == Math
  ? window : typeof self != 'undefined' && self.Math == Math ? self
  // eslint-disable-next-line no-new-func
  : Function('return this')();
if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef
});

var _core = createCommonjsModule(function (module) {
var core = module.exports = { version: '2.5.3' };
if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef
});

var _aFunction = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};

// optional / simple context binding

var _ctx = function (fn, that, length) {
  _aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};

var _isObject = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};

var _anObject = function (it) {
  if (!_isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};

var _fails = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};

// Thank's IE8 for his funny defineProperty
var _descriptors = !_fails(function () {
  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
});

var document$1 = _global.document;
// typeof document.createElement is 'object' in old IE
var is = _isObject(document$1) && _isObject(document$1.createElement);
var _domCreate = function (it) {
  return is ? document$1.createElement(it) : {};
};

var _ie8DomDefine = !_descriptors && !_fails(function () {
  return Object.defineProperty(_domCreate('div'), 'a', { get: function () { return 7; } }).a != 7;
});

// 7.1.1 ToPrimitive(input [, PreferredType])

// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
var _toPrimitive = function (it, S) {
  if (!_isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !_isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};

var dP = Object.defineProperty;

var f = _descriptors ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  _anObject(O);
  P = _toPrimitive(P, true);
  _anObject(Attributes);
  if (_ie8DomDefine) try {
    return dP(O, P, Attributes);
  } catch (e) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};

var _objectDp = {
	f: f
};

var _propertyDesc = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};

var _hide = _descriptors ? function (object, key, value) {
  return _objectDp.f(object, key, _propertyDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};

var PROTOTYPE = 'prototype';

var $export = function (type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var IS_WRAP = type & $export.W;
  var exports = IS_GLOBAL ? _core : _core[name] || (_core[name] = {});
  var expProto = exports[PROTOTYPE];
  var target = IS_GLOBAL ? _global : IS_STATIC ? _global[name] : (_global[name] || {})[PROTOTYPE];
  var key, own, out;
  if (IS_GLOBAL) source = name;
  for (key in source) {
    // contains in native
    own = !IS_FORCED && target && target[key] !== undefined;
    if (own && key in exports) continue;
    // export native or passed
    out = own ? target[key] : source[key];
    // prevent global pollution for namespaces
    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
    // bind timers to global for call from export context
    : IS_BIND && own ? _ctx(out, _global)
    // wrap global constructors for prevent change them in library
    : IS_WRAP && target[key] == out ? (function (C) {
      var F = function (a, b, c) {
        if (this instanceof C) {
          switch (arguments.length) {
            case 0: return new C();
            case 1: return new C(a);
            case 2: return new C(a, b);
          } return new C(a, b, c);
        } return C.apply(this, arguments);
      };
      F[PROTOTYPE] = C[PROTOTYPE];
      return F;
    // make static versions for prototype methods
    })(out) : IS_PROTO && typeof out == 'function' ? _ctx(Function.call, out) : out;
    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
    if (IS_PROTO) {
      (exports.virtual || (exports.virtual = {}))[key] = out;
      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
      if (type & $export.R && expProto && !expProto[key]) _hide(expProto, key, out);
    }
  }
};
// type bitmap
$export.F = 1;   // forced
$export.G = 2;   // global
$export.S = 4;   // static
$export.P = 8;   // proto
$export.B = 16;  // bind
$export.W = 32;  // wrap
$export.U = 64;  // safe
$export.R = 128; // real proto method for `library`
var _export = $export;

// 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
_export(_export.S + _export.F * !_descriptors, 'Object', { defineProperty: _objectDp.f });

var $Object = _core.Object;
var defineProperty$2 = function defineProperty(it, key, desc) {
  return $Object.defineProperty(it, key, desc);
};

var defineProperty = createCommonjsModule(function (module) {
module.exports = { "default": defineProperty$2, __esModule: true };
});

unwrapExports(defineProperty);

var createClass = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _defineProperty2 = _interopRequireDefault(defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      (0, _defineProperty2.default)(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();
});

var _createClass = unwrapExports(createClass);

// 7.1.4 ToInteger
var ceil = Math.ceil;
var floor = Math.floor;
var _toInteger = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};

// 7.2.1 RequireObjectCoercible(argument)
var _defined = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};

// true  -> String#at
// false -> String#codePointAt
var _stringAt = function (TO_STRING) {
  return function (that, pos) {
    var s = String(_defined(that));
    var i = _toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
      ? TO_STRING ? s.charAt(i) : a
      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};

var _library = true;

var _redefine = _hide;

var hasOwnProperty = {}.hasOwnProperty;
var _has = function (it, key) {
  return hasOwnProperty.call(it, key);
};

var _iterators = {};

var toString = {}.toString;

var _cof = function (it) {
  return toString.call(it).slice(8, -1);
};

// fallback for non-array-like ES3 and non-enumerable old V8 strings

// eslint-disable-next-line no-prototype-builtins
var _iobject = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return _cof(it) == 'String' ? it.split('') : Object(it);
};

// to indexed object, toObject with fallback for non-array-like ES3 strings


var _toIobject = function (it) {
  return _iobject(_defined(it));
};

// 7.1.15 ToLength

var min = Math.min;
var _toLength = function (it) {
  return it > 0 ? min(_toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
};

var max = Math.max;
var min$1 = Math.min;
var _toAbsoluteIndex = function (index, length) {
  index = _toInteger(index);
  return index < 0 ? max(index + length, 0) : min$1(index, length);
};

// false -> Array#indexOf
// true  -> Array#includes



var _arrayIncludes = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = _toIobject($this);
    var length = _toLength(O.length);
    var index = _toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
      if (O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};

var SHARED = '__core-js_shared__';
var store = _global[SHARED] || (_global[SHARED] = {});
var _shared = function (key) {
  return store[key] || (store[key] = {});
};

var id = 0;
var px = Math.random();
var _uid = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};

var shared = _shared('keys');

var _sharedKey = function (key) {
  return shared[key] || (shared[key] = _uid(key));
};

var arrayIndexOf = _arrayIncludes(false);
var IE_PROTO$1 = _sharedKey('IE_PROTO');

var _objectKeysInternal = function (object, names) {
  var O = _toIobject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) if (key != IE_PROTO$1) _has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (_has(O, key = names[i++])) {
    ~arrayIndexOf(result, key) || result.push(key);
  }
  return result;
};

// IE 8- don't enum bug keys
var _enumBugKeys = (
  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
).split(',');

// 19.1.2.14 / 15.2.3.14 Object.keys(O)



var _objectKeys = Object.keys || function keys(O) {
  return _objectKeysInternal(O, _enumBugKeys);
};

var _objectDps = _descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
  _anObject(O);
  var keys = _objectKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;
  while (length > i) _objectDp.f(O, P = keys[i++], Properties[P]);
  return O;
};

var document$2 = _global.document;
var _html = document$2 && document$2.documentElement;

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])



var IE_PROTO = _sharedKey('IE_PROTO');
var Empty = function () { /* empty */ };
var PROTOTYPE$1 = 'prototype';

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var createDict = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = _domCreate('iframe');
  var i = _enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';
  _html.appendChild(iframe);
  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
  // createDict = iframe.contentWindow.Object;
  // html.removeChild(iframe);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  createDict = iframeDocument.F;
  while (i--) delete createDict[PROTOTYPE$1][_enumBugKeys[i]];
  return createDict();
};

var _objectCreate = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    Empty[PROTOTYPE$1] = _anObject(O);
    result = new Empty();
    Empty[PROTOTYPE$1] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = createDict();
  return Properties === undefined ? result : _objectDps(result, Properties);
};

var _wks = createCommonjsModule(function (module) {
var store = _shared('wks');

var Symbol = _global.Symbol;
var USE_SYMBOL = typeof Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] =
    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : _uid)('Symbol.' + name));
};

$exports.store = store;
});

var def = _objectDp.f;

var TAG = _wks('toStringTag');

var _setToStringTag = function (it, tag, stat) {
  if (it && !_has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
};

var IteratorPrototype = {};

// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
_hide(IteratorPrototype, _wks('iterator'), function () { return this; });

var _iterCreate = function (Constructor, NAME, next) {
  Constructor.prototype = _objectCreate(IteratorPrototype, { next: _propertyDesc(1, next) });
  _setToStringTag(Constructor, NAME + ' Iterator');
};

// 7.1.13 ToObject(argument)

var _toObject = function (it) {
  return Object(_defined(it));
};

// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)


var IE_PROTO$2 = _sharedKey('IE_PROTO');
var ObjectProto = Object.prototype;

var _objectGpo = Object.getPrototypeOf || function (O) {
  O = _toObject(O);
  if (_has(O, IE_PROTO$2)) return O[IE_PROTO$2];
  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  } return O instanceof Object ? ObjectProto : null;
};

var ITERATOR = _wks('iterator');
var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function () { return this; };

var _iterDefine = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  _iterCreate(Constructor, NAME, next);
  var getMethod = function (kind) {
    if (!BUGGY && kind in proto) return proto[kind];
    switch (kind) {
      case KEYS: return function keys() { return new Constructor(this, kind); };
      case VALUES: return function values() { return new Constructor(this, kind); };
    } return function entries() { return new Constructor(this, kind); };
  };
  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = (!BUGGY && $native) || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;
  // Fix native
  if ($anyNative) {
    IteratorPrototype = _objectGpo($anyNative.call(new Base()));
    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      // Set @@toStringTag to native iterators
      _setToStringTag(IteratorPrototype, TAG, true);
      // fix for some old engines
      if (!_library && !_has(IteratorPrototype, ITERATOR)) _hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }
  // fix Array#{values, @@iterator}.name in V8 / FF
  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;
    $default = function values() { return $native.call(this); };
  }
  // Define iterator
  if ((!_library || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    _hide(proto, ITERATOR, $default);
  }
  // Plug for library
  _iterators[NAME] = $default;
  _iterators[TAG] = returnThis;
  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) _redefine(proto, key, methods[key]);
    } else _export(_export.P + _export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }
  return methods;
};

var $at = _stringAt(true);

// 21.1.3.27 String.prototype[@@iterator]()
_iterDefine(String, 'String', function (iterated) {
  this._t = String(iterated); // target
  this._i = 0;                // next index
// 21.1.5.2.1 %StringIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return { value: undefined, done: true };
  point = $at(O, index);
  this._i += point.length;
  return { value: point, done: false };
});

var _addToUnscopables = function () { /* empty */ };

var _iterStep = function (done, value) {
  return { value: value, done: !!done };
};

// 22.1.3.4 Array.prototype.entries()
// 22.1.3.13 Array.prototype.keys()
// 22.1.3.29 Array.prototype.values()
// 22.1.3.30 Array.prototype[@@iterator]()
var es6_array_iterator = _iterDefine(Array, 'Array', function (iterated, kind) {
  this._t = _toIobject(iterated); // target
  this._i = 0;                   // next index
  this._k = kind;                // kind
// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;
  if (!O || index >= O.length) {
    this._t = undefined;
    return _iterStep(1);
  }
  if (kind == 'keys') return _iterStep(0, index);
  if (kind == 'values') return _iterStep(0, O[index]);
  return _iterStep(0, [index, O[index]]);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
_iterators.Arguments = _iterators.Array;

_addToUnscopables('keys');
_addToUnscopables('values');
_addToUnscopables('entries');

var TO_STRING_TAG = _wks('toStringTag');

var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
  'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
  'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
  'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
  'TextTrackList,TouchList').split(',');

for (var i = 0; i < DOMIterables.length; i++) {
  var NAME = DOMIterables[i];
  var Collection = _global[NAME];
  var proto = Collection && Collection.prototype;
  if (proto && !proto[TO_STRING_TAG]) _hide(proto, TO_STRING_TAG, NAME);
  _iterators[NAME] = _iterators.Array;
}

var f$1 = _wks;

var _wksExt = {
	f: f$1
};

var iterator$2 = _wksExt.f('iterator');

var iterator = createCommonjsModule(function (module) {
module.exports = { "default": iterator$2, __esModule: true };
});

unwrapExports(iterator);

var _meta = createCommonjsModule(function (module) {
var META = _uid('meta');


var setDesc = _objectDp.f;
var id = 0;
var isExtensible = Object.isExtensible || function () {
  return true;
};
var FREEZE = !_fails(function () {
  return isExtensible(Object.preventExtensions({}));
});
var setMeta = function (it) {
  setDesc(it, META, { value: {
    i: 'O' + ++id, // object ID
    w: {}          // weak collections IDs
  } });
};
var fastKey = function (it, create) {
  // return primitive with prefix
  if (!_isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
  if (!_has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return 'F';
    // not necessary to add metadata
    if (!create) return 'E';
    // add missing metadata
    setMeta(it);
  // return object ID
  } return it[META].i;
};
var getWeak = function (it, create) {
  if (!_has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return true;
    // not necessary to add metadata
    if (!create) return false;
    // add missing metadata
    setMeta(it);
  // return hash weak collections IDs
  } return it[META].w;
};
// add metadata on freeze-family methods calling
var onFreeze = function (it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !_has(it, META)) setMeta(it);
  return it;
};
var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};
});

var defineProperty$4 = _objectDp.f;
var _wksDefine = function (name) {
  var $Symbol = _core.Symbol || (_core.Symbol = _library ? {} : _global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty$4($Symbol, name, { value: _wksExt.f(name) });
};

var f$2 = Object.getOwnPropertySymbols;

var _objectGops = {
	f: f$2
};

var f$3 = {}.propertyIsEnumerable;

var _objectPie = {
	f: f$3
};

// all enumerable object keys, includes symbols



var _enumKeys = function (it) {
  var result = _objectKeys(it);
  var getSymbols = _objectGops.f;
  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = _objectPie.f;
    var i = 0;
    var key;
    while (symbols.length > i) if (isEnum.call(it, key = symbols[i++])) result.push(key);
  } return result;
};

// 7.2.2 IsArray(argument)

var _isArray = Array.isArray || function isArray(arg) {
  return _cof(arg) == 'Array';
};

// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)

var hiddenKeys = _enumBugKeys.concat('length', 'prototype');

var f$5 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return _objectKeysInternal(O, hiddenKeys);
};

var _objectGopn = {
	f: f$5
};

// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window

var gOPN$1 = _objectGopn.f;
var toString$1 = {}.toString;

var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
  ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function (it) {
  try {
    return gOPN$1(it);
  } catch (e) {
    return windowNames.slice();
  }
};

var f$4 = function getOwnPropertyNames(it) {
  return windowNames && toString$1.call(it) == '[object Window]' ? getWindowNames(it) : gOPN$1(_toIobject(it));
};

var _objectGopnExt = {
	f: f$4
};

var gOPD$1 = Object.getOwnPropertyDescriptor;

var f$6 = _descriptors ? gOPD$1 : function getOwnPropertyDescriptor(O, P) {
  O = _toIobject(O);
  P = _toPrimitive(P, true);
  if (_ie8DomDefine) try {
    return gOPD$1(O, P);
  } catch (e) { /* empty */ }
  if (_has(O, P)) return _propertyDesc(!_objectPie.f.call(O, P), O[P]);
};

var _objectGopd = {
	f: f$6
};

// ECMAScript 6 symbols shim





var META = _meta.KEY;



















var gOPD = _objectGopd.f;
var dP$1 = _objectDp.f;
var gOPN = _objectGopnExt.f;
var $Symbol = _global.Symbol;
var $JSON = _global.JSON;
var _stringify = $JSON && $JSON.stringify;
var PROTOTYPE$2 = 'prototype';
var HIDDEN = _wks('_hidden');
var TO_PRIMITIVE = _wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = _shared('symbol-registry');
var AllSymbols = _shared('symbols');
var OPSymbols = _shared('op-symbols');
var ObjectProto$1 = Object[PROTOTYPE$2];
var USE_NATIVE = typeof $Symbol == 'function';
var QObject = _global.QObject;
// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
var setter = !QObject || !QObject[PROTOTYPE$2] || !QObject[PROTOTYPE$2].findChild;

// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
var setSymbolDesc = _descriptors && _fails(function () {
  return _objectCreate(dP$1({}, 'a', {
    get: function () { return dP$1(this, 'a', { value: 7 }).a; }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto$1, key);
  if (protoDesc) delete ObjectProto$1[key];
  dP$1(it, key, D);
  if (protoDesc && it !== ObjectProto$1) dP$1(ObjectProto$1, key, protoDesc);
} : dP$1;

var wrap = function (tag) {
  var sym = AllSymbols[tag] = _objectCreate($Symbol[PROTOTYPE$2]);
  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function (it) {
  return typeof it == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto$1) $defineProperty(OPSymbols, key, D);
  _anObject(it);
  key = _toPrimitive(key, true);
  _anObject(D);
  if (_has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!_has(it, HIDDEN)) dP$1(it, HIDDEN, _propertyDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (_has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _objectCreate(D, { enumerable: _propertyDesc(0, false) });
    } return setSymbolDesc(it, key, D);
  } return dP$1(it, key, D);
};
var $defineProperties = function defineProperties(it, P) {
  _anObject(it);
  var keys = _enumKeys(P = _toIobject(P));
  var i = 0;
  var l = keys.length;
  var key;
  while (l > i) $defineProperty(it, key = keys[i++], P[key]);
  return it;
};
var $create = function create(it, P) {
  return P === undefined ? _objectCreate(it) : $defineProperties(_objectCreate(it), P);
};
var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = _toPrimitive(key, true));
  if (this === ObjectProto$1 && _has(AllSymbols, key) && !_has(OPSymbols, key)) return false;
  return E || !_has(this, key) || !_has(AllSymbols, key) || _has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};
var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = _toIobject(it);
  key = _toPrimitive(key, true);
  if (it === ObjectProto$1 && _has(AllSymbols, key) && !_has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && _has(AllSymbols, key) && !(_has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};
var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(_toIobject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (!_has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  } return result;
};
var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto$1;
  var names = gOPN(IS_OP ? OPSymbols : _toIobject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (_has(AllSymbols, key = names[i++]) && (IS_OP ? _has(ObjectProto$1, key) : true)) result.push(AllSymbols[key]);
  } return result;
};

// 19.4.1.1 Symbol([description])
if (!USE_NATIVE) {
  $Symbol = function Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = _uid(arguments.length > 0 ? arguments[0] : undefined);
    var $set = function (value) {
      if (this === ObjectProto$1) $set.call(OPSymbols, value);
      if (_has(this, HIDDEN) && _has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, _propertyDesc(1, value));
    };
    if (_descriptors && setter) setSymbolDesc(ObjectProto$1, tag, { configurable: true, set: $set });
    return wrap(tag);
  };
  _redefine($Symbol[PROTOTYPE$2], 'toString', function toString() {
    return this._k;
  });

  _objectGopd.f = $getOwnPropertyDescriptor;
  _objectDp.f = $defineProperty;
  _objectGopn.f = _objectGopnExt.f = $getOwnPropertyNames;
  _objectPie.f = $propertyIsEnumerable;
  _objectGops.f = $getOwnPropertySymbols;

  if (_descriptors && !_library) {
    _redefine(ObjectProto$1, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  _wksExt.f = function (name) {
    return wrap(_wks(name));
  };
}

_export(_export.G + _export.W + _export.F * !USE_NATIVE, { Symbol: $Symbol });

for (var es6Symbols = (
  // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
  'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
).split(','), j = 0; es6Symbols.length > j;)_wks(es6Symbols[j++]);

for (var wellKnownSymbols = _objectKeys(_wks.store), k = 0; wellKnownSymbols.length > k;) _wksDefine(wellKnownSymbols[k++]);

_export(_export.S + _export.F * !USE_NATIVE, 'Symbol', {
  // 19.4.2.1 Symbol.for(key)
  'for': function (key) {
    return _has(SymbolRegistry, key += '')
      ? SymbolRegistry[key]
      : SymbolRegistry[key] = $Symbol(key);
  },
  // 19.4.2.5 Symbol.keyFor(sym)
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');
    for (var key in SymbolRegistry) if (SymbolRegistry[key] === sym) return key;
  },
  useSetter: function () { setter = true; },
  useSimple: function () { setter = false; }
});

_export(_export.S + _export.F * !USE_NATIVE, 'Object', {
  // 19.1.2.2 Object.create(O [, Properties])
  create: $create,
  // 19.1.2.4 Object.defineProperty(O, P, Attributes)
  defineProperty: $defineProperty,
  // 19.1.2.3 Object.defineProperties(O, Properties)
  defineProperties: $defineProperties,
  // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  // 19.1.2.7 Object.getOwnPropertyNames(O)
  getOwnPropertyNames: $getOwnPropertyNames,
  // 19.1.2.8 Object.getOwnPropertySymbols(O)
  getOwnPropertySymbols: $getOwnPropertySymbols
});

// 24.3.2 JSON.stringify(value [, replacer [, space]])
$JSON && _export(_export.S + _export.F * (!USE_NATIVE || _fails(function () {
  var S = $Symbol();
  // MS Edge converts symbol values to JSON as {}
  // WebKit converts symbol values to JSON as null
  // V8 throws on boxed symbols
  return _stringify([S]) != '[null]' || _stringify({ a: S }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    var args = [it];
    var i = 1;
    var replacer, $replacer;
    while (arguments.length > i) args.push(arguments[i++]);
    $replacer = replacer = args[1];
    if (!_isObject(replacer) && it === undefined || isSymbol(it)) return; // IE8 returns string on undefined
    if (!_isArray(replacer)) replacer = function (key, value) {
      if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});

// 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
$Symbol[PROTOTYPE$2][TO_PRIMITIVE] || _hide($Symbol[PROTOTYPE$2], TO_PRIMITIVE, $Symbol[PROTOTYPE$2].valueOf);
// 19.4.3.5 Symbol.prototype[@@toStringTag]
_setToStringTag($Symbol, 'Symbol');
// 20.2.1.9 Math[@@toStringTag]
_setToStringTag(Math, 'Math', true);
// 24.3.3 JSON[@@toStringTag]
_setToStringTag(_global.JSON, 'JSON', true);

_wksDefine('asyncIterator');

_wksDefine('observable');

var symbol$2 = _core.Symbol;

var symbol = createCommonjsModule(function (module) {
module.exports = { "default": symbol$2, __esModule: true };
});

unwrapExports(symbol);

var _typeof_1 = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _iterator2 = _interopRequireDefault(iterator);



var _symbol2 = _interopRequireDefault(symbol);

var _typeof = typeof _symbol2.default === "function" && typeof _iterator2.default === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = typeof _symbol2.default === "function" && _typeof(_iterator2.default) === "symbol" ? function (obj) {
  return typeof obj === "undefined" ? "undefined" : _typeof(obj);
} : function (obj) {
  return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
};
});

var _typeof = unwrapExports(_typeof_1);

var possibleConstructorReturn = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _typeof3 = _interopRequireDefault(_typeof_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && ((typeof call === "undefined" ? "undefined" : (0, _typeof3.default)(call)) === "object" || typeof call === "function") ? call : self;
};
});

var _possibleConstructorReturn = unwrapExports(possibleConstructorReturn);

// Works with __proto__ only. Old v8 can't work with null proto objects.
/* eslint-disable no-proto */


var check = function (O, proto) {
  _anObject(O);
  if (!_isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
};
var _setProto = {
  set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
    function (test, buggy, set) {
      try {
        set = _ctx(Function.call, _objectGopd.f(Object.prototype, '__proto__').set, 2);
        set(test, []);
        buggy = !(test instanceof Array);
      } catch (e) { buggy = true; }
      return function setPrototypeOf(O, proto) {
        check(O, proto);
        if (buggy) O.__proto__ = proto;
        else set(O, proto);
        return O;
      };
    }({}, false) : undefined),
  check: check
};

// 19.1.3.19 Object.setPrototypeOf(O, proto)

_export(_export.S, 'Object', { setPrototypeOf: _setProto.set });

var setPrototypeOf$2 = _core.Object.setPrototypeOf;

var setPrototypeOf = createCommonjsModule(function (module) {
module.exports = { "default": setPrototypeOf$2, __esModule: true };
});

unwrapExports(setPrototypeOf);

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
_export(_export.S, 'Object', { create: _objectCreate });

var $Object$1 = _core.Object;
var create$2 = function create(P, D) {
  return $Object$1.create(P, D);
};

var create = createCommonjsModule(function (module) {
module.exports = { "default": create$2, __esModule: true };
});

unwrapExports(create);

var inherits = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _setPrototypeOf2 = _interopRequireDefault(setPrototypeOf);



var _create2 = _interopRequireDefault(create);



var _typeof3 = _interopRequireDefault(_typeof_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === "undefined" ? "undefined" : (0, _typeof3.default)(superClass)));
  }

  subClass.prototype = (0, _create2.default)(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf2.default ? (0, _setPrototypeOf2.default)(subClass, superClass) : subClass.__proto__ = superClass;
};
});

var _inherits = unwrapExports(inherits);

var Icon = function (_Component) {
  _inherits(Icon, _Component);

  function Icon(props) {
    _classCallCheck(this, Icon);

    var _this = _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Icon, [{
    key: 'render',
    value: function render() {
      if (this.props.custom) {
        return React.createElement('img', {
          style: this.props.style,
          src: this.props.custom,
          className: this.props.className,
          alt: '',
          onClick: this.props.onClick
        });
      } else {
        return React.createElement('i', {
          style: this.props.style,
          className: (this.props.bootstrap ? 'icon-' + this.props.bootstrap + ' ' : ' ') + (this.props.awesome ? 'fa fa-' + this.props.awesome + ' ' : ' ') + (this.props.className ? this.props.className : ''),
          onClick: this.props.onClick
        });
      }
    }
  }]);

  return Icon;
}(Component);

Icon.defaultProps = {
  onClick: function onClick() {}
};

Icon.propTypes = {
  bootstrap: PropTypes.string,
  awesome: PropTypes.string,
  custom: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  onClick: PropTypes.func
};

var Header = function (_Component) {
  _inherits(Header, _Component);

  function Header(props) {
    _classCallCheck(this, Header);

    var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

    _this.toggle = _this.toggle.bind(_this);
    _this.toggleNot = _this.toggleNot.bind(_this);
    _this._renderMenuLeft = _this._renderMenuLeft.bind(_this);
    _this._renderMenuRight = _this._renderMenuRight.bind(_this);
    _this.state = { dropdownOpen: false, dropdownOpenNot: false };
    return _this;
  }

  _createClass(Header, [{
    key: 'toggle',
    value: function toggle() {
      this.setState({ dropdownOpen: !this.state.dropdownOpen });
    }
  }, {
    key: 'toggleNot',
    value: function toggleNot() {
      this.setState({ dropdownOpenNot: !this.state.dropdownOpenNot });
    }
  }, {
    key: 'sidebarToggle',
    value: function sidebarToggle(e) {
      e.preventDefault();
      document.body.classList.toggle('sidebar-hidden');
    }
  }, {
    key: 'mobileSidebarToggle',
    value: function mobileSidebarToggle(e) {
      e.preventDefault();
      document.body.classList.toggle('sidebar-mobile-show');
    }
  }, {
    key: 'asideToggle',
    value: function asideToggle(e) {
      e.preventDefault();
      document.body.classList.toggle('aside-menu-hidden');
    }
  }, {
    key: 'activeRoute',
    value: function activeRoute(routeName) {
      return window.location.pathname.indexOf(routeName) > -1 ? 'active' : '';
    }
  }, {
    key: '_renderMenuLeft',
    value: function _renderMenuLeft(menu, key) {
      if (!menu.to) {
        alert('falta la key "to"'); // eslint-disable-line
        return;
      }
      return React.createElement(
        'li',
        { key: key, className: 'nav-item px-1' },
        menu.text && React.createElement(
          Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu.to) },
          menu.text
        ),
        menu.icon && React.createElement(
          Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu.to) },
          React.createElement(Icon, menu.icon)
        )
      );
    }
  }, {
    key: '_renderMenuRight',
    value: function _renderMenuRight(menu, key) {
      if (!menu.to) {
        alert('falta la key "to"'); // eslint-disable-line
        return;
      }
      return React.createElement(
        'li',
        { key: key, className: 'nav-item hidden-md-down' },
        menu.text && React.createElement(
          Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu.to) },
          menu.text
        ),
        menu.icon && React.createElement(
          Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu.to) },
          React.createElement(Icon, menu.icon)
        )
      );
    }
  }, {
    key: '_renderMenuUser',
    value: function _renderMenuUser(menu, key) {
      if (menu.divider) {
        return React.createElement(DropdownItem, { key: key, divider: true });
      }
      if (menu.header) {
        return React.createElement(
          DropdownItem,
          { key: key, header: true,
            className: 'text-center'
          },
          React.createElement(
            'strong',
            null,
            menu.name
          )
        );
      }
      return React.createElement(
        Link,
        { key: key,
          to: menu.to,
          onClick: menu.onClick ? function () {
            return menu.onClick();
          } : function () {},
          className: 'nav-link'
        },
        React.createElement(
          DropdownItem,
          null,
          menu.icon && React.createElement(Icon, menu.icon),
          menu.name,
          menu.notificacion && React.createElement(
            'span',
            { className: 'badge ' + (menu.notificacion.style ? 'badge-' + menu.notificacion.style : 'badge-info')
            },
            menu.notificacion.cantidad
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'header',
        { className: 'app-header navbar ' + this.props.className },
        this.props.sidebarToggle && React.createElement(
          'button',
          { className: 'btn navbar-toggler mobile-sidebar-toggler hidden-lg-up hidden-print',
            onClick: this.mobileSidebarToggle,
            type: 'button'
          },
          '\u2630'
        ),
        React.createElement(
          'div',
          { className: 'navbar-brand' },
          this.props.logo && React.createElement('img', {
            src: this.props.logo,
            style: { width: '100%', height: '100%', objectFit: 'contain' },
            alt: ''
          })
        ),
        React.createElement(
          'ul',
          { className: 'nav navbar-nav hidden-md-down' },
          this.props.sidebarToggle && React.createElement(
            'li',
            { className: 'nav-item' },
            React.createElement(
              'a',
              { className: 'nav-link navbar-toggler sidebar-toggler',
                onClick: this.sidebarToggle,
                href: '#'
              },
              '\u2630'
            )
          ),
          this.props.menuLeft.map(this._renderMenuLeft)
        ),
        React.createElement(
          'ul',
          { className: 'nav navbar-nav ml-auto' },
          this.props.notificaciones && React.createElement(
            'li',
            { className: 'nav-item hidden-md-down', id: 'notificaciones' },
            React.createElement(
              Dropdown,
              { isOpen: this.state.dropdownOpenNot, toggle: this.toggleNot },
              React.createElement(
                'a',
                { className: 'nav-link',
                  onClick: this.toggleNot,
                  href: '#'
                },
                React.createElement('i', { className: 'icon-bell' }),
                React.createElement(
                  'span',
                  { className: 'badge badge-pill badge-danger' },
                  this.props.notificaciones.cantidad
                )
              ),
              this.props.notificaciones.component
            )
          ),
          this.props.menuRight.map(this._renderMenuRight),
          this.props.menuUser && React.createElement(
            'li',
            { className: 'nav-item', style: { paddingRight: !this.props.asideMenu ? 15 : 0 } },
            this.props.menuUser.dropdown && React.createElement(
              Dropdown,
              { isOpen: this.state.dropdownOpen, toggle: this.toggle },
              React.createElement(
                'a',
                { onClick: this.toggle,
                  className: 'nav-link dropdown-toggle ' + this.props.menuUser.className,
                  role: 'button'
                },
                React.createElement('img', {
                  src: this.props.menuUser.avatar,
                  className: 'img-avatar',
                  alt: ''
                }),
                React.createElement(
                  'span',
                  { className: 'hidden-md-down' },
                  this.props.menuUser.username
                )
              ),
              React.createElement(
                DropdownMenu,
                { className: 'dropdown-menu-right' },
                this.props.menuUser.dropdown.map(this._renderMenuUser)
              )
            ),
            !this.props.menuUser.dropdown && React.createElement(
              'div',
              {
                className: 'nav-link ' + this.props.menuUser.className,
                role: 'button'
              },
              React.createElement('img', {
                src: this.props.menuUser.avatar,
                className: 'img-avatar',
                alt: ''
              }),
              React.createElement(
                'span',
                { className: 'hidden-md-down' },
                this.props.menuUser.username
              )
            )
          ),
          this.props.asideMenu && React.createElement(
            'li',
            { className: 'nav-item hidden-md-down' },
            React.createElement(
              'a',
              { className: 'nav-link navbar-toggler aside-menu-toggler',
                onClick: this.asideToggle,
                href: '#'
              },
              '\u2630'
            )
          )
        )
      );
    }
  }]);

  return Header;
}(Component);

Header.defaultProps = {
  asideMenu: false,
  sidebarToggle: true,
  menuLeft: [],
  menuRight: []
};

Header.propTypes = {
  asideMenu: PropTypes.bool,
  sidebarToggle: PropTypes.bool,
  notificaciones: PropTypes.object,
  menuLeft: PropTypes.array,
  menuRight: PropTypes.array,
  menuUser: PropTypes.object,
  logo: PropTypes.string,
  className: PropTypes.string
};

var Body = function (_Component) {
  _inherits(Body, _Component);

  function Body(props) {
    _classCallCheck(this, Body);

    var _this = _possibleConstructorReturn(this, (Body.__proto__ || Object.getPrototypeOf(Body)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Body, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'app-body' },
        this.props.Sidebar,
        React.createElement(
          'main',
          { className: 'main' + (!this.props.sidebarToggle ? ' ml-0' : '') },
          this.props.Breadcrumb,
          React.createElement(
            'div',
            { className: 'container-fluid' },
            this.props.children
          )
        ),
        this.props.Aside
      );
    }
  }]);

  return Body;
}(Component);

Body.defaultProps = {
  sidebarToggle: true
};

Body.propTypes = {
  children: PropTypes.any,
  Sidebar: PropTypes.any,
  Breadcrumb: PropTypes.any,
  Aside: PropTypes.any,
  sidebarToggle: PropTypes.bool
};

var Footer = function (_Component) {
  _inherits(Footer, _Component);

  function Footer(props) {
    _classCallCheck(this, Footer);

    var _this = _possibleConstructorReturn(this, (Footer.__proto__ || Object.getPrototypeOf(Footer)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Footer, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'footer',
        {
          className: 'app-footer ' + (!this.props.sidebarToggle ? 'ml-0 ' : ' ') + this.props.className
        },
        this.props.contentCenter && React.createElement(
          'div',
          { className: 'text-center' },
          this.props.contentCenter
        ),
        !this.props.contentCenter && React.createElement(
          'wrapper',
          null,
          this.props.contentLeft,
          React.createElement(
            'span',
            { className: 'float-right' },
            this.props.contentRight
          )
        )
      );
    }
  }]);

  return Footer;
}(Component);

Footer.defaultProps = {
  sidebarToggle: true
};

Footer.propTypes = {
  contentCenter: PropTypes.any,
  contentLeft: PropTypes.any,
  contentRight: PropTypes.any,
  sidebarToggle: PropTypes.bool,
  className: PropTypes.string
};

var Aside = function (_Component) {
  _inherits(Aside, _Component);

  function Aside(props) {
    _classCallCheck(this, Aside);

    var _this = _possibleConstructorReturn(this, (Aside.__proto__ || Object.getPrototypeOf(Aside)).call(this, props));

    _this.state = { activeTab: 0 };
    _this.toggle = _this.toggle.bind(_this);
    _this._renderNavItems = _this._renderNavItems.bind(_this);
    _this._renderTabPanels = _this._renderTabPanels.bind(_this);
    return _this;
  }

  _createClass(Aside, [{
    key: 'toggle',
    value: function toggle(tab) {
      if (this.state.activeTab !== tab) {
        this.setState({ activeTab: tab });
      }
    }
  }, {
    key: '_renderNavItems',
    value: function _renderNavItems(item, key) {
      var _this2 = this;

      return React.createElement(
        NavItem,
        { key: key },
        React.createElement(
          NavLink,
          { className: classnames({ active: this.state.activeTab === key }), onClick: function onClick() {
              _this2.toggle(key);
            } },
          item.icon && React.createElement('i', { className: item.icon }),
          item.text && React.createElement(
            'i',
            null,
            item.text
          )
        )
      );
    }
  }, {
    key: '_renderTabPanels',
    value: function _renderTabPanels(tab, key) {
      return React.createElement(
        TabPane,
        {
          key: key,
          className: tab.props.className,
          tabId: key
        },
        tab
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'aside',
        { className: 'aside-menu' },
        React.createElement(
          Nav,
          { tabs: true },
          this.props.NavItems.map(this._renderNavItems)
        ),
        React.createElement(
          TabContent,
          { activeTab: this.state.activeTab },
          this.props.TabPanels.map(this._renderTabPanels)
        )
      );
    }
  }]);

  return Aside;
}(Component);

Aside.defaultProps = {
  NavItems: [],
  TabPanels: []
};

Aside.propTypes = {
  NavItems: PropTypes.array,
  TabPanels: PropTypes.array
};

var Sidebar = function (_Component) {
  _inherits(Sidebar, _Component);

  function Sidebar(props) {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

    _this.state = {};
    _this._renderSidebarMenu = _this._renderSidebarMenu.bind(_this);
    _this._renderDropdownMenu = _this._renderDropdownMenu.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'handleClick',
    value: function handleClick(e) {
      e.preventDefault();
      e.target.parentElement.classList.toggle('open');
    }
  }, {
    key: 'activeDropdown',
    value: function activeDropdown(routeName) {
      return window.location.pathname.indexOf(routeName) > -1 ? 'nav-item nav-dropdown open' : 'nav-item nav-dropdown';
    }
  }, {
    key: 'activeRoute',
    value: function activeRoute(menu) {
      return window.location.pathname.indexOf(menu.to) > -1 && window.location.pathname.length === menu.to.length ? 'active' : '';
    }
  }, {
    key: '_renderSidebarMenu',
    value: function _renderSidebarMenu(menu, key) {
      if (menu.divider) {
        return React.createElement('li', { key: key, className: 'divider' });
      }
      if (menu.title) {
        return React.createElement(
          'li',
          { key: key, className: 'nav-title' },
          menu.name
        );
      }
      if (menu.dropdown) {
        if (!menu.to) {
          alert('falta la key "to"'); // eslint-disable-line
          return;
        }
        return React.createElement(
          'li',
          { key: key, className: this.activeDropdown(menu.to) },
          React.createElement(
            'a',
            { className: 'nav-link nav-dropdown-toggle',
              href: '#',
              onClick: this.handleClick
            },
            menu.icon && React.createElement(Icon, menu.icon),
            menu.name
          ),
          React.createElement(
            'ul',
            { className: 'nav-dropdown-items' },
            menu.submenus.map(this._renderSidebarMenu)
          )
        );
      }

      if (!menu.to) {
        alert('falta la key "to"'); // eslint-disable-line
        return;
      }
      return React.createElement(
        'li',
        { key: key, className: 'nav-item' },
        React.createElement(
          Link,
          { to: menu.to, className: 'nav-link ' + this.activeRoute(menu) },
          menu.icon && React.createElement(Icon, menu.icon),
          menu.name,
          menu.badge && React.createElement(
            'span',
            { className: 'badge ' + (menu.badge.style ? 'badge-' + menu.badge.style : 'badge-info') },
            menu.badge.name
          )
        )
      );
    }
  }, {
    key: '_renderDropdownMenu',
    value: function _renderDropdownMenu(submenu, key) {
      return React.createElement(
        'li',
        { className: 'nav-item' },
        React.createElement(
          Link,
          { to: submenu.to, className: 'nav-link' },
          submenu.icon && React.createElement(Icon, submenu.icon),
          '\xA0 ',
          submenu.name,
          submenu.badge && React.createElement(
            'span',
            { className: 'badge ' + (submenu.badge.style ? 'badge-info' : 'badge-') },
            submenu.badge.name
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'sidebar' },
        React.createElement(
          'nav',
          { className: 'sidebar-nav' },
          React.createElement(
            'ul',
            { className: 'nav' },
            this.props.sidebarMenu.map(this._renderSidebarMenu)
          )
        )
      );
    }
  }]);

  return Sidebar;
}(Component);

Sidebar.defaultProps = {
  sidebarMenu: []
};

Sidebar.propTypes = {
  sidebarMenu: PropTypes.array
};

var Breadcrumb = function (_Component) {
  _inherits(Breadcrumb, _Component);

  function Breadcrumb(props) {
    _classCallCheck(this, Breadcrumb);

    var _this = _possibleConstructorReturn(this, (Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).call(this, props));

    _this._renderRoutes = _this._renderRoutes.bind(_this);
    _this.state = {};
    return _this;
  }

  _createClass(Breadcrumb, [{
    key: 'getRoutes',
    value: function getRoutes() {
      var routes = window.location.pathname.split('/').filter(function (r, i) {
        return r !== '';
      });
      return routes;
    }
  }, {
    key: '_renderRoutes',
    value: function _renderRoutes(route, key, last) {
      if (route === this.props.initialRoute.to) {
        return;
      }
      if (key === last) {
        if (this.props.normalizeRoutes[route]) {
          return React.createElement(
            'span',
            { key: key, className: 'breadcrumb-item' },
            this.props.normalizeRoutes[route].name
          );
        } else {
          return React.createElement(
            'span',
            { key: key, className: 'breadcrumb-item' },
            route
          );
        }
      }
      if (this.props.normalizeRoutesDropdown[route]) {
        return React.createElement(
          'span',
          { key: key, className: 'breadcrumb-item' },
          this.props.normalizeRoutesDropdown[route].to ? React.createElement(
            Link,
            { to: this.props.normalizeRoutesDropdown[route].to },
            this.props.normalizeRoutesDropdown[route].name
          ) : this.props.normalizeRoutesDropdown[route].name ? this.props.normalizeRoutesDropdown[route].name : route
        );
      } else {
        return React.createElement(
          'span',
          { key: key, className: 'breadcrumb-item' },
          route
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        'ol',
        { className: 'breadcrumb' },
        this.props.initialRoute && React.createElement(
          'span',
          { className: 'breadcrumb-item' },
          React.createElement(
            Link,
            { to: '/' + this.props.initialRoute.to },
            this.props.initialRoute.name
          )
        ),
        this.getRoutes().map(function (v, i) {
          return _this2._renderRoutes(v, i, _this2.getRoutes().length - 1);
        })
      );
    }
  }]);

  return Breadcrumb;
}(Component);

Breadcrumb.defaultProps = {
  initialRoute: { to: 'inicio', name: 'Inicio' },
  normalizeRoutes: {},
  normalizeRoutesDropdown: {}
};

Breadcrumb.propTypes = {
  initialRoute: PropTypes.object,
  normalizeRoutes: PropTypes.object,
  normalizeRoutesDropdown: PropTypes.object
};

var ViewAnimated = function (_Component) {
  _inherits(ViewAnimated, _Component);

  function ViewAnimated(props) {
    _classCallCheck(this, ViewAnimated);

    var _this = _possibleConstructorReturn(this, (ViewAnimated.__proto__ || Object.getPrototypeOf(ViewAnimated)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(ViewAnimated, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        document.body.classList.remove('modal-open');
        if (_this2.viewAnimated) {
          _this2.viewAnimated.classList.remove('animated');
        }
      }, 500);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React.createElement(
        'div',
        {
          ref: function ref(viewAnimated) {
            _this3.viewAnimated = viewAnimated;
          },
          className: 'animated fadeIn ' + this.props.className
        },
        this.props.children
      );
    }
  }]);

  return ViewAnimated;
}(Component);

ViewAnimated.defaultProps = {};

ViewAnimated.propTypes = {
  children: PropTypes.any,
  className: PropTypes.string
};

var Card = function (_Component) {
  _inherits(Card, _Component);

  function Card(props) {
    _classCallCheck(this, Card);

    var _this = _possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this, props));

    _this.state = {
      propOpen: props.open,
      collapseOpen: !props.animated ? true : props.open,
      textCollapse: !props.animated ? '' : props.open ? 'ocultar contenido' : 'mostrar contenido'
    };
    _this.toggle = _this.toggle.bind(_this);
    return _this;
  }

  _createClass(Card, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.open !== this.state.propOpen) {
        this.setState({
          collapseOpen: nextProps.open,
          propOpen: nextProps.open
        });
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.setState({
        collapseOpen: !this.state.collapseOpen,
        textCollapse: !this.state.collapseOpen ? 'ocultar contenido' : 'mostrar contenido'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        Col,
        {
          className: 'col-12',
          style: { padding: this.props.fullWidth && 0 },
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        React.createElement(
          'div',
          {
            className: 'card' + (this.props.outlineColor ? ' card-outline-' + this.props.outlineColor : '') + (this.props.topColor ? ' card-accent-' + this.props.topColor : '') + (this.props.cardColor ? ' card-inverse card-' + this.props.cardColor : '')
          },
          this.props.title && React.createElement(
            'div',
            { className: 'card-header',
              onClick: this.props.animated && this.toggle,
              style: { cursor: this.props.animated ? 'pointer' : 'default' }
            },
            this.props.icon && React.createElement(Icon, this.props.icon),
            this.props.title,
            this.props.nextTitle,
            this.props.animated && React.createElement(
              'small',
              null,
              React.createElement(
                'strong',
                null,
                '\xA0\xA0(click para ',
                this.state.textCollapse,
                ')'
              )
            )
          ),
          React.createElement(
            Collapse,
            { isOpen: this.state.collapseOpen },
            React.createElement(
              'div',
              {
                className: 'card-block' + (this.props.fullWidth ? ' row' : '')
              },
              this.props.children
            ),
            this.props.footer && React.createElement(
              'div',
              { className: 'card-footer' },
              this.props.footer
            )
          )
        )
      );
    }
  }]);

  return Card;
}(Component);

Card.defaultProps = {
  size: {},
  animated: false,
  open: false,
  fullWidth: false
};

Card.propTypes = {
  size: PropTypes.object,
  animated: PropTypes.bool,
  open: PropTypes.bool,
  fullWidth: PropTypes.bool,
  icon: PropTypes.object,
  title: PropTypes.any,
  nextTitle: PropTypes.any,
  outlineColor: PropTypes.string,
  topColor: PropTypes.string,
  cardColor: PropTypes.string,
  footer: PropTypes.any,
  children: PropTypes.any
};

var CardImgFull = function (_Component) {
  _inherits(CardImgFull, _Component);

  function CardImgFull(props) {
    _classCallCheck(this, CardImgFull);

    var _this = _possibleConstructorReturn(this, (CardImgFull.__proto__ || Object.getPrototypeOf(CardImgFull)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(CardImgFull, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'wrapper',
        null,
        React.createElement(
          Container,
          { fluid: true,
            style: { height: 230, padding: 0, marginLeft: -30, marginRight: -30, marginTop: -25, marginBottom: -210 }
          },
          React.createElement('img', {
            src: this.props.image,
            style: { position: 'absolute', width: '100%', height: '100%', objectFit: 'cover', backgroundRepeat: 'no-repeat' },
            alt: ''
          })
        ),
        React.createElement(
          Jumbotron,
          { fluid: true, style: { position: 'relative', height: 240, color: this.props.color } },
          this.props.titulo && React.createElement(
            'label',
            {
              className: 'display-3',
              style: { background: 'rgba(0,0,0,0.5)', padding: '5px 20px', marginLeft: -30 }
            },
            this.props.titulo
          ),
          this.props.subtitulo && React.createElement(
            'p',
            { className: 'lead', style: { marginTop: 75 } },
            this.props.subtitulo
          )
        )
      );
    }
  }]);

  return CardImgFull;
}(Component);

CardImgFull.defaultProps = {};

CardImgFull.propTypes = {
  image: PropTypes.string,
  color: PropTypes.string,
  titulo: PropTypes.string,
  subtitulo: PropTypes.string
};

var CardLittle = function (_Component) {
  _inherits(CardLittle, _Component);

  function CardLittle(props) {
    _classCallCheck(this, CardLittle);

    var _this = _possibleConstructorReturn(this, (CardLittle.__proto__ || Object.getPrototypeOf(CardLittle)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(CardLittle, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        Col,
        {
          className: 'col-12',
          style: { padding: this.props.fullWidth && 0 },
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        React.createElement(
          'div',
          { className: 'card ' + this.props.className, style: this.props.style },
          React.createElement(
            'div',
            { className: (!this.props.box ? 'p-0 ' : '') + 'card-block clearfix' },
            React.createElement(
              Col,
              { className: 'col-12 p-0 pull-left text-center', md: '6' },
              React.createElement(
                'div',
                {
                  className: 'bg-' + this.props.color + (!this.props.noPadding ? ' pt-1 pb-1 ' : ' ') + this.props.txtLeft.className,
                  style: this.props.txtLeft.style
                },
                this.props.txtLeft.titulo || this.props.txtLeft
              )
            ),
            React.createElement(
              Col,
              { className: 'col-12 p-0 pull-right text-center', md: '6' },
              React.createElement(
                'div',
                {
                  className: 'text-' + this.props.color + (!this.props.noPadding ? ' pt-1 pb-1 ' : ' ') + this.props.txtRight.className,
                  style: this.props.txtRight.style
                },
                this.props.txtRight.titulo || this.props.txtRight
              )
            )
          )
        )
      );
    }
  }]);

  return CardLittle;
}(Component);

CardLittle.defaultProps = {
  size: {},
  fullWidth: false,
  txtLeft: {},
  txtRight: {}
};

CardLittle.propTypes = {
  box: PropTypes.bool,
  size: PropTypes.object,
  fullWidth: PropTypes.bool,
  icon: PropTypes.object,
  titulo: PropTypes.string,
  subtitulo: PropTypes.string,
  color: PropTypes.string,
  style: PropTypes.object,
  className: PropTypes.string,
  noPadding: PropTypes.bool,
  txtLeft: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  txtRight: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
};

// 19.1.2.1 Object.assign(target, source, ...)





var $assign = Object.assign;

// should work with symbols and should have deterministic property order (V8 bug)
var _objectAssign = !$assign || _fails(function () {
  var A = {};
  var B = {};
  // eslint-disable-next-line no-undef
  var S = Symbol();
  var K = 'abcdefghijklmnopqrst';
  A[S] = 7;
  K.split('').forEach(function (k) { B[k] = k; });
  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
}) ? function assign(target, source) { // eslint-disable-line no-unused-vars
  var T = _toObject(target);
  var aLen = arguments.length;
  var index = 1;
  var getSymbols = _objectGops.f;
  var isEnum = _objectPie.f;
  while (aLen > index) {
    var S = _iobject(arguments[index++]);
    var keys = getSymbols ? _objectKeys(S).concat(getSymbols(S)) : _objectKeys(S);
    var length = keys.length;
    var j = 0;
    var key;
    while (length > j) if (isEnum.call(S, key = keys[j++])) T[key] = S[key];
  } return T;
} : $assign;

// 19.1.3.1 Object.assign(target, source)


_export(_export.S + _export.F, 'Object', { assign: _objectAssign });

var assign$2 = _core.Object.assign;

var assign = createCommonjsModule(function (module) {
module.exports = { "default": assign$2, __esModule: true };
});

unwrapExports(assign);

var _extends = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _assign2 = _interopRequireDefault(assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _assign2.default || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};
});

var _extends$1 = unwrapExports(_extends);

var CardLittleIcon = function (_Component) {
  _inherits(CardLittleIcon, _Component);

  function CardLittleIcon(props) {
    _classCallCheck(this, CardLittleIcon);

    var _this = _possibleConstructorReturn(this, (CardLittleIcon.__proto__ || Object.getPrototypeOf(CardLittleIcon)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(CardLittleIcon, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        Col,
        {
          className: 'col-12',
          style: { padding: this.props.fullWidth && 0 },
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        React.createElement(
          'div',
          { className: 'card ' + this.props.className, style: this.props.style },
          React.createElement(
            'div',
            { className: (!this.props.box ? 'p-0 ' : '') + 'card-block clearfix' },
            React.createElement(Icon, _extends$1({}, this.props.icon, {
              className: (this.props.color ? 'bg-' + this.props.color : '') + ' p-2 font-2xl mr-1 pull-left'
            })),
            React.createElement(
              'div',
              { className: 'h5 text-' + this.props.color + ' mb-0 pt-1' },
              this.props.titulo
            ),
            this.props.subtitulo && React.createElement(
              'div',
              { className: 'text-muted text-uppercase font-weight-bold font-xs' },
              this.props.subtitulo
            )
          )
        )
      );
    }
  }]);

  return CardLittleIcon;
}(Component);

CardLittleIcon.defaultProps = {
  size: {},
  fullWidth: false
};

CardLittleIcon.propTypes = {
  box: PropTypes.bool,
  size: PropTypes.object,
  fullWidth: PropTypes.bool,
  icon: PropTypes.object,
  titulo: PropTypes.string,
  subtitulo: PropTypes.string,
  color: PropTypes.string,
  style: PropTypes.object,
  className: PropTypes.string
};

var Modal$1 = function (_Component) {
  _inherits(Modal$$1, _Component);

  function Modal$$1(props) {
    _classCallCheck(this, Modal$$1);

    var _this = _possibleConstructorReturn(this, (Modal$$1.__proto__ || Object.getPrototypeOf(Modal$$1)).call(this, props));

    _this.state = {
      close: false
    };
    _this._renderHeader = _this._renderHeader.bind(_this);
    _this._renderBody = _this._renderBody.bind(_this);
    _this._renderFooter = _this._renderFooter.bind(_this);
    _this.close = _this.close.bind(_this);
    return _this;
  }

  _createClass(Modal$$1, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isOpen) {
        document.body.classList.add('modal-open');
      }
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      return React.createElement(
        ModalHeader,
        { toggle: !this.props.noHeaderBtnClose && this.close },
        this.props.title
      );
    }
  }, {
    key: '_renderBody',
    value: function _renderBody() {
      return React.createElement(
        ModalBody,
        null,
        this.props.titleBody && React.createElement(
          'p',
          null,
          this.props.titleBody
        ),
        this.props.children
      );
    }
  }, {
    key: '_renderFooter',
    value: function _renderFooter() {
      return React.createElement(
        ModalFooter,
        null,
        this.props.preFooter,
        !this.props.noFooterBtnClose && React.createElement(
          Button,
          {
            disabled: this.props.fetching,
            onClick: this.close,
            style: { marginRight: 5 }
          },
          'Cerrar'
        ),
        this.props.footer
      );
    }
  }, {
    key: 'close',
    value: function close() {
      var _this2 = this;

      if (this.props.animation.out) {
        this.setState({
          close: true
        }, function () {
          setTimeout(function () {
            _this2.props.close();
            _this2.setState({
              close: false
            });
          }, 300);
        });
      } else {
        this.props.close();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        Modal,
        {
          isOpen: this.props.isOpen,
          backdrop: 'static',
          size: this.props.size,
          className: (this.props.color ? 'modal-' + this.props.color : '') + (this.props.animation.in && !this.state.close ? ' animated ' + this.props.animation.in : ' ') + (this.props.animation.out && this.state.close ? ' animated ' + this.props.animation.out : ' ')
        },
        this.props.title && this._renderHeader(),
        this._renderBody(),
        !this.props.noFooter && this._renderFooter()
      );
    }
  }]);

  return Modal$$1;
}(Component);

Modal$1.defaultProps = {
  isOpen: false,
  noHeaderBtnClose: false,
  noFooterBtnClose: false,
  noFooter: false,
  size: 'md',
  animation: {}
};

Modal$1.propTypes = {
  size: PropTypes.string,
  title: PropTypes.string,
  titleBody: PropTypes.string,
  color: PropTypes.string,
  isOpen: PropTypes.bool,
  noHeaderBtnClose: PropTypes.bool,
  noFooterBtnClose: PropTypes.bool,
  noFooter: PropTypes.bool,
  fetching: PropTypes.bool,
  close: PropTypes.func.isRequired,
  children: PropTypes.any,
  footer: PropTypes.any,
  preFooter: PropTypes.any,
  animation: PropTypes.object
};

function withTooltip(Component$$1) {
  var withTooltip = function (_React$Component) {
    _inherits(withTooltip, _React$Component);

    function withTooltip() {
      _classCallCheck(this, withTooltip);

      return _possibleConstructorReturn(this, (withTooltip.__proto__ || Object.getPrototypeOf(withTooltip)).apply(this, arguments));
    }

    _createClass(withTooltip, [{
      key: '_renderTooltip',
      value: function _renderTooltip(text) {
        return React.createElement(
          Tooltip,
          { id: 'tooltip' },
          React.createElement(
            'strong',
            null,
            text
          )
        );
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderTooltip: this._renderTooltip
        }, this.props));
      }
    }]);

    return withTooltip;
  }(React.Component);

  return withTooltip;
}

function withColumnsTag(Component$$1) {
  var withColumnsTag = function (_React$Component) {
    _inherits(withColumnsTag, _React$Component);

    function withColumnsTag(props) {
      _classCallCheck(this, withColumnsTag);

      var _this = _possibleConstructorReturn(this, (withColumnsTag.__proto__ || Object.getPrototypeOf(withColumnsTag)).call(this, props));

      _this.state = {
        columnsTag: props.columnsTag,
        columnsTagPrint: props.columnsTag
      };
      _this.setColumnsTagPrint = _this.setColumnsTagPrint.bind(_this);
      _this.handlerClickColumnsTag = _this.handlerClickColumnsTag.bind(_this);
      _this.handlerClickColumnsTagPrint = _this.handlerClickColumnsTagPrint.bind(_this);
      _this._renderColumnsTagElements = _this._renderColumnsTagElements.bind(_this);
      _this._renderColumnsTagElementsPrint = _this._renderColumnsTagElementsPrint.bind(_this);
      _this._renderColumnsTag = _this._renderColumnsTag.bind(_this);
      _this._renderColumnsTagPrint = _this._renderColumnsTagPrint.bind(_this);
      return _this;
    }

    _createClass(withColumnsTag, [{
      key: 'setColumnsTagPrint',
      value: function setColumnsTagPrint() {
        this.setState({
          columnsTagPrint: deepcopy(this.state.columnsTag)
        });
      }
    }, {
      key: 'handlerClickColumnsTag',
      value: function handlerClickColumnsTag(prop) {
        var columnsTag = this.state.columnsTag;
        columnsTag[prop] = !columnsTag[prop];

        this.setState({
          columnsTag: columnsTag
        });
      }
    }, {
      key: 'handlerClickColumnsTagPrint',
      value: function handlerClickColumnsTagPrint(prop) {
        var columnsTagPrint = this.state.columnsTagPrint;
        columnsTagPrint[prop] = !columnsTagPrint[prop];

        this.setState({
          columnsTagPrint: columnsTagPrint
        });
      }
    }, {
      key: '_renderColumnsTagElements',
      value: function _renderColumnsTagElements() {
        var _this2 = this;

        var elements = [];

        var _loop = function _loop(prop) {
          if (_this2.props.tHead[prop]) {
            elements.push(React.createElement(
              'wrapper',
              { key: prop },
              React.createElement(
                Badge,
                {
                  pill: true,
                  className: 'mb-q',
                  color: _this2.state.columnsTag[prop] ? 'primary' : 'default',
                  role: 'button',
                  style: { fontSize: '.80rem' },
                  onClick: function onClick() {
                    return _this2.handlerClickColumnsTag(prop);
                  }
                },
                _this2.props.tHead[prop]
              ),
              '\xA0'
            ));
          }
        };

        for (var prop in this.state.columnsTag) {
          _loop(prop);
        }
        return elements;
      }
    }, {
      key: '_renderColumnsTag',
      value: function _renderColumnsTag() {
        if (this.state.columnsTag) {
          return React.createElement(
            Row,
            null,
            React.createElement(
              Col,
              { className: 'col-12 mb-q', sm: '12' },
              this._renderColumnsTagElements()
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderColumnsTagElementsPrint',
      value: function _renderColumnsTagElementsPrint() {
        var _this3 = this;

        var elements = [];

        var _loop2 = function _loop2(prop) {
          if (_this3.props.tHead[prop]) {
            elements.push(React.createElement(
              'wrapper',
              { key: prop },
              React.createElement(
                Badge,
                {
                  pill: true,
                  className: 'mb-q',
                  color: _this3.state.columnsTagPrint[prop] ? 'primary' : 'default',
                  role: 'button',
                  style: { fontSize: '.80rem' },
                  onClick: function onClick() {
                    return _this3.handlerClickColumnsTagPrint(prop);
                  }
                },
                _this3.props.tHead[prop]
              ),
              '\xA0'
            ));
          }
        };

        for (var prop in this.state.columnsTagPrint) {
          _loop2(prop);
        }
        return elements;
      }
    }, {
      key: '_renderColumnsTagPrint',
      value: function _renderColumnsTagPrint() {
        if (this.state.columnsTagPrint) {
          return React.createElement(
            Row,
            { className: 'hidden-print' },
            React.createElement(
              Col,
              { className: 'col-12 mb-q', sm: '12' },
              this._renderColumnsTagElementsPrint()
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderColumnsTag: this._renderColumnsTag,
          _renderColumnsTagPrint: this._renderColumnsTagPrint,
          setColumnsTagPrint: this.setColumnsTagPrint
        }, this.props, {
          columnsTag: this.state.columnsTag,
          columnsTagPrint: this.state.columnsTagPrint
        }));
      }
    }]);

    return withColumnsTag;
  }(React.Component);

  withColumnsTag.defaultProps = {};

  withColumnsTag.propTypes = {
    tHead: PropTypes.object,
    columnsTag: PropTypes.object
  };

  return withColumnsTag;
}

function withSortLimitFilterPageFunctions(Component$$1) {
  var withSortLimitFilterPageFunctions = function (_React$Component) {
    _inherits(withSortLimitFilterPageFunctions, _React$Component);

    function withSortLimitFilterPageFunctions(props) {
      _classCallCheck(this, withSortLimitFilterPageFunctions);

      var _this = _possibleConstructorReturn(this, (withSortLimitFilterPageFunctions.__proto__ || Object.getPrototypeOf(withSortLimitFilterPageFunctions)).call(this, props));

      _this.state = {
        activeLimit: 0,
        activePage: 0,
        activeSort: [],
        activeFilter: []
      };
      _this.setActiveLimit = _this.setActiveLimit.bind(_this);
      _this.setActivePage = _this.setActivePage.bind(_this);
      _this.setActiveSort = _this.setActiveSort.bind(_this);
      _this.setActiveFilter = _this.setActiveFilter.bind(_this);
      _this.returnSortLimitFilterPage = _this.returnSortLimitFilterPage.bind(_this);
      return _this;
    }

    _createClass(withSortLimitFilterPageFunctions, [{
      key: 'setActiveLimit',
      value: function setActiveLimit(activeLimit, init) {
        var _this2 = this;

        this.setState({
          activeLimit: activeLimit,
          activePage: 1
        }, function () {
          return !init && _this2.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActivePage',
      value: function setActivePage(activePage, init) {
        var _this3 = this;

        this.setState({
          activePage: activePage
        }, function () {
          return !init && _this3.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActiveSort',
      value: function setActiveSort(activeSort, init) {
        var _this4 = this;

        this.setState({
          activeSort: activeSort
        }, function () {
          return !init && _this4.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'setActiveFilter',
      value: function setActiveFilter(activeFilter, init) {
        var _this5 = this;

        this.setState({
          activeFilter: activeFilter,
          activePage: 1
        }, function () {
          return !init && _this5.returnSortLimitFilterPage();
        });
      }
    }, {
      key: 'calculateEntries',
      value: function calculateEntries(page, perPage) {
        return page * perPage - perPage;
      }
    }, {
      key: 'returnSortLimitFilterPage',
      value: function returnSortLimitFilterPage() {
        var activeFilter = this.state.activeFilter.length !== 0 ? this.state.activeFilter : undefined;
        var activeSort = this.state.activeSort.length !== 0 ? this.state.activeSort : undefined;
        var activeOffset = void 0;
        var activeLimit = void 0;
        // chequeo si existe la propiedad limit sino utilizo la perPage de pagination
        if (this.props.limit) {
          activeOffset = this.calculateEntries(this.state.activePage, this.state.activeLimit);
          activeLimit = this.state.activeLimit;
        } else if (this.props.pagination.perPage) {
          activeOffset = this.calculateEntries(this.state.activePage, this.props.pagination.perPage);
          activeLimit = this.props.pagination.perPage;
        }
        this.props.returnSortPaginationAndFilter && this.props.returnSortPaginationAndFilter(activeFilter, activeSort, activeLimit, activeOffset);
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          activeLimit: this.state.activeLimit,
          activePage: this.state.activePage,
          activeSort: this.state.activeSort,
          activeFilter: this.state.activeFilter,
          setActiveLimit: this.setActiveLimit,
          setActivePage: this.setActivePage,
          setActiveSort: this.setActiveSort,
          setActiveFilter: this.setActiveFilter
        }, this.props));
      }
    }]);

    return withSortLimitFilterPageFunctions;
  }(React.Component);

  withSortLimitFilterPageFunctions.defaultProps = {};

  withSortLimitFilterPageFunctions.propTypes = {
    returnSortPaginationAndFilter: PropTypes.func,
    pagination: PropTypes.object,
    limit: PropTypes.oneOfType([PropTypes.bool, PropTypes.object])
  };

  return withSortLimitFilterPageFunctions;
}

function withLimit(Component$$1) {
  var withLimit = function (_React$Component) {
    _inherits(withLimit, _React$Component);

    function withLimit(props) {
      _classCallCheck(this, withLimit);

      var _this = _possibleConstructorReturn(this, (withLimit.__proto__ || Object.getPrototypeOf(withLimit)).call(this, props));

      var limit = null;
      if (props.limit) {
        if (_typeof(props.limit) === 'object' && props.limit.options) {
          limit = props.limit;
        } else {
          limit = {
            options: [10, 25, 50, 100, 1000]
          };
        }
      }

      _this.state = {
        limit: limit
      };
      _this.handlerOnChange = _this.handlerOnChange.bind(_this);
      _this._renderLimit = _this._renderLimit.bind(_this);
      return _this;
    }

    _createClass(withLimit, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.state.limit) {
          this.props.setActiveLimit(this.state.limit.options[0], true);
        }
      }
    }, {
      key: 'handlerOnChange',
      value: function handlerOnChange(value) {
        this.props.setActiveLimit(parseInt(value, 10));
      }
    }, {
      key: '_renderLimitElements',
      value: function _renderLimitElements(opt, kOpt) {
        return React.createElement(
          'option',
          {
            key: 'opt-' + kOpt,
            value: opt
          },
          opt
        );
      }
    }, {
      key: '_renderLimit',
      value: function _renderLimit() {
        var _this2 = this;

        if (this.state.limit) {
          return React.createElement(
            'div',
            { className: 'pull-left' },
            'Mostrar \xA0',
            React.createElement(
              'select',
              {
                value: this.props.activeLimit,
                onChange: function onChange(e) {
                  return _this2.handlerOnChange(e.currentTarget.value);
                }
              },
              this.state.limit.options.map(this._renderLimitElements)
            ),
            '\xA0 registros'
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderLimit: this._renderLimit
        }, this.props));
      }
    }]);

    return withLimit;
  }(React.Component);

  withLimit.defaultProps = {};

  withLimit.propTypes = {
    limit: PropTypes.oneOfType([PropTypes.bool, PropTypes.object]),
    setActiveLimit: PropTypes.func,
    activeLimit: PropTypes.number
  };

  return withLimit;
}

var defineProperty$5 = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;



var _defineProperty2 = _interopRequireDefault(defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (obj, key, value) {
  if (key in obj) {
    (0, _defineProperty2.default)(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};
});

var _defineProperty$1 = unwrapExports(defineProperty$5);

// Translate month names
var MONTHS = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

// Translate for aria-label attribute
var LABELS = {
  nextMonth: 'Siguiente mes',
  previousMonth: 'Anterior mes'

  // Component will receive date, locale and localeUtils props
};function YearMonthForm(_ref) {
  var date = _ref.date,
      localeUtils = _ref.localeUtils,
      _onChange = _ref.onChange,
      enabledYearChange = _ref.enabledYearChange;

  var years = [];
  if (typeof enabledYearChange === 'number' || (typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
    var fromMonth = 0;
    var toMonth = 0;

    if ((typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt(moment().add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt(moment().add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.dynamic && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt(moment(date.getFullYear(), 'YYYY', true).add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt(moment(date.getFullYear(), 'YYYY', true).add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
    } else {
      fromMonth = parseInt(enabledYearChange <= 0 ? moment().add(enabledYearChange, 'year').format('YYYY') : moment().format('YYYY'), 10);
      toMonth = parseInt(enabledYearChange <= 0 ? moment().format('YYYY') : moment().add(enabledYearChange, 'year').format('YYYY'), 10);
    }
    for (var i = fromMonth; i <= toMonth; i += 1) {
      years.push(i);
    }
  } else if (Array.isArray(enabledYearChange)) {
    years = enabledYearChange;
  }

  return React.createElement(
    'div',
    { className: 'DayPicker-Caption' },
    React.createElement(
      'span',
      null,
      MONTHS[date.getMonth()]
    ),
    React.createElement(
      'select',
      {
        name: 'year',
        onChange: function onChange(e) {
          return _onChange(e.currentTarget.value, date.getMonth());
        },
        value: date.getFullYear()
      },
      years.map(function (year, i) {
        return React.createElement(
          'option',
          { key: i, value: year },
          year
        );
      })
    )
  );
}

YearMonthForm.propTypes = {
  date: PropTypes.object,
  localeUtils: PropTypes.object,
  onChange: PropTypes.func,
  enabledYearChange: PropTypes.any
};

var FieldDate = function (_Component) {
  _inherits(FieldDate, _Component);

  function FieldDate(props) {
    _classCallCheck(this, FieldDate);

    var _this = _possibleConstructorReturn(this, (FieldDate.__proto__ || Object.getPrototypeOf(FieldDate)).call(this, props));

    var formato = props.formato ? props.formato : 'DD/MM/YYYY';

    _this.state = {
      formato: formato,
      showOverlay: false,
      value: props.input.value && props.input.value !== '' ? moment(props.input.value, formato, true).format(formato) : '',
      selectedDay: props.input.value && props.input.value !== '' ? moment(props.input.value, formato, true).toDate() : null
    };
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    _this.handleInputChange = _this.handleInputChange.bind(_this);
    _this.handleOpenDatepicker = _this.handleOpenDatepicker.bind(_this);
    _this.handleInputBlur = _this.handleInputBlur.bind(_this);
    _this.handleContainerMouseDown = _this.handleContainerMouseDown.bind(_this);
    _this.handleCleanDatepicker = _this.handleCleanDatepicker.bind(_this);
    _this.handleYearMonthChange = _this.handleYearMonthChange.bind(_this);
    return _this;
  }

  _createClass(FieldDate, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value === '') {
        this.setState({
          value: '',
          selectedDay: null
        });
      } else {
        this.setState({
          value: nextProps.input.value && nextProps.input.value !== '' ? moment(nextProps.input.value, this.state.formato, true).format(this.state.formato) : '',
          selectedDay: nextProps.input.value && nextProps.input.value !== '' ? moment(nextProps.input.value, this.state.formato, true).toDate() : null
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.clickTimeout);
    }
  }, {
    key: 'handleContainerMouseDown',
    value: function handleContainerMouseDown() {
      var _this2 = this;

      this.clickedInside = true;
      // The input's onBlur method is called from a queue right after onMouseDown event.
      // setTimeout adds another callback in the queue, but is called later than onBlur event
      this.clickTimeout = setTimeout(function () {
        _this2.clickedInside = false;
      }, 0);
    }
  }, {
    key: 'handleCleanDatepicker',
    value: function handleCleanDatepicker() {
      var _this3 = this;

      this.setState({
        value: '',
        showOverlay: false,
        selectedDay: null
      }, function () {
        _this3.props.input && _this3.props.input.onChange && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur && _this3.props.input.onBlur('');
        _this3.props.onSelected && _this3.props.onSelected('');
      });
    }
  }, {
    key: 'handleOpenDatepicker',
    value: function handleOpenDatepicker() {
      this.setState({
        showOverlay: true
      });
      this.input.focus();
    }
  }, {
    key: 'handleInputBlur',
    value: function handleInputBlur(e) {
      var showOverlay = this.clickedInside;

      this.setState({
        showOverlay: showOverlay
      });

      // Force input's focus if blur event was caused by clicking on the calendar
      if (showOverlay) {
        // this.input.focus()
      }
    }
  }, {
    key: 'handleInputChange',
    value: function handleInputChange(e) {
      var _this4 = this;

      var value = e.target.value;

      var momentDay = moment(value, this.state.formato, true);
      if (momentDay.isValid()) {
        this.setState({
          selectedDay: momentDay.toDate(),
          value: value
        }, function () {
          _this4.daypicker.showMonth(_this4.state.selectedDay);
        });
      } else {
        this.setState({ value: value, selectedDay: null });
      }

      // if (this.props.onSelected) {
      //   this.props.onSelected(value)
      // } else {
      //   this.props.input.onChange(value)
      // }
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, _ref2) {
      var _this5 = this;

      var disabled = _ref2.disabled,
          selected = _ref2.selected;

      if (disabled) {
        return;
      }
      this.setState({
        value: moment(day).format(this.state.formato),
        selectedDay: day,
        showOverlay: false
      }, function () {
        _this5.props.input && _this5.props.input.onChange && _this5.props.input.onChange(_this5.state.value);
        _this5.props.onSelected && _this5.props.onSelected(_this5.state.value);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'handleYearMonthChange',
    value: function handleYearMonthChange(year, month) {
      this.setState({
        month: new Date(year, month)
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return React.createElement(
        FormGroup,
        {
          color: !this.props.meta.touched ? '' : this.props.meta.valid ? '' : 'danger',
          style: this.props.styleFormGroup,
          className: this.props.className
        },
        this.props.label && React.createElement(
          Label,
          { 'for': this.props.label.replace(/ /g, '') },
          this.props.label,
          ' ',
          this.props.required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        React.createElement(
          'div',
          { onMouseDown: this.handleContainerMouseDown },
          React.createElement(
            InputGroup,
            { style: this.props.styleInputGroup },
            React.createElement('input', {
              className: 'form-control',
              readOnly: true,
              disabled: this.props.disabled,
              type: 'text',
              ref: function ref(input) {
                _this6.input = input;
              },
              placeholder: this.props.placeholder,
              value: this.state.value,
              onChange: this.handleInputChange,
              onBlur: this.handleInputBlur
            }),
            this.props.disabled && this.props.motiveDisabled && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip(this.props.motiveDisabled)
              },
              React.createElement(
                InputGroupAddon,
                { style: { cursor: 'not-allowed' }
                },
                React.createElement(Icon, {
                  bootstrap: 'calendar'
                })
              )
            ),
            this.props.disabled && !this.props.motiveDisabled && React.createElement(
              InputGroupAddon,
              {
                style: { cursor: 'not-allowed' }
              },
              React.createElement(Icon, {
                bootstrap: 'calendar'
              })
            ),
            !this.props.disabled && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Abrir calendario')
              },
              React.createElement(
                InputGroupAddon,
                {
                  style: { cursor: 'pointer' },
                  onClick: this.handleOpenDatepicker },
                React.createElement(Icon, {
                  bootstrap: 'calendar'
                })
              )
            ),
            !this.props.required && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Limpiar')
              },
              React.createElement(
                InputGroupAddon,
                { style: { cursor: 'pointer' }, onClick: this.handleCleanDatepicker },
                React.createElement(Icon, {
                  bootstrap: 'close'
                })
              )
            )
          ),
          this.state.showOverlay && React.createElement(
            'div',
            {
              style: {
                position: 'absolute',
                height: 325,
                zIndex: 10
              }
            },
            React.createElement(
              'div',
              {
                style: {
                  position: 'relative',
                  background: 'white',
                  boxShadow: '0 2px 5px rgba(0, 0, 0, .15)'
                }
              },
              React.createElement(DayPicker, _extends$1({
                ref: function ref(daypicker) {
                  _this6.daypicker = daypicker;
                },
                locale: 'es',
                months: MONTHS,
                weekdaysLong: WEEKDAYS_LONG,
                weekdaysShort: WEEKDAYS_SHORT,
                labels: LABELS,
                initialMonth: this.state.selectedDay || this.props.initialMonth,
                onDayClick: this.handleDayClick,
                selectedDays: this.state.selectedDay,
                month: this.state.month,
                fromMonth: this.props.fromMonth,
                toMonth: this.props.toMonth,
                disabledDays: this.props.disabledDays,
                captionElement: this.props.enabledYearChange && React.createElement(YearMonthForm, {
                  onChange: this.handleYearMonthChange,
                  enabledYearChange: this.props.enabledYearChange
                })
              }, this.props.config))
            )
          )
        ),
        this.props.meta.touched && this.props.meta.error && React.createElement(
          FormFeedback,
          null,
          this.props.meta.error
        )
      );
    }
  }]);

  return FieldDate;
}(Component);

FieldDate.defaultProps = {
  meta: {},
  enabledYearChange: { from: -70, to: +10, dynamic: true }
};

FieldDate.propTypes = {
  label: PropTypes.string,
  required: PropTypes.bool,
  input: PropTypes.object,
  meta: PropTypes.object,
  onSelected: PropTypes.func,
  fromMonth: PropTypes.object,
  toMonth: PropTypes.object,
  placeholder: PropTypes.string,
  formato: PropTypes.string,
  disabled: PropTypes.bool,
  motiveDisabled: PropTypes.string,
  initialMonth: PropTypes.object,
  styleFormGroup: PropTypes.object,
  styleInputGroup: PropTypes.object,
  disabledDays: PropTypes.oneOfType([PropTypes.array, PropTypes.object, PropTypes.func]),
  config: PropTypes.object,
  className: PropTypes.string,
  enabledYearChange: PropTypes.any
};

// Translate month names
var MONTHS$1 = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT$1 = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG$1 = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

// Translate for aria-label attribute
var LABELS$1 = {
  nextMonth: 'Siguiente mes',
  previousMonth: 'Anterior mes'

  // Component will receive date, locale and localeUtils props
};function YearMonthForm$1(_ref) {
  var date = _ref.date,
      localeUtils = _ref.localeUtils,
      _onChange = _ref.onChange,
      enabledYearChange = _ref.enabledYearChange;

  var years = [];
  if (typeof enabledYearChange === 'number' || (typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
    var fromMonth = 0;
    var toMonth = 0;

    if ((typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt(moment().add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt(moment().add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.dynamic && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt(moment(date.getFullYear(), 'YYYY', true).add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt(moment(date.getFullYear(), 'YYYY', true).add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
    } else {
      fromMonth = parseInt(enabledYearChange <= 0 ? moment().add(enabledYearChange, 'year').format('YYYY') : moment().format('YYYY'), 10);
      toMonth = parseInt(enabledYearChange <= 0 ? moment().format('YYYY') : moment().add(enabledYearChange, 'year').format('YYYY'), 10);
    }
    for (var i = fromMonth; i <= toMonth; i += 1) {
      years.push(i);
    }
  } else if (Array.isArray(enabledYearChange)) {
    years = enabledYearChange;
  }

  return React.createElement(
    'div',
    { className: 'DayPicker-Caption' },
    React.createElement(
      'span',
      null,
      MONTHS$1[date.getMonth()]
    ),
    React.createElement(
      'select',
      {
        name: 'year',
        onChange: function onChange(e) {
          return _onChange(e.currentTarget.value, date.getMonth());
        },
        value: date.getFullYear()
      },
      years.map(function (year, i) {
        return React.createElement(
          'option',
          { key: i, value: year },
          year
        );
      })
    )
  );
}

YearMonthForm$1.propTypes = {
  date: PropTypes.object,
  localeUtils: PropTypes.object,
  onChange: PropTypes.func,
  enabledYearChange: PropTypes.any
};

var FieldDateTime = function (_Component) {
  _inherits(FieldDateTime, _Component);

  function FieldDateTime(props) {
    _classCallCheck(this, FieldDateTime);

    var _this = _possibleConstructorReturn(this, (FieldDateTime.__proto__ || Object.getPrototypeOf(FieldDateTime)).call(this, props));

    var formato = props.formato ? props.formato : 'DD/MM/YYYY';
    var value = '';
    var date = '';
    var tiempo = {
      hora: '00',
      minutos: '00'
    };
    var selectedDay = null;
    if (props.input.value) {
      date = props.input.value.split(' ')[0];

      tiempo = props.input.value.split(' ')[1].split(':');
      tiempo = {
        hora: tiempo[0],
        minutos: tiempo[1]
      };

      value = props.input.value;

      selectedDay = moment(date, formato, true).toDate();
    }

    _this.state = {
      formato: formato,
      showOverlay: false,
      value: value,
      date: date,
      tiempo: tiempo,
      selectedDay: selectedDay,
      selectsTiempo: {
        hora: _this.generateTime(24),
        minutos: _this.generateTime(60)
      }
    };
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    _this.handleInputChange = _this.handleInputChange.bind(_this);
    _this.handleOpenDatepicker = _this.handleOpenDatepicker.bind(_this);
    _this.handleInputBlur = _this.handleInputBlur.bind(_this);
    _this.handleContainerMouseDown = _this.handleContainerMouseDown.bind(_this);
    _this.handleCleanDatepicker = _this.handleCleanDatepicker.bind(_this);
    _this.hideOverlay = _this.hideOverlay.bind(_this);
    _this.handleYearMonthChange = _this.handleYearMonthChange.bind(_this);
    return _this;
  }

  _createClass(FieldDateTime, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value === '') {
        this.setState({
          value: '',
          date: '',
          tiempo: {
            hora: '00',
            minutos: '00'
          },
          selectedDay: null
        });
      } else {
        var value = '';
        var date = '';
        var tiempo = {
          hora: '00',
          minutos: '00'
        };
        var selectedDay = null;
        if (nextProps.input.value) {
          date = nextProps.input.value.split(' ')[0];

          tiempo = nextProps.input.value.split(' ')[1].split(':');
          tiempo = {
            hora: tiempo[0],
            minutos: tiempo[1]
          };

          value = nextProps.input.value;

          selectedDay = moment(date, this.state.formato, true).toDate();

          this.setState({
            value: value,
            date: date,
            tiempo: tiempo,
            selectedDay: selectedDay
          });
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.clickTimeout);
    }
  }, {
    key: 'generateTime',
    value: function generateTime(hasta) {
      var cantidad = [];
      for (var i = 0; i < hasta; i++) {
        if (i < 10) {
          i = '0' + i;
        }
        cantidad.push(i.toString());
      }
      return cantidad;
    }
  }, {
    key: 'handleContainerMouseDown',
    value: function handleContainerMouseDown() {
      var _this2 = this;

      this.clickedInside = true;
      // The input's onBlur method is called from a queue right after onMouseDown event.
      // setTimeout adds another callback in the queue, but is called later than onBlur event
      this.clickTimeout = setTimeout(function () {
        _this2.clickedInside = false;
      }, 0);
    }
  }, {
    key: 'handleCleanDatepicker',
    value: function handleCleanDatepicker() {
      var _this3 = this;

      this.setState({
        value: '',
        date: '',
        tiempo: {
          hora: '00',
          minutos: '00'
        },
        showOverlay: false,
        selectedDay: null
      }, function () {
        _this3.props.input && _this3.props.input.onChange && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur && _this3.props.input.onBlur('');
        _this3.props.onSelected && _this3.props.onSelected('');
      });
    }
  }, {
    key: 'handleOpenDatepicker',
    value: function handleOpenDatepicker() {
      this.setState({
        showOverlay: true
      });
      this.input.focus();
    }
  }, {
    key: 'handleInputBlur',
    value: function handleInputBlur(e) {
      var showOverlay = this.clickedInside;

      this.setState({
        showOverlay: showOverlay
      });

      // Force input's focus if blur event was caused by clicking on the calendar
      if (showOverlay) {
        // this.input.focus()
      }
    }
  }, {
    key: 'handleInputChange',
    value: function handleInputChange(e) {
      var _this4 = this;

      var value = e.target.value;

      var momentDay = moment(value, this.state.formato, true);
      if (momentDay.isValid()) {
        this.setState({
          selectedDay: momentDay.toDate()
        }, function () {
          _this4.daypicker.showMonth(_this4.state.selectedDay);
        });
      } else {
        this.setState({ selectedDay: null });
      }
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, _ref2) {
      var disabled = _ref2.disabled,
          selected = _ref2.selected;

      if (disabled) {
        return;
      }
      this.setState({
        date: moment(day).format(this.state.formato),
        selectedDay: day
      });
    }
  }, {
    key: 'hideOverlay',
    value: function hideOverlay() {
      var _this5 = this;

      if (!this.state.date) {
        this.setState({
          showOverlay: false
        });
        return;
      }
      this.setState({
        value: this.state.date + ' ' + this.state.tiempo.hora + ':' + this.state.tiempo.minutos,
        showOverlay: false
      }, function () {
        _this5.props.input && _this5.props.input.onChange && _this5.props.input.onChange(_this5.state.value);
        _this5.props.onSelected && _this5.props.onSelected(_this5.state.value);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'handleYearMonthChange',
    value: function handleYearMonthChange(year, month) {
      this.setState({
        month: new Date(year, month)
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return React.createElement(
        FormGroup,
        {
          color: !this.props.meta.touched ? '' : this.props.meta.valid ? '' : 'danger',
          style: this.props.styleFormGroup,
          className: this.props.className
        },
        this.props.label && React.createElement(
          Label,
          { 'for': this.props.label.replace(/ /g, '') },
          this.props.label,
          ' ',
          this.props.required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        React.createElement(
          'div',
          { onMouseDown: this.handleContainerMouseDown },
          React.createElement(
            InputGroup,
            { style: this.props.styleInputGroup },
            React.createElement('input', {
              className: 'form-control',
              readOnly: true,
              disabled: this.props.disabled,
              type: 'text',
              ref: function ref(input) {
                _this6.input = input;
              },
              placeholder: this.props.placeholder,
              value: this.state.value,
              onChange: this.handleInputChange,
              onBlur: this.handleInputBlur
            }),
            this.props.disabled && this.props.motiveDisabled && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip(this.props.motiveDisabled)
              },
              React.createElement(
                InputGroupAddon,
                { style: { cursor: 'not-allowed' }
                },
                React.createElement(Icon, {
                  bootstrap: 'calendar'
                })
              )
            ),
            this.props.disabled && !this.props.motiveDisabled && React.createElement(
              InputGroupAddon,
              {
                style: { cursor: 'not-allowed' }
              },
              React.createElement(Icon, {
                bootstrap: 'calendar'
              })
            ),
            !this.props.disabled && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Abrir calendario')
              },
              React.createElement(
                InputGroupAddon,
                {
                  style: { cursor: 'pointer' },
                  onClick: this.handleOpenDatepicker },
                React.createElement(Icon, {
                  bootstrap: 'calendar'
                })
              )
            ),
            !this.props.required && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Limpiar')
              },
              React.createElement(
                InputGroupAddon,
                { style: { cursor: 'pointer' }, onClick: this.handleCleanDatepicker },
                React.createElement(Icon, {
                  bootstrap: 'close'
                })
              )
            )
          ),
          this.state.showOverlay && React.createElement(
            'div',
            {
              style: {
                position: 'absolute',
                height: 325,
                zIndex: 10
              }
            },
            React.createElement(
              'div',
              {
                style: {
                  position: 'relative',
                  background: 'white',
                  boxShadow: '0 2px 5px rgba(0, 0, 0, .15)'
                }
              },
              React.createElement(DayPicker, _extends$1({
                ref: function ref(daypicker) {
                  _this6.daypicker = daypicker;
                },
                locale: 'es',
                months: MONTHS$1,
                weekdaysLong: WEEKDAYS_LONG$1,
                weekdaysShort: WEEKDAYS_SHORT$1,
                labels: LABELS$1,
                initialMonth: this.state.selectedDay || this.props.initialMonth,
                onDayClick: this.handleDayClick,
                selectedDays: this.state.selectedDay,
                month: this.state.month,
                fromMonth: this.props.fromMonth,
                toMonth: this.props.toMonth,
                disabledDays: this.props.disabledDays,
                captionElement: this.props.enabledYearChange && React.createElement(YearMonthForm$1, {
                  onChange: this.handleYearMonthChange,
                  enabledYearChange: this.props.enabledYearChange
                })
              }, this.props.config)),
              React.createElement(
                'div',
                { style: {
                    padding: '0 1rem 1rem',
                    overflow: 'hidden',
                    textAlign: 'center',
                    fontSize: 23,
                    color: '#607d8b'
                  }
                },
                React.createElement(
                  'select',
                  {
                    style: {
                      width: '48%',
                      minWidth: '48%',
                      float: 'left',
                      textIndent: 35
                    },
                    className: 'form-control',
                    onChange: function onChange(e) {
                      _this6.setState({
                        tiempo: {
                          hora: e.currentTarget.value,
                          minutos: _this6.state.tiempo.minutos
                        }
                      });
                    },
                    value: this.state.tiempo.hora
                  },
                  this.state.selectsTiempo.hora.map(function (h, k) {
                    return React.createElement(
                      'option',
                      { key: k, value: h },
                      h
                    );
                  })
                ),
                ':',
                React.createElement(
                  'select',
                  {
                    style: {
                      width: '48%',
                      minWidth: '48%',
                      float: 'right',
                      textIndent: 35
                    },
                    className: 'form-control',
                    onChange: function onChange(e) {
                      _this6.setState({
                        tiempo: {
                          hora: _this6.state.tiempo.hora,
                          minutos: e.currentTarget.value
                        }
                      });
                    },
                    value: this.state.tiempo.minutos
                  },
                  this.state.selectsTiempo.minutos.map(function (m, k) {
                    return React.createElement(
                      'option',
                      { key: k, value: m },
                      m
                    );
                  })
                )
              ),
              React.createElement(
                'div',
                { style: { padding: '0 1rem 1rem' } },
                React.createElement(
                  Button,
                  {
                    block: true,
                    size: 'sm',
                    color: 'success',
                    onClick: this.hideOverlay
                  },
                  'Listo'
                )
              )
            )
          )
        ),
        this.props.meta.touched && this.props.meta.error && React.createElement(
          FormFeedback,
          null,
          this.props.meta.error
        )
      );
    }
  }]);

  return FieldDateTime;
}(Component);

FieldDateTime.defaultProps = {
  meta: {},
  enabledYearChange: { from: -70, to: +10, dynamic: true }
};

FieldDateTime.propTypes = {
  label: PropTypes.string,
  required: PropTypes.bool,
  input: PropTypes.object,
  meta: PropTypes.object,
  onSelected: PropTypes.func,
  fromMonth: PropTypes.object,
  toMonth: PropTypes.object,
  placeholder: PropTypes.string,
  formato: PropTypes.string,
  disabled: PropTypes.bool,
  motiveDisabled: PropTypes.string,
  initialMonth: PropTypes.object,
  styleFormGroup: PropTypes.object,
  styleInputGroup: PropTypes.object,
  disabledDays: PropTypes.oneOfType([PropTypes.array, PropTypes.object, PropTypes.func]),
  config: PropTypes.object,
  className: PropTypes.string,
  enabledYearChange: PropTypes.any
};

function withFilter(Component$$1) {
  var withFilter = function (_React$Component) {
    _inherits(withFilter, _React$Component);

    function withFilter(props) {
      _classCallCheck(this, withFilter);

      var _this = _possibleConstructorReturn(this, (withFilter.__proto__ || Object.getPrototypeOf(withFilter)).call(this, props));

      var selectFilterType = null;
      var selectFilterValue = null;
      var filter = null;
      if (props.filter && _typeof(props.filter) === 'object' && props.filter.options) {
        filter = [];
        var saveFirstActive = true;
        for (var prop in props.filter.options) {
          filter.push(prop);
          if (saveFirstActive) {
            selectFilterValue = prop;
            selectFilterType = props.filter.options[prop];
            saveFirstActive = false;
          }
        }
      }

      _this.state = {
        filter: filter,
        selectFilterType: selectFilterType,
        selectFilterValue: selectFilterValue,
        inputFilterValue: ''
      };
      _this.handlerOnChangeSelectFilter = _this.handlerOnChangeSelectFilter.bind(_this);
      _this.handlerOnClickFindFilter = _this.handlerOnClickFindFilter.bind(_this);
      _this.handlerOnChangeInput = _this.handlerOnChangeInput.bind(_this);
      _this._renderSelectFilter = _this._renderSelectFilter.bind(_this);
      _this._renderFilter = _this._renderFilter.bind(_this);
      return _this;
    }

    _createClass(withFilter, [{
      key: 'handlerOnChangeInput',
      value: function handlerOnChangeInput(value) {
        this.setState({
          inputFilterValue: value
        });
      }
    }, {
      key: 'handlerOnClickFindFilter',
      value: function handlerOnClickFindFilter(prop, value) {
        var _this2 = this;

        var filter = [];
        if (value && value !== '') {
          if (this.props.filter.output && this.props.filter.output[prop]) {
            var _filter$push;

            filter.push((_filter$push = {}, _defineProperty$1(_filter$push, this.props.outputDefault.p || 'p', this.props.filter.output[prop].prop || prop), _defineProperty$1(_filter$push, this.props.outputDefault.v || 'v', this.props.filter.output[prop].value ? typeof this.props.filter.output[prop].value === 'function' ? this.props.filter.output[prop].value(value) : this.props.filter.output[prop].value : value), _defineProperty$1(_filter$push, this.props.outputDefault.t || 't', this.props.filter.output[prop].type || (this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined)), _defineProperty$1(_filter$push, this.props.outputDefault.e || 'e', this.props.filter.output[prop].exp ? this.props.filter.output[prop].exp : undefined), _filter$push));
          } else {
            var _filter$push2;

            filter.push((_filter$push2 = {}, _defineProperty$1(_filter$push2, this.props.outputDefault.p || 'p', prop), _defineProperty$1(_filter$push2, this.props.outputDefault.v || 'v', value), _defineProperty$1(_filter$push2, this.props.outputDefault.t || 't', this.state.selectFilterType === 'date' || this.state.selectFilterType === 'datetime' ? 'date' : undefined), _filter$push2));
          }
        }

        this.setState({
          inputFilterValue: value
        }, function () {
          return _this2.props.setActiveFilter(filter);
        });
      }
    }, {
      key: 'handlerOnChangeSelectFilter',
      value: function handlerOnChangeSelectFilter(value) {
        var _this3 = this;

        if (this.state.selectFilterType) {
          this.setState({
            selectFilterValue: value,
            selectFilterType: this.props.filter.options[value],
            inputFilterValue: ''
          }, function () {
            if (_this3.state.selectFilterType === 'text' || _this3.state.selectFilterType === 'number') {
              _this3.inputFilter.focus();
            }
          });
        } else {
          this.inputFilter.focus();
        }
      }
    }, {
      key: '_renderSelectFilter',
      value: function _renderSelectFilter(opt, kOpt) {
        return React.createElement(
          'option',
          {
            key: 'opt' + kOpt,
            value: opt
          },
          this.props.tHead[opt]
        );
      }
    }, {
      key: '_renderFilter',
      value: function _renderFilter() {
        var _this4 = this;

        if (this.props.filter) {
          return React.createElement(
            'div',
            { className: 'pull-right' },
            React.createElement(
              InputGroup,
              null,
              React.createElement(
                InputGroupButton,
                null,
                React.createElement(
                  'select',
                  {
                    style: { width: '100%' },
                    className: 'form-control',
                    value: this.state.selectFilterValue,
                    onChange: function onChange(e) {
                      return _this4.handlerOnChangeSelectFilter(e.currentTarget.value);
                    }
                  },
                  this.state.filter.map(this._renderSelectFilter)
                )
              ),
              this.state.selectFilterType && this.state.selectFilterType === 'date' && React.createElement(FieldDate, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && this.state.selectFilterType === 'datetime' && React.createElement(FieldDateTime, {
                styleFormGroup: { marginBottom: 0 },
                styleInputGroup: { height: '2.22rem' },
                type: 'text',
                formato: 'DD/MM/YYYY',
                input: { value: this.state.inputFilterValue },
                onSelected: function onSelected(value) {
                  return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, value);
                }
              }),
              this.state.selectFilterType && Array.isArray(this.state.selectFilterType) && React.createElement(
                'select',
                {
                  className: 'form-control',
                  value: this.state.inputFilterValue,
                  onChange: function onChange(e) {
                    return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                },
                React.createElement('option', { value: '' }),
                this.state.selectFilterType.map(function (v, k) {
                  return React.createElement(
                    'option',
                    { key: 'option-' + k, value: v.value || v },
                    v.label || v
                  );
                })
              ),
              (!this.state.selectFilterType || this.state.selectFilterType === 'text' || this.state.selectFilterType === 'number') && React.createElement('input', {
                type: this.state.selectFilterType,
                ref: function ref(input) {
                  _this4.inputFilter = input;
                },
                className: 'form-control',
                onChange: function onChange(e) {
                  return _this4.handlerOnChangeInput(e.currentTarget.value);
                },
                onKeyPress: function onKeyPress(e) {
                  if (e.which === 13 || e.charCode === 13 || e.keyCode === 13) {
                    _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, e.currentTarget.value);
                  }
                }
              }),
              React.createElement(
                OverlayTrigger,
                {
                  placement: 'top',
                  overlay: this.props._renderTooltip('Buscar')
                },
                React.createElement(
                  InputGroupAddon,
                  {
                    style: { cursor: 'pointer' },
                    onClick: function onClick(e) {
                      return _this4.handlerOnClickFindFilter(_this4.state.selectFilterValue, _this4.state.inputFilterValue);
                    }
                  },
                  React.createElement(Icon, {
                    bootstrap: 'magnifier'
                  })
                )
              )
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderFilter: this._renderFilter
        }, this.props));
      }
    }]);

    return withFilter;
  }(React.Component);

  withFilter.defaultProps = {
    tHead: {},
    outputDefault: {}
  };

  withFilter.propTypes = {
    filter: PropTypes.object,
    tHead: PropTypes.object,
    outputDefault: PropTypes.object,
    _renderTooltip: PropTypes.func,
    setActiveFilter: PropTypes.func
  };

  return withFilter;
}

function withSort(Component$$1) {
  var withSort = function (_React$Component) {
    _inherits(withSort, _React$Component);

    function withSort(props) {
      _classCallCheck(this, withSort);

      var _this = _possibleConstructorReturn(this, (withSort.__proto__ || Object.getPrototypeOf(withSort)).call(this, props));

      var initSort = [];
      if (props.sort && props.sort.init) {
        initSort = [{ p: props.sort.init, v: props.sort.fieldsSort[props.sort.init] }];
      }

      // INVIERTO LOS DEMAS QUE NO SON DEL INIT PARA QUE FUNCIONE EL ALGORITMO
      var sort = null;
      if (props.sort && props.sort.fieldsSort) {
        sort = props.sort;
        for (var prop in sort.fieldsSort) {
          if (props.sort.init && prop !== props.sort.init) {
            if (sort.fieldsSort[prop] === 'asc') {
              sort.fieldsSort[prop] = 'desc';
            } else {
              sort.fieldsSort[prop] = 'asc';
            }
          }
        }
      }

      _this.state = {
        initSort: initSort,
        sort: sort,
        cssClassName: { enabled: 'sorting', sorting: 'sorting_' }
      };
      _this.handlerSortOnChange = _this.handlerSortOnChange.bind(_this);
      return _this;
    }

    _createClass(withSort, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.props.setActiveSort(this.state.initSort, true);
      }
    }, {
      key: 'handlerSortOnChange',
      value: function handlerSortOnChange(key) {
        var _ref,
            _this2 = this;

        var sort = deepcopy(this.state.sort);
        var initAnterior = sort.init;
        sort.init = key;
        if (sort.init !== initAnterior) {
          sort.fieldsSort[initAnterior] = this.props.sort.fieldsSort[initAnterior] === 'asc' ? 'desc' : 'asc';
        }
        sort.fieldsSort[sort.init] = sort.fieldsSort[sort.init] === 'asc' ? 'desc' : 'asc';
        var activeSort = [(_ref = {}, _defineProperty$1(_ref, this.props.outputDefault.p || 'p', sort.init), _defineProperty$1(_ref, this.props.outputDefault.v || 'v', this.props.outputDefault[sort.fieldsSort[sort.init]] || sort.fieldsSort[sort.init]), _ref)];

        this.setState({
          sort: sort
        }, function () {
          return _this2.props.setActiveSort(activeSort);
        });
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          handlerSortOnChange: this.handlerSortOnChange,
          cssClassName: this.state.cssClassName
        }, this.props, {
          sort: this.state.sort
        }));
      }
    }]);

    return withSort;
  }(React.Component);

  withSort.defaultProps = {
    outputDefault: {}
  };

  withSort.propTypes = {
    outputDefault: PropTypes.object,
    sort: PropTypes.object,
    setActiveSort: PropTypes.func
  };

  return withSort;
}

function withPage(Component$$1) {
  var withPage = function (_React$Component) {
    _inherits(withPage, _React$Component);

    function withPage(props) {
      _classCallCheck(this, withPage);

      var _this = _possibleConstructorReturn(this, (withPage.__proto__ || Object.getPrototypeOf(withPage)).call(this, props));

      var items = 0;
      if (props.tBodyObject.length !== 0 && props.pagination) {
        if (props.limit) {
          items = Math.ceil(props.pagination.total / props.activeLimit);
        } else if (props.pagination.perPage && props.pagination.total) {
          items = Math.ceil(props.pagination.total / props.pagination.perPage);
        }
      }

      _this.state = {
        items: items
      };
      _this.handlerOnChange = _this.handlerOnChange.bind(_this);
      _this._renderPage = _this._renderPage.bind(_this);
      return _this;
    }

    _createClass(withPage, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.props.pagination.init) {
          this.props.setActivePage(1);
        }
        if (this.props.pagination.restart && this.props.pagination.returnRestart) {
          this.props.pagination.returnRestart();
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.tBodyObject.length !== 0 && nextProps.pagination) {
          var items = 0;
          if (nextProps.limit) {
            items = Math.ceil(nextProps.pagination.total / nextProps.activeLimit);
          } else if (nextProps.pagination.perPage && nextProps.pagination.total) {
            items = Math.ceil(nextProps.pagination.total / nextProps.pagination.perPage);
          }
          this.setState({
            items: items
          });
        }
        if (nextProps.pagination.restart && nextProps.pagination.returnRestart) {
          nextProps.setActivePage(1);
          nextProps.pagination.returnRestart();
        }
      }
    }, {
      key: 'handlerOnChange',
      value: function handlerOnChange(activePage) {
        if (activePage !== this.props.activePage) {
          this.props.setActivePage(activePage);
        }
      }
    }, {
      key: '_renderPage',
      value: function _renderPage() {
        if (this.props.pagination && !this.props.fetching && this.props.tBodyObject.length !== 0 && this.state.items !== 0) {
          return React.createElement(
            'nav',
            null,
            React.createElement(Pagination, _extends$1({}, this.props.pagination.configPagination, {
              items: this.state.items,
              activePage: this.props.activePage,
              onSelect: this.handlerOnChange
            }))
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderPage: this._renderPage
        }, this.props));
      }
    }]);

    return withPage;
  }(React.Component);

  withPage.defaultProps = {
    pagination: { init: false },
    tBodyObject: [],
    fetching: false
  };

  withPage.propTypes = {
    pagination: PropTypes.object,
    tBodyObject: PropTypes.array,
    fetching: PropTypes.bool,
    activePage: PropTypes.number,
    activeLimit: PropTypes.number,
    setActivePage: PropTypes.func,
    limit: PropTypes.oneOfType([PropTypes.bool, PropTypes.object])
  };

  return withPage;
}

function withPageDetail(Component$$1) {
  var withPageDetail = function (_React$Component) {
    _inherits(withPageDetail, _React$Component);

    function withPageDetail(props) {
      _classCallCheck(this, withPageDetail);

      var _this = _possibleConstructorReturn(this, (withPageDetail.__proto__ || Object.getPrototypeOf(withPageDetail)).call(this, props));

      _this.state = {};
      _this._renderPageDetail = _this._renderPageDetail.bind(_this);
      return _this;
    }

    _createClass(withPageDetail, [{
      key: '_renderPageDetail',
      value: function _renderPageDetail() {
        if (this.props.pagination && this.props.pagination.detalle && !this.props.fetching && this.props.tBodyObject.length !== 0 && (this.props.limit || this.props.pagination.perPage)) {
          return React.createElement(
            'p',
            { className: 'text-right mt-q mb-h' },
            'Mostrando del ' + (this.props.activePage * this.props.activeLimit - this.props.activeLimit + 1) + ' al ' + (this.props.activePage * this.props.activeLimit < this.props.pagination.total ? this.props.activePage * this.props.activeLimit : this.props.pagination.total) + ' de ' + this.props.pagination.total + ' registros'
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderPageDetail: this._renderPageDetail
        }, this.props));
      }
    }]);

    return withPageDetail;
  }(React.Component);

  withPageDetail.defaultProps = {};

  withPageDetail.propTypes = {
    pagination: PropTypes.object,
    activePage: PropTypes.number,
    activeLimit: PropTypes.number,
    fetching: PropTypes.bool,
    tBodyObject: PropTypes.array,
    limit: PropTypes.oneOfType([PropTypes.bool, PropTypes.object])
  };

  return withPageDetail;
}

// const EQ        = '=';
// const NEQ       = '<>';
// const LT        = '<';
// const LTE       = '<=';
// const GT        = '>';
// const GTE       = '>=';
// const IS        = '='; // no difference with EQ
// const IN        = 'IN';
// const NIN       = 'NIN';
// const CONTAINS  = 'CONTAINS';

function withMultiFilter(Component$$1) {
  var withMultiFilter = function (_React$Component) {
    _inherits(withMultiFilter, _React$Component);

    function withMultiFilter(props) {
      _classCallCheck(this, withMultiFilter);

      var _this = _possibleConstructorReturn(this, (withMultiFilter.__proto__ || Object.getPrototypeOf(withMultiFilter)).call(this, props));

      var fields = [];
      for (var prop in props.multiFilter) {
        if (props.tHead[prop]) {
          fields.push({ value: prop, label: props.tHead[prop], showAlways: props.multiFilter[prop].showAlways });
        } else if (props.multiFilter[prop].label) {
          fields.push({ value: prop, label: props.multiFilter[prop].label, showAlways: props.multiFilter[prop].showAlways });
        }
      }

      _this.state = {
        fields: fields,
        fieldsBck: fields,
        fieldsUsados: {},
        filtros: [{ field: '', criterio: '', valor: '' }]
      };
      _this.handlerResetear = _this.handlerResetear.bind(_this);
      _this.handlerAgregarFiltro = _this.handlerAgregarFiltro.bind(_this);
      _this.handlerEliminarFiltro = _this.handlerEliminarFiltro.bind(_this);
      _this.handlerGuardarLabel = _this.handlerGuardarLabel.bind(_this);
      _this.handlerGuardarCriterio = _this.handlerGuardarCriterio.bind(_this);
      _this.handlerGuardarValue = _this.handlerGuardarValue.bind(_this);
      _this.handlerFiltrar = _this.handlerFiltrar.bind(_this);
      _this.recalculoFieldsUsados = _this.recalculoFieldsUsados.bind(_this);
      _this.saveFiltros = _this.saveFiltros.bind(_this);
      _this._renderMultiFilter = _this._renderMultiFilter.bind(_this);
      _this._renderFiltro = _this._renderFiltro.bind(_this);
      _this._renderCriterio = _this._renderCriterio.bind(_this);
      _this._renderCampo = _this._renderCampo.bind(_this);
      return _this;
    }

    _createClass(withMultiFilter, [{
      key: 'handlerResetear',
      value: function handlerResetear(e) {
        if (this.Card.state.collapseOpen) {
          e.stopPropagation();
        }
        this.setState({
          fields: this.state.fieldsBck,
          fieldsUsados: {},
          filtros: [{ field: '', criterio: '', valor: '' }]
        });
      }
    }, {
      key: 'handlerAgregarFiltro',
      value: function handlerAgregarFiltro(e) {
        if (this.Card.state.collapseOpen) {
          e.stopPropagation();
        }
        var filtros = deepcopy(this.state.filtros);
        filtros.push({ field: '', criterio: '', valor: '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerEliminarFiltro',
      value: function handlerEliminarFiltro(kf) {
        this.recalculoFieldsUsados(undefined, kf);

        var filtros = deepcopy(this.state.filtros);
        filtros.splice(kf, 1);
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarLabel',
      value: function handlerGuardarLabel(value, kf) {
        this.recalculoFieldsUsados(value, kf);

        var filtros = deepcopy(this.state.filtros);
        filtros[kf] = merge(filtros[kf], { field: value, criterio: '', valor: '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarCriterio',
      value: function handlerGuardarCriterio(value, kf) {
        var filtros = deepcopy(this.state.filtros);
        var criteria = this.props.multiFilter[this.state.filtros[kf].field].criteria.filter(function (c) {
          return c.v === value;
        })[0];
        filtros[kf] = merge(filtros[kf], { criterio: value, valor: criteria.d || '' });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerGuardarValue',
      value: function handlerGuardarValue(value, kf) {
        var filtros = deepcopy(this.state.filtros);
        filtros[kf] = merge(filtros[kf], { valor: value });
        this.saveFiltros(filtros);
      }
    }, {
      key: 'handlerFiltrar',
      value: function handlerFiltrar() {
        var _this2 = this;

        var normalizeFiltros = deepcopy(this.state.filtros);
        normalizeFiltros = normalizeFiltros.filter(function (f) {
          return f.field !== '' && f.criterio !== '' && f.valor !== '';
        }).map(function (f, kf) {
          f[_this2.props.outputDefault.p || 'p'] = _this2.props.multiFilter[f.field].prop ? _this2.props.multiFilter[f.field].prop : f.field;
          f[_this2.props.outputDefault.v || 'v'] = f.valor;
          f[_this2.props.outputDefault.t || 't'] = _this2.props.multiFilter[f.field].type === 'date' || _this2.props.multiFilter[f.field].type === 'datetime' ? 'date' : undefined;
          f[_this2.props.outputDefault.e || 'e'] = f.criterio;
          delete f.field;
          delete f.valor;
          delete f.criterio;
          return f;
        });
        this.props.setActiveFilter(normalizeFiltros);
      }
    }, {
      key: 'saveFiltros',
      value: function saveFiltros(filtros) {
        this.setState({ filtros: filtros });
      }
    }, {
      key: 'recalculoFieldsUsados',
      value: function recalculoFieldsUsados(value, kf) {
        var fields = deepcopy(this.state.fields);
        var fieldsUsados = deepcopy(this.state.fieldsUsados);
        fieldsUsados[kf] = value;

        fields = fields.map(function (f) {
          f.usado = false;
          for (var prop in fieldsUsados) {
            if (f.value === fieldsUsados[prop]) {
              f.usado = true;
            }
          }
          return f;
        });

        this.setState({
          fieldsUsados: fieldsUsados,
          fields: fields
        });
      }
    }, {
      key: '_renderLabels',
      value: function _renderLabels(kf) {
        var _this3 = this;

        return React.createElement(
          'select',
          {
            value: this.state.filtros[kf].field,
            className: 'form-control',
            onChange: function onChange(e) {
              return _this3.handlerGuardarLabel(e.currentTarget.value, kf);
            }
          },
          React.createElement('option', { value: '' }),
          this.state.fields.filter(function (f) {
            return !f.usado || f.value === _this3.state.filtros[kf].field || f.showAlways;
          }).map(function (f, kf) {
            return React.createElement(
              'option',
              {
                key: 'opt-' + kf,
                value: f.value
              },
              f.label
            );
          })
        );
      }
    }, {
      key: '_renderCriterioDisabled',
      value: function _renderCriterioDisabled(kf) {
        return React.createElement('select', {
          value: this.state.filtros[kf].criterio,
          className: 'form-control',
          disabled: true
        });
      }
    }, {
      key: '_renderCriterio',
      value: function _renderCriterio(field, kf) {
        var _this4 = this;

        if (this.props.multiFilter[field].criteria) {
          return React.createElement(
            'select',
            {
              value: this.state.filtros[kf].criterio,
              className: 'form-control',
              onChange: function onChange(e) {
                return _this4.handlerGuardarCriterio(e.currentTarget.value, kf);
              }
            },
            React.createElement('option', { value: '' }),
            this.props.multiFilter[field].criteria.map(function (cr, kcr) {
              return React.createElement(
                'option',
                {
                  key: 'opt-' + kcr,
                  value: cr.v
                },
                cr.l
              );
            })
          );
        } else {
          return this._renderCriterioDisabled(kf);
        }
      }
    }, {
      key: '_renderCampoDisabled',
      value: function _renderCampoDisabled(kf) {
        return React.createElement('input', {
          className: 'form-control',
          value: this.state.filtros[kf].valor,
          disabled: true
        });
      }
    }, {
      key: '_renderCampo',
      value: function _renderCampo(field, kf) {
        var _this5 = this;

        if (this.props.multiFilter[field].type === 'date') {
          return React.createElement(FieldDate, {
            styleFormGroup: { marginBottom: 0 },
            styleInputGroup: { height: '2.22rem' },
            type: 'text',
            formato: 'DD/MM/YYYY',
            input: { value: this.state.filtros[kf].valor },
            onSelected: function onSelected(value) {
              return _this5.handlerGuardarValue(value, kf);
            }
          });
        } else if (this.props.multiFilter[field].type === 'datetime') {
          return React.createElement(FieldDateTime, {
            styleFormGroup: { marginBottom: 0 },
            styleInputGroup: { height: '2.22rem' },
            type: 'text',
            formato: 'DD/MM/YYYY',
            input: { value: this.state.filtros[kf].valor },
            onSelected: function onSelected(value) {
              return _this5.handlerGuardarValue(value, kf);
            }
          });
        } else if (Array.isArray(this.props.multiFilter[field].type)) {
          return React.createElement(
            'select',
            {
              className: 'form-control',
              value: this.state.filtros[kf].valor,
              onChange: function onChange(e) {
                return _this5.handlerGuardarValue(e.currentTarget.value, kf);
              }
            },
            React.createElement('option', { value: '' }),
            this.props.multiFilter[field].type.map(function (opt, kOpt) {
              return React.createElement(
                'option',
                { key: 'opt-' + kOpt, value: opt.value || opt },
                opt.label || opt
              );
            })
          );
        } else if (this.props.multiFilter[field].type === 'text' || this.props.multiFilter[field].type === 'number') {
          return React.createElement('input', {
            type: this.props.multiFilter[field].type,
            className: 'form-control',
            value: this.state.filtros[kf].valor,
            onChange: function onChange(e) {
              return _this5.handlerGuardarValue(e.currentTarget.value, kf);
            }
          });
        } else {
          return this._renderCampoDisabled(kf);
        }
      }
    }, {
      key: '_renderFiltro',
      value: function _renderFiltro(f, kf) {
        var _this6 = this;

        return React.createElement(
          Row,
          { key: 'filtro-' + kf, style: { width: '100%', margin: '0 0 5px' } },
          React.createElement(
            Col,
            { className: 'col-12', lg: '3' },
            React.createElement(
              'div',
              { style: { display: 'flex' } },
              React.createElement(
                'strong',
                { style: { padding: '0.5rem 0.75rem 0.5rem 0', flex: 'none' } },
                kf + 1,
                ' -'
              ),
              this._renderLabels(kf)
            )
          ),
          React.createElement(
            Col,
            { className: 'col-12', lg: '2' },
            this.state.filtros[kf].field && this.state.filtros[kf].field !== '' ? this._renderCriterio(this.state.filtros[kf].field, kf) : this._renderCriterioDisabled(kf)
          ),
          React.createElement(
            Col,
            { className: 'col-12', lg: '3' },
            this.state.filtros[kf].field && this.state.filtros[kf].field !== '' ? this._renderCampo(this.state.filtros[kf].field, kf) : this._renderCampoDisabled(kf)
          ),
          React.createElement(
            Col,
            { className: 'col-12', lg: '3' },
            kf !== 0 && React.createElement(
              OverlayTrigger,
              {
                placement: 'top',
                overlay: this.props._renderTooltip('Eliminar filtro')
              },
              React.createElement(
                Button,
                {
                  color: 'danger',
                  size: 'sm',
                  onClick: function onClick() {
                    return _this6.handlerEliminarFiltro(kf);
                  }
                },
                React.createElement(Icon, { bootstrap: 'trash' })
              )
            )
          )
        );
      }
    }, {
      key: '_renderMultiFilter',
      value: function _renderMultiFilter() {
        var _this7 = this;

        if (this.props.multiFilter) {
          return React.createElement(
            Card,
            {
              ref: function ref(Card$$1) {
                _this7.Card = Card$$1;
              },
              fullWidth: true,
              size: { sm: 12 },
              icon: { bootstrap: 'diamond' },
              title: 'Filtros avanzados',
              topColor: 'dark',
              animated: true,
              nextTitle: React.createElement(
                'wrapper',
                { className: 'pull-right' },
                React.createElement(
                  OverlayTrigger,
                  {
                    placement: 'top',
                    overlay: this.props._renderTooltip('Resetear')
                  },
                  React.createElement(
                    Button,
                    {
                      color: 'dark',
                      size: 'sm',
                      onClick: this.handlerResetear
                    },
                    React.createElement(Icon, { bootstrap: 'refresh' })
                  )
                ),
                ' \xA0',
                React.createElement(
                  OverlayTrigger,
                  {
                    placement: 'top',
                    overlay: this.props._renderTooltip('Sumar filtro')
                  },
                  React.createElement(
                    Button,
                    {
                      color: 'dark',
                      size: 'sm',
                      onClick: this.handlerAgregarFiltro
                    },
                    React.createElement(Icon, { bootstrap: 'plus' })
                  )
                )
              )
            },
            this.state.filtros.map(this._renderFiltro),
            React.createElement(
              Row,
              { style: { width: '100%', margin: '0 0 5px' } },
              React.createElement(
                Col,
                { className: 'col-12' },
                React.createElement('hr', null),
                React.createElement(
                  Button,
                  {
                    color: 'dark',
                    onClick: this.handlerFiltrar
                  },
                  'Filtrar'
                )
              )
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderMultiFilter: this._renderMultiFilter
        }, this.props));
      }
    }]);

    return withMultiFilter;
  }(React.Component);

  withMultiFilter.defaultProps = {
    outputDefault: {}
  };

  withMultiFilter.propTypes = {
    // withTooltip
    _renderTooltip: PropTypes.func,
    multiFilter: PropTypes.object,
    tHead: PropTypes.object,
    outputDefault: PropTypes.object,
    setActiveFilter: PropTypes.func
  };

  return withMultiFilter;
}

function withPrint(Component$$1) {
  var withPrint = function (_React$Component) {
    _inherits(withPrint, _React$Component);

    function withPrint(props) {
      _classCallCheck(this, withPrint);

      var _this = _possibleConstructorReturn(this, (withPrint.__proto__ || Object.getPrototypeOf(withPrint)).call(this, props));

      var tHead = [];
      for (var prop in props.tHead) {
        tHead.push({ key: prop, value: props.tHead[prop] });
      }

      _this.state = {
        tHead: tHead,
        popupWindow: false,
        popupWindowTitle: '',
        csv: { data: [], filename: '' },
        pdf: { data: '', filename: '' }
      };
      _this.handleColumnStart = _this.handleColumnStart.bind(_this);
      _this.handleColumnStop = _this.handleColumnStop.bind(_this);
      _this.handlePrintOpen = _this.handlePrintOpen.bind(_this);
      _this.handlePrintClose = _this.handlePrintClose.bind(_this);
      _this.handleGenerateCSV = _this.handleGenerateCSV.bind(_this);
      _this.handleGeneratePDF = _this.handleGeneratePDF.bind(_this);
      _this.tHeadGenerate = _this.tHeadGenerate.bind(_this);
      _this.tBodyGenerate = _this.tBodyGenerate.bind(_this);
      _this._renderResize = _this._renderResize.bind(_this);
      _this._renderTablePrint = _this._renderTablePrint.bind(_this);
      _this._renderTHEADprint = _this._renderTHEADprint.bind(_this);
      _this._renderTBODYprint = _this._renderTBODYprint.bind(_this);
      _this._renderLinesPrint = _this._renderLinesPrint.bind(_this);
      _this._renderPrint = _this._renderPrint.bind(_this);
      _this._renderPrintButton = _this._renderPrintButton.bind(_this);
      return _this;
    }

    _createClass(withPrint, [{
      key: 'tHeadGenerate',
      value: function tHeadGenerate() {
        var _this2 = this;

        var tHead = [];
        this.state.tHead.map(function (vThead) {
          if (!_this2.props.columnsTagPrint || _this2.props.columnsTagPrint[vThead.key] === undefined || _this2.props.columnsTagPrint[vThead.key]) {
            tHead.push(vThead);
          }
          return vThead;
        });
        return tHead;
      }
    }, {
      key: 'tBodyGenerate',
      value: function tBodyGenerate(tHead) {
        var _this3 = this;

        var tBodys = [];
        this.props.tBodyObject.map(function (vTbody, tBodyK) {
          var tBody = [];
          tHead.map(function (vThead) {
            if (_this3.props.tBodyDefault[vThead.key] && (objectPath.get(vTbody, vThead.key) === undefined || objectPath.get(vTbody, vThead.key) === '')) {
              tBody.push(_this3.props.tBodyDefault[vThead.key]);
              return vThead;
            }
            var valueData = void 0;
            if (_this3.props.tBodyFormatCSV[vThead.key]) {
              valueData = _this3.props.tBodyFormatCSV[vThead.key](vTbody, tBodyK);
              tBody.push(valueData);
              return vThead;
            } else if (_this3.props.tBodyFormat[vThead.key]) {
              valueData = _this3.props.tBodyFormat[vThead.key](vTbody, tBodyK);
              if (typeof valueData === 'string') {
                tBody.push(valueData);
                return vThead;
              }
            }
            if (objectPath.get(vTbody, vThead.key) === true || objectPath.get(vTbody, vThead.key) === false) {
              valueData = objectPath.get(vTbody, vThead.key) === true ? 'SI' : 'NO';
              tBody.push(valueData);
              return vThead;
            }

            tBody.push(objectPath.get(vTbody, vThead.key));
            return vThead;
          });
          tBodys.push(tBody);
          return vTbody;
        });
        return tBodys;
      }
    }, {
      key: 'handleGeneratePDF',
      value: function handleGeneratePDF(childWindow) {
        var pdf = { data: '', filename: '' };
        var tHead = this.tHeadGenerate();
        var tBody = this.tBodyGenerate(tHead);
        tHead = tHead.map(function (v) {
          return v.value;
        });

        var doc = new JsPDF('landscape', 'pt');
        var options = {
          theme: 'striped',
          styles: {
            overflow: 'linebreak'
          },
          headerStyles: {
            fillColor: [38, 50, 56]
          },
          margin: {
            top: 10,
            left: 10,
            right: 10,
            bottom: 10
          }
        };
        doc.setFontSize(12);
        doc.setFont('helvetica');
        doc.setTextColor(38, 50, 56);
        doc.autoTable(tHead, tBody, options);
        pdf.data = doc.output('dataurlstring');
        pdf.filename = this.state.popupWindowTitle + ' (' + moment().format('DD-MM-YYYY HH-mm') + 'hs).pdf';
        this.setState({
          pdf: pdf
        });
      }
    }, {
      key: 'handleGenerateCSV',
      value: function handleGenerateCSV() {
        var csv = { data: [], filename: '' };
        var tHead = this.tHeadGenerate();
        var tBody = this.tBodyGenerate(tHead);
        tHead = tHead.map(function (v) {
          return v.value;
        });
        csv.data.push(tHead);
        tBody.map(function (v) {
          csv.data.push(v);
          return v;
        });
        csv.filename = this.state.popupWindowTitle + ' (' + moment().format('DD-MM-YYYY HH-mm') + 'hs).csv';
        this.setState({
          csv: csv
        });
      }
    }, {
      key: 'handlePrintClose',
      value: function handlePrintClose() {
        this.setState({
          popupWindow: false
        });
      }
    }, {
      key: 'handlePrintOpen',
      value: function handlePrintOpen() {
        this.props.setColumnsTagPrint();
        var popupWindowTitle = 'REPORTE - ' + document.querySelector('head title').innerHTML;
        this.setState({
          popupWindowTitle: popupWindowTitle,
          popupWindow: true
        });
      }
    }, {
      key: 'handleColumnStart',
      value: function handleColumnStart(e) {
        this.position = e.pageX;
        this.element = e.currentTarget;
        if (this.element.parentNode.style.width === '') {
          this.element.parentNode.style.width = this.element.parentNode.clientWidth + 'px';
        }
      }
    }, {
      key: 'handleColumnStop',
      value: function handleColumnStop(e) {
        var withParent = this.element.parentNode.clientWidth;
        this.element.parentNode.style.width = withParent + e.pageX - this.position + 'px';
        this.element.style.right = parseInt(this.element.style.right.replace('px', ''), 10) + e.pageX - this.position + 'px';
        this.element = null;
      }
    }, {
      key: '_renderResize',
      value: function _renderResize() {
        return React.createElement(
          Draggable,
          {
            axis: 'x',
            onStart: this.handleColumnStart,
            onStop: this.handleColumnStop
          },
          React.createElement('div', {
            className: 'hidden-print',
            style: {
              position: 'absolute',
              right: 0,
              top: 0,
              height: 13,
              background: '#343a40',
              width: 3,
              cursor: 'col-resize'
            }
          })
        );
      }
    }, {
      key: '_renderTablePrint',
      value: function _renderTablePrint() {
        var _this4 = this;

        return React.createElement(
          'table',
          {
            ref: function ref(refTable) {
              _this4.refTable = refTable;
            },
            className: 'table table-hover table-md' + (this.props.striped ? 'table-striped ' : '') + (this.props.condensed ? 'table-condensed ' : '') + (this.props.bordered ? 'table-bordered ' : ''),
            style: { position: 'relative' }
          },
          React.createElement(
            'thead',
            null,
            React.createElement(
              'tr',
              null,
              this.state.tHead.map(this._renderTHEADprint)
            )
          ),
          React.createElement(
            'tbody',
            null,
            !this.props.fetching && this.props.tBodyObject.map(this._renderTBODYprint)
          ),
          React.createElement(
            'tfoot',
            null,
            React.createElement(
              'tr',
              null,
              this.props.fetching && React.createElement(
                'th',
                { colSpan: Object.keys(this.props.tHead).length + 1 },
                'Cargando ...'
              ),
              !this.props.fetching && this.props.tBodyObject.length === 0 && React.createElement(
                'th',
                { colSpan: Object.keys(this.props.tHead).length + 1 },
                this.props.txtSinResultados
              )
            )
          )
        );
      }
    }, {
      key: '_renderTHEADprint',
      value: function _renderTHEADprint(data, key) {
        if (!this.props.columnsTagPrint || this.props.columnsTagPrint[data.key] === undefined || this.props.columnsTagPrint[data.key]) {
          return React.createElement(
            'th',
            {
              key: key,
              style: this.props.tBodyStyle[data.key]
            },
            data.value,
            this.props.resize && this._renderResize()
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderTBODYprint',
      value: function _renderTBODYprint(data, key) {
        var _this5 = this;

        var tBody = [];
        this.state.tHead.map(function (v) {
          if (_this5.props.tBodyDefault[v.key] && (objectPath.get(data, v.key) === undefined || objectPath.get(data, v.key) === '')) {
            tBody.push({ key: v.key, value: _this5.props.tBodyDefault[v.key] });
            return v;
          }

          if (_this5.props.tBodyFormat[v.key]) {
            var valueData = _this5.props.tBodyFormat[v.key](data, key);
            tBody.push({ key: v.key, value: valueData });
            return v;
          }

          tBody.push({ key: v.key, value: objectPath.get(data, v.key) });
          return v;
        });

        return React.createElement(
          'tr',
          { key: key, className: this.props.tBodyStyleTR && this.props.tBodyStyleTR(data, key) },
          tBody.map(this._renderLinesPrint)
        );
      }
    }, {
      key: '_renderLinesPrint',
      value: function _renderLinesPrint(data, key) {
        if (!this.props.columnsTagPrint || this.props.columnsTagPrint[data.key] === undefined || this.props.columnsTagPrint[data.key]) {
          return React.createElement(
            'td',
            { key: key,
              style: this.props.tBodyStyle[data.key]
            },
            data.value
          );
        }
      }
    }, {
      key: '_renderPrintButton',
      value: function _renderPrintButton() {
        if (this.props.print && this.props.tBodyObject.length !== 0) {
          return React.createElement(
            'div',
            { style: { display: 'flex' } },
            !this.state.popupWindow && React.createElement(
              Button,
              {
                style: { flex: 1 },
                color: 'success',
                onClick: this.handlePrintOpen
              },
              React.createElement(Icon, { bootstrap: 'printer' }),
              ' Modo impresi\xF3n'
            ),
            this.state.popupWindow && React.createElement(
              Button,
              {
                style: { flex: 1 },
                color: 'dark',
                onClick: this.handlePrintClose
              },
              React.createElement(Icon, { bootstrap: 'close' }),
              ' Cerrar modo impresi\xF3n'
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderPrint',
      value: function _renderPrint() {
        var _this6 = this;

        if (this.state.popupWindow) {
          return React.createElement(
            PopoutWindow,
            {
              options: { width: '1200px', height: '600px' },
              title: this.state.popupWindowTitle,
              onClosing: this.handlePrintClose
            },
            function (childWindow) {
              return React.createElement(
                'wrapper',
                null,
                React.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/font-awesome.min.css',
                  crossOrigin: 'anonymous'
                }),
                React.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/simple-line-icons.css',
                  crossOrigin: 'anonymous'
                }),
                React.createElement('link', {
                  rel: 'stylesheet',
                  href: window.location.origin + '/css/style.css',
                  crossOrigin: 'anonymous'
                }),
                React.createElement(
                  Container,
                  { fluid: true, className: 'mt-h mb-h' },
                  React.createElement(
                    Row,
                    { className: 'hidden-print mb-h' },
                    React.createElement(
                      Col,
                      { className: 'col-12' },
                      React.createElement(
                        Button,
                        {
                          color: 'success',
                          onClick: function onClick() {
                            return childWindow.print();
                          }
                        },
                        React.createElement(Icon, { bootstrap: 'printer' }),
                        ' Imprimir'
                      ),
                      ' \xA0',
                      React.createElement(
                        Button,
                        {
                          style: { position: 'relative' },
                          color: 'success'
                        },
                        React.createElement(Icon, { awesome: 'file-excel-o' }),
                        ' Excel',
                        React.createElement(CSVLink, {
                          style: {
                            position: 'absolute',
                            top: 0,
                            bottom: 0,
                            left: 0,
                            right: 0
                          },
                          data: _this6.state.csv.data,
                          filename: _this6.state.csv.filename,
                          onClick: _this6.handleGenerateCSV
                        })
                      ),
                      ' \xA0',
                      React.createElement(
                        Button,
                        {
                          style: { position: 'relative' },
                          color: 'success'
                        },
                        React.createElement(Icon, { awesome: 'file-pdf-o' }),
                        ' PDF',
                        React.createElement('a', {
                          style: {
                            position: 'absolute',
                            top: 0,
                            bottom: 0,
                            left: 0,
                            right: 0
                          },
                          href: _this6.state.pdf.data,
                          download: _this6.state.pdf.filename,
                          onClick: function onClick() {
                            return _this6.handleGeneratePDF(childWindow);
                          }
                        })
                      )
                    )
                  ),
                  _this6.props._renderColumnsTagPrint(),
                  React.createElement(
                    Row,
                    null,
                    React.createElement(
                      Col,
                      { className: 'col-12' },
                      _this6._renderTablePrint()
                    )
                  ),
                  React.createElement(
                    Row,
                    { className: 'hidden-print mt-q' },
                    React.createElement(
                      Col,
                      { className: 'col-12' },
                      _this6.props._renderPageDetail()
                    )
                  )
                )
              );
            }
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderPrint: this._renderPrint,
          _renderPrintButton: this._renderPrintButton,
          popupWindow: this.state.popupWindow
        }, this.props, {
          tHead: this.state.tHead
        }));
      }
    }]);

    return withPrint;
  }(React.Component);

  withPrint.defaultProps = {
    tBodyStyle: {},
    tBodyDefault: {},
    tBodyFormat: {},
    tBodyFormatCSV: {}
  };

  withPrint.propTypes = {
    // withColumnsTag
    _renderColumnsTagPrint: PropTypes.func,
    columnsTagPrint: PropTypes.object,
    setColumnsTagPrint: PropTypes.func,
    // withPageDetail
    _renderPageDetail: PropTypes.func,

    resize: PropTypes.bool,
    tHead: PropTypes.object,
    striped: PropTypes.bool,
    condensed: PropTypes.bool,
    bordered: PropTypes.bool,
    tBodyObject: PropTypes.array,
    tBodyDefault: PropTypes.object,
    tBodyFormat: PropTypes.object,
    tBodyFormatCSV: PropTypes.object,
    tBodyStyle: PropTypes.object,
    tBodyStyleTR: PropTypes.func,
    fetching: PropTypes.bool,
    txtSinResultados: PropTypes.string,
    print: PropTypes.bool
  };

  return withPrint;
}

function withTable(Component$$1) {
  var withTable = function (_React$Component) {
    _inherits(withTable, _React$Component);

    function withTable(props) {
      _classCallCheck(this, withTable);

      var _this = _possibleConstructorReturn(this, (withTable.__proto__ || Object.getPrototypeOf(withTable)).call(this, props));

      _this.state = {};
      _this._renderTable = _this._renderTable.bind(_this);
      _this._renderTHEAD = _this._renderTHEAD.bind(_this);
      _this._renderTBODY = _this._renderTBODY.bind(_this);
      _this._renderLines = _this._renderLines.bind(_this);
      _this._renderTHEADbutton = _this._renderTHEADbutton.bind(_this);
      return _this;
    }

    _createClass(withTable, [{
      key: '_renderTHEAD',
      value: function _renderTHEAD(data, key) {
        var _this2 = this;

        if (!this.props.columnsTag || this.props.columnsTag[data.key] === undefined || this.props.columnsTag[data.key]) {
          if (this.props.sort && this.props.sort.fieldsSort[data.key]) {
            return React.createElement(
              OverlayTrigger,
              {
                key: key,
                placement: 'top',
                overlay: this.props._renderTooltip('Ordenar ' + (this.props.sort.fieldsSort[data.key] === 'asc' ? 'descendentemente' : 'ascendentemente'))
              },
              React.createElement(
                'th',
                {
                  style: this.props.tBodyStyle[data.key],
                  className: (this.props.sort.fieldsSort[data.key] ? this.props.cssClassName.enabled + ' ' : ' ') + (this.props.sort.init === data.key ? this.props.cssClassName.sorting + this.props.sort.fieldsSort[data.key] : ' '),
                  onClick: function onClick() {
                    if (_this2.props.sort.fieldsSort[data.key]) {
                      _this2.props.handlerSortOnChange(data.key);
                    }
                  }
                },
                data.value
              )
            );
          } else {
            return React.createElement(
              'th',
              {
                key: key,
                style: this.props.tBodyStyle[data.key]
              },
              data.value
            );
          }
        }
      }
    }, {
      key: '_renderTBODY',
      value: function _renderTBODY(data, key) {
        var _this3 = this;

        var tBody = [];
        this.props.tHead.map(function (v) {
          if (_this3.props.tBodyDefault[v.key] && (objectPath.get(data, v.key) === undefined || objectPath.get(data, v.key) === '')) {
            tBody.push({ key: v.key, value: _this3.props.tBodyDefault[v.key] });
            return v;
          }

          if (_this3.props.tBodyFormat[v.key]) {
            var valueData = _this3.props.tBodyFormat[v.key](data, key);
            tBody.push({ key: v.key, value: valueData });
            return v;
          }

          tBody.push({ key: v.key, value: objectPath.get(data, v.key) });
          return v;
        });

        return React.createElement(
          'tr',
          { key: key, className: this.props.tBodyStyleTR && this.props.tBodyStyleTR(data, key) },
          tBody.map(this._renderLines),
          this.props.footerButtonsAction && this.props.footerButtonsAction(data, key)
        );
      }
    }, {
      key: '_renderTHEADbutton',
      value: function _renderTHEADbutton() {
        return React.createElement(
          'th',
          { className: '' },
          'Acciones'
        );
      }
    }, {
      key: '_renderLines',
      value: function _renderLines(data, key) {
        if (!this.props.columnsTag || this.props.columnsTag[data.key] === undefined || this.props.columnsTag[data.key]) {
          return React.createElement(
            'td',
            { key: key,
              style: this.props.tBodyStyle[data.key]
            },
            data.value
          );
        }
      }
    }, {
      key: '_renderTable',
      value: function _renderTable() {
        var _this4 = this;

        return React.createElement(
          'table',
          {
            ref: function ref(refTable) {
              return !_this4.state.refTable && _this4.setState({ refTable: refTable });
            },
            className: 'table table-hover table-md' + (this.props.striped ? 'table-striped ' : '') + (this.props.condensed ? 'table-condensed ' : '') + (this.props.bordered ? 'table-bordered ' : ''),
            style: { position: 'relative' }
          },
          React.createElement(
            'thead',
            null,
            React.createElement(
              'tr',
              null,
              this.props.tHead.map(this._renderTHEAD),
              this.props.footerButtonsAction && this._renderTHEADbutton()
            )
          ),
          React.createElement(
            'tbody',
            null,
            !this.props.fetching && this.props.tBodyObject.map(this._renderTBODY)
          ),
          React.createElement(
            'tfoot',
            null,
            React.createElement(
              'tr',
              null,
              this.props.fetching && React.createElement(
                'th',
                { colSpan: this.props.tHead.length + 1 },
                'Cargando ...'
              ),
              !this.props.fetching && this.props.tBodyObject.length === 0 && React.createElement(
                'th',
                { colSpan: this.props.tHead.length + 1 },
                this.props.txtSinResultados
              )
            )
          )
        );
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderTable: this._renderTable,
          _renderTHEADbutton: this._renderTHEADbutton,
          refTable: this.state.refTable
        }, this.props));
      }
    }]);

    return withTable;
  }(React.Component);

  withTable.defaultProps = {
    tBodyStyle: {},
    tBodyDefault: {},
    tBodyFormat: {}
  };

  withTable.propTypes = {
    // withTooltip
    _renderTooltip: PropTypes.func,
    // withSort
    handlerSortOnChange: PropTypes.func,
    cssClassName: PropTypes.object,
    // withColumnsTag
    columnsTag: PropTypes.object,

    striped: PropTypes.bool,
    condensed: PropTypes.bool,
    bordered: PropTypes.bool,
    sort: PropTypes.object,
    tHead: PropTypes.array,
    tBodyObject: PropTypes.array,
    tBodyDefault: PropTypes.object,
    tBodyFormat: PropTypes.object,
    tBodyStyle: PropTypes.object,
    tBodyStyleTR: PropTypes.func,
    fetching: PropTypes.bool,
    txtSinResultados: PropTypes.string,
    footerButtonsAction: PropTypes.func
  };

  return withTable;
}

function withFixHeader(Component$$1) {
  var withFixHeader = function (_React$Component) {
    _inherits(withFixHeader, _React$Component);

    function withFixHeader(props) {
      _classCallCheck(this, withFixHeader);

      var _this = _possibleConstructorReturn(this, (withFixHeader.__proto__ || Object.getPrototypeOf(withFixHeader)).call(this, props));

      _this.state = {};
      _this._renderTHEADclone = _this._renderTHEADclone.bind(_this);
      _this._renderTableFixHeader = _this._renderTableFixHeader.bind(_this);
      return _this;
    }

    _createClass(withFixHeader, [{
      key: '_renderTHEADclone',
      value: function _renderTHEADclone(data, key) {
        if (key === 0) {
          this.countColumn = -1;
        }
        if (!this.props.columnsTag || this.props.columnsTag[data.key] === undefined || this.props.columnsTag[data.key]) {
          this.countColumn++;
          return React.createElement(
            'th',
            {
              key: key,
              style: _extends$1({}, this.props.tBodyStyle[data.key], { width: this.props.refTable.children[0].children[0].children[this.countColumn].offsetWidth })
            },
            data.value
          );
        }
      }
    }, {
      key: '_renderTableFixHeader',
      value: function _renderTableFixHeader() {
        var _this2 = this;

        return React.createElement(
          StickyContainer,
          null,
          React.createElement(
            'div',
            { style: { position: 'fixed', zIndex: 2 } },
            React.createElement(
              Sticky,
              { topOffset: -55, bottomOffset: -130 },
              function (_ref) {
                var isSticky = _ref.isSticky,
                    wasSticky = _ref.wasSticky,
                    style = _ref.style,
                    distanceFromTop = _ref.distanceFromTop,
                    distanceFromBottom = _ref.distanceFromBottom,
                    calculatedHeight = _ref.calculatedHeight;

                if (isSticky) {
                  return React.createElement(
                    'table',
                    {
                      className: 'table table-hover ' + (_this2.props.striped ? 'table-striped ' : '') + (_this2.props.condensed ? 'table-condensed ' : '') + (_this2.props.bordered ? 'table-bordered ' : ''),
                      style: _extends$1({}, style, { top: 55, background: 'white', width: _this2.props.refTable.children[0].children[0].offsetWidth })
                    },
                    React.createElement(
                      'thead',
                      null,
                      React.createElement(
                        'tr',
                        null,
                        _this2.props.tHead.map(_this2._renderTHEADclone),
                        _this2.props.footerButtonsAction && _this2.props._renderTHEADbutton()
                      )
                    )
                  );
                } else {
                  return React.createElement('div', null);
                }
              }
            )
          ),
          this.props._renderTable()
        );
      }
    }, {
      key: 'render',
      value: function render() {
        return React.createElement(Component$$1, _extends$1({
          _renderTableFixHeader: this._renderTableFixHeader
        }, this.props));
      }
    }]);

    return withFixHeader;
  }(React.Component);

  withFixHeader.defaultProps = {
    tBodyStyle: {}
  };

  withFixHeader.propTypes = {
    striped: PropTypes.string,
    condensed: PropTypes.string,
    bordered: PropTypes.string,
    columnsTag: PropTypes.object,
    tBodyStyle: PropTypes.object,
    footerButtonsAction: PropTypes.func,
    tHead: PropTypes.array,
    _renderTable: PropTypes.func,
    _renderTHEADbutton: PropTypes.func,
    refTable: PropTypes.any
  };

  return withFixHeader;
}

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'wrapper',
        {
          className: 'componentTable',
          style: _extends$1({ display: 'block' }, this.props.style)
        },
        this.props._renderMultiFilter(),
        (this.props.limit || this.props.filter) && React.createElement(
          Row,
          { className: 'table_filtros' },
          React.createElement(
            Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderLimit()
          ),
          React.createElement(
            Col,
            { className: 'col-12 mb-1', lg: '6' },
            this.props._renderFilter()
          )
        ),
        this.props._renderColumnsTag(),
        this.props.fixHeader && this.props._renderTableFixHeader(),
        !this.props.fixHeader && this.props._renderTable(),
        this.props.pagination && !this.props.fetching && React.createElement(
          Row,
          null,
          React.createElement(
            Col,
            { className: 'col-12', lg: '7' },
            this.props._renderPage()
          ),
          React.createElement(
            Col,
            { className: 'col-12', lg: '5' },
            this.props._renderPageDetail()
          )
        ),
        (this.props.print || this.props.otherOptions) && !this.props.fetching && React.createElement(
          Row,
          null,
          React.createElement(
            Col,
            { className: 'col-12' },
            this.props._renderPrintButton(),
            !this.props.popupWindow && this.props.otherOptions
          )
        ),
        this.props._renderPrint()
      );
    }
  }]);

  return Table;
}(Component);

Table.defaultProps = {};

Table.propTypes = {
  // withColumnsTag
  _renderColumnsTag: PropTypes.func,
  // withLimit
  _renderLimit: PropTypes.func,
  // withFilter
  _renderFilter: PropTypes.func,
  // withPage
  _renderPage: PropTypes.func,
  // withPageDetail
  _renderPageDetail: PropTypes.func,

  // withMultiFilter
  _renderMultiFilter: PropTypes.func,
  // withPrint
  _renderPrintButton: PropTypes.func,
  _renderPrint: PropTypes.func,
  // withTable
  _renderTable: PropTypes.func,
  // withFixHeader
  _renderTableFixHeader: PropTypes.func,

  style: PropTypes.object,
  filter: PropTypes.oneOfType([PropTypes.bool, PropTypes.object]),
  limit: PropTypes.oneOfType([PropTypes.bool, PropTypes.object]),
  pagination: PropTypes.object,
  fixHeader: PropTypes.bool,
  print: PropTypes.bool,
  otherOptions: PropTypes.any,
  popupWindow: PropTypes.bool,
  fetching: PropTypes.bool
};

var index = withTooltip(withColumnsTag(withSortLimitFilterPageFunctions(withLimit(withFilter(withSort(withPage(withPageDetail(withMultiFilter(withPrint(withTable(withFixHeader(Table))))))))))));

var TableCard = function (_Component) {
  _inherits(TableCard, _Component);

  function TableCard(props) {
    _classCallCheck(this, TableCard);

    var _this = _possibleConstructorReturn(this, (TableCard.__proto__ || Object.getPrototypeOf(TableCard)).call(this, props));

    _this.state = {
      rows: [],
      datalist: [],
      dropdownOpen: {},
      collapseOpen: {},
      cardView: { active: 1, size: 3 },
      menu: []
    };
    _this.toggleCollapse = _this.toggleCollapse.bind(_this);
    _this.toggleDropdown = _this.toggleDropdown.bind(_this);
    _this.handlerChangeCardView = _this.handlerChangeCardView.bind(_this);
    _this.calculoRows = _this.calculoRows.bind(_this);
    _this._renderDropdownItems = _this._renderDropdownItems.bind(_this);
    _this._renderRow = _this._renderRow.bind(_this);
    _this._renderCard = _this._renderCard.bind(_this);
    return _this;
  }

  _createClass(TableCard, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.datalist.length !== 0 && nextProps.datalist.length !== this.state.datalist.length) {
        var menu = [];
        var countMenuEnabled = 0;
        nextProps.datalist.map(function (value, key) {
          if (nextProps.menu && nextProps.menu.length !== 0) {
            nextProps.menu.map(function (m1, k1) {
              if (typeof m1 === 'function') {
                m1 = m1(value);
                if (Array.isArray(m1)) {
                  m1.map(function (m2, k2) {
                    if (m2.enabled || m2.enabled(value)) {
                      menu.push(m2);
                    }

                    if ((m2.enabled || m2.enabled(value)) && !m2.header) {
                      countMenuEnabled++;
                    }

                    return m2;
                  });
                } else {
                  if (m1.enabled || m1.enabled(value)) {
                    menu.push(m1);
                  }

                  if ((m1.enabled || m1.enabled(value)) && !m1.header) {
                    countMenuEnabled++;
                  }
                }
              } else {
                if (m1.enabled || m1.enabled(value)) {
                  menu.push(m1);
                }
                if ((m1.enabled || m1.enabled(value)) && !m1.header) {
                  countMenuEnabled++;
                }
              }
              return m1;
            });
          }
          return value;
        });

        if (!countMenuEnabled) {
          menu = [];
        }
        this.setState({
          menu: menu
        }, function () {
          _this2.calculoRows(nextProps.datalist);
        });
      }
      if (nextProps.fetching && this.state.datalist.length !== 0) {
        this.setState({
          rows: [],
          datalist: []
        });
      }
    }
  }, {
    key: 'toggleCollapse',
    value: function toggleCollapse(key) {
      this.setState({
        collapseOpen: merge(this.state.collapseOpen, _defineProperty$1({}, key, !this.state.collapseOpen[key]))
      });
    }
  }, {
    key: 'toggleDropdown',
    value: function toggleDropdown(key) {
      this.setState({
        dropdownOpen: merge(this.state.dropdownOpen, _defineProperty$1({}, key, !this.state.dropdownOpen[key]))
      });
    }
  }, {
    key: 'handlerChangeCardView',
    value: function handlerChangeCardView(cardView) {
      var _this3 = this;

      this.setState({ cardView: cardView }, function () {
        _this3.calculoRows(_this3.props.datalist);
      });
    }
  }, {
    key: 'calculoRows',
    value: function calculoRows(data) {
      var rows = [];
      var datalist = [];
      var perRow = void 0;
      if (this.props.size) {
        perRow = 12 / parseInt(this.props.size, 10);
      } else {
        perRow = 12 / parseInt(this.state.cardView.size, 10);
      }
      var count = 0;
      data.map(function (val, key) {
        if (key === 0) {
          rows.push('row');
        }

        if (count === 0) {
          datalist.push([]);
        }

        count++;
        if (perRow >= count) {
          datalist[datalist.length - 1].push(val);
        }

        if (perRow <= count) {
          if (data.length - 1 !== key) {
            rows.push('row');
          }
          count = 0;
        }
        return val;
      });
      this.setState({
        rows: rows,
        datalist: datalist
      });
    }
  }, {
    key: '_renderDropdownItems',
    value: function _renderDropdownItems(m, k, c) {
      if (typeof m === 'function') {
        m = m(c);
        if (Array.isArray(m)) {
          var opciones = [];
          m.map(function (menu, key) {
            if (menu.enabled === undefined || typeof menu.enabled === 'boolean' && menu.enabled === false || typeof menu.enabled === 'function' && !menu.enabled(c)) {
              return false;
            }

            opciones.push(React.createElement(
              DropdownItem,
              {
                key: k + '' + key,
                header: menu.header,
                divider: menu.divider,
                disabled: menu.disabled,
                style: { cursor: 'pointer' },
                onClick: function onClick() {
                  return menu.onClick(c);
                }
              },
              typeof menu.label === 'function' ? menu.label(c) : menu.label ? menu.label : 'Falta el label'
            ));
            return menu;
          });
          return opciones;
        }
      }
      if (m.enabled === undefined || typeof m.enabled === 'boolean' && m.enabled === false || typeof m.enabled === 'function' && !m.enabled(c)) {
        return false;
      }
      return React.createElement(
        DropdownItem,
        {
          key: k,
          header: m.header,
          divider: m.divider,
          disabled: m.disabled,
          style: { cursor: 'pointer' },
          onClick: function onClick() {
            return m.onClick(c);
          }
        },
        typeof m.label === 'function' ? m.label(c) : m.label ? m.label : 'Falta el label'
      );
    }
  }, {
    key: '_renderRow',
    value: function _renderRow(r, kr) {
      var _this4 = this;

      return React.createElement(
        Row,
        { key: kr },
        this.state.datalist[kr].map(function (c, kc) {
          return _this4._renderCard(c, kc, kr);
        })
      );
    }
  }, {
    key: '_renderCard',
    value: function _renderCard(c, kc, kr) {
      var _this5 = this;

      return React.createElement(
        Col,
        {
          key: kr + '' + kc,
          className: 'col-12'
          // lg={this.props.size}
          , style: { transition: '.3s all ease-in-out' },
          lg: this.state.cardView.size
        },
        React.createElement(
          'div',
          { className: 'card ' + (typeof this.props.color === 'string' ? 'card-inverse card-' + this.props.color : '') + (typeof this.props.color === 'function' ? this.props.color(c) : '')
          },
          React.createElement(
            'div',
            { className: 'card-block' },
            (this.props.icon || this.state.menu.length !== 0) && React.createElement(
              'div',
              { className: 'h1 text-muted text-right mb-2' },
              this.state.menu.length !== 0 && React.createElement(
                Dropdown,
                { isOpen: this.state.dropdownOpen[kr + '' + kc], toggle: function toggle() {
                    return _this5.toggleDropdown(kr + '' + kc);
                  } },
                React.createElement(
                  DropdownToggle,
                  { style: { float: 'left', fontSize: 20, cursor: 'pointer', left: -5, position: 'relative' }, tag: 'span' },
                  React.createElement(Icon, { bootstrap: 'options-vertical' })
                ),
                React.createElement(
                  DropdownMenu,
                  { style: { top: 30 } },
                  this.props.menu.map(function (m, k) {
                    return _this5._renderDropdownItems(m, k, c);
                  })
                )
              ),
              this.props.icon && _typeof(this.props.icon) === 'object' && React.createElement(Icon, this.props.icon),
              this.props.icon && typeof this.props.icon === 'function' && this.props.icon(c)
            ),
            this.props.body && this.props.body(c),
            this.props.titulo && typeof this.props.titulo === 'string' && !this.props.body && React.createElement(
              'div',
              { className: 'h4 mb-0',
                style: {
                  textOverflow: 'ellipsis',
                  overflow: 'hidden'
                }
              },
              this.props.titulo
            ),
            this.props.titulo && typeof this.props.titulo === 'function' && !this.props.body && React.createElement(
              'div',
              { className: 'h4 mb-0',
                style: {
                  textOverflow: 'ellipsis',
                  overflow: 'hidden'
                }
              },
              this.props.titulo(c)
            ),
            this.props.subtitulo && typeof this.props.subtitulo === 'string' && !this.props.body && React.createElement(
              'small',
              { className: 'text-muted text-uppercase font-weight-bold' },
              this.props.subtitulo
            ),
            this.props.subtitulo && typeof this.props.subtitulo === 'function' && !this.props.body && React.createElement(
              'small',
              { className: 'text-muted text-uppercase font-weight-bold' },
              this.props.subtitulo(c)
            ),
            this.props.progressBar && this.props.progressBar(c),
            this.props.verMas && this.props.verMas.enabled !== undefined && (typeof this.props.verMas.enabled === 'boolean' && this.props.verMas.enabled || typeof this.props.verMas.enabled === 'function' && this.props.verMas.enabled(c)) && React.createElement(
              'wrapper',
              { style: { marginTop: 7, display: 'block' } },
              React.createElement(
                Button,
                {
                  block: true,
                  size: 'sm',
                  color: (typeof this.props.verMas.btnColor === 'string' ? this.props.verMas.btnColor : '') + (typeof this.props.verMas.btnColor === 'function' ? this.props.verMas.btnColor(c) : ''),
                  onClick: function onClick() {
                    return _this5.toggleCollapse(kr + '' + kc);
                  }
                },
                React.createElement(Icon, { awesome: this.state.collapseOpen[kr + '' + kc] ? 'chevron-up' : 'chevron-down' })
              ),
              React.createElement(
                Collapse,
                { isOpen: this.state.collapseOpen[kr + '' + kc] },
                this.props.verMas.body && React.createElement(
                  'div',
                  { className: 'card-block row' },
                  this.props.verMas.body(c)
                ),
                this.props.verMas.footer && React.createElement(
                  'div',
                  { className: 'card-footer' },
                  this.props.verMas.footer(c)
                )
              )
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return React.createElement(
        'wrapper',
        null,
        !this.props.size && React.createElement(
          ButtonGroup,
          null,
          React.createElement(
            Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 1, size: 3 });
              },
              active: this.state.cardView.active === 1
            },
            React.createElement(Icon, { awesome: 'th' })
          ),
          React.createElement(
            Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 2, size: 6 });
              },
              active: this.state.cardView.active === 2
            },
            React.createElement(Icon, { awesome: 'th-large' })
          ),
          React.createElement(
            Button,
            {
              color: 'primary',
              onClick: function onClick() {
                return _this6.handlerChangeCardView({ active: 3, size: 12 });
              },
              active: this.state.cardView.active === 3
            },
            React.createElement(Icon, { awesome: 'th-list' })
          )
        ),
        !this.props.size && React.createElement('hr', null),
        !this.props.fetching && this.state.rows.map(this._renderRow),
        !this.props.fetching && this.props.datalist.length === 0 && React.createElement(
          'p',
          null,
          React.createElement(
            'strong',
            null,
            this.props.txtSinResultados
          )
        ),
        this.props.fetching && React.createElement(
          'p',
          null,
          React.createElement(
            'strong',
            null,
            'Cargando ...'
          )
        )
      );
    }
  }]);

  return TableCard;
}(Component);

TableCard.defaultProps = {
  datalist: [],
  menu: []
};

TableCard.propTypes = {
  size: PropTypes.string,
  datalist: PropTypes.array,
  menu: PropTypes.array,
  icon: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
  color: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  titulo: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  subtitulo: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  body: PropTypes.func,
  progressBar: PropTypes.func,
  verMas: PropTypes.object,
  txtSinResultados: PropTypes.string,
  fetching: PropTypes.bool
};

var objectWithoutProperties = createCommonjsModule(function (module, exports) {
"use strict";

exports.__esModule = true;

exports.default = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};
});

var _objectWithoutProperties = unwrapExports(objectWithoutProperties);

function _renderTooltip(text) {
  return React.createElement(
    Tooltip,
    { id: 'tooltip' },
    React.createElement(
      'strong',
      null,
      text
    )
  );
}

var FieldInputMask = function FieldInputMask(_ref) {
  var label = _ref.label,
      input = _ref.input,
      autocomplete = _ref.autocomplete,
      componentClass = _ref.componentClass,
      byField = _ref.byField,
      onSelect = _ref.onSelect,
      stylesInput = _ref.stylesInput,
      props = _objectWithoutProperties(_ref, ['label', 'input', 'autocomplete', 'componentClass', 'byField', 'onSelect', 'stylesInput']);

  return React.createElement(InputMask, _extends$1({
    id: label ? label.replace(/ /g, '') : input.name.replace(/ /g, ''),
    className: 'form-control',
    autoComplete: autocomplete ? 'on' : 'off',
    type: componentClass,
    style: stylesInput,
    value: input ? !byField ? input.value : input.value[byField] : null,
    onChange: function onChange(event) {
      input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
    } //eslint-disable-line
    , onBlur: input && input.onBlur,
    onFocus: input && input.onFocus
  }, props));
};

FieldInputMask.defaultProps = {
  autocomplete: false
};

FieldInputMask.propTypes = {
  label: PropTypes.string,
  byField: PropTypes.any,
  componentClass: PropTypes.string,
  input: PropTypes.object,
  onSelect: PropTypes.func,
  autocomplete: PropTypes.bool,
  stylesInput: PropTypes.object
};

var FieldInput = function FieldInput(_ref2) {
  var label = _ref2.label,
      input = _ref2.input,
      autocomplete = _ref2.autocomplete,
      componentClass = _ref2.componentClass,
      byField = _ref2.byField,
      onSelect = _ref2.onSelect,
      stylesInput = _ref2.stylesInput,
      props = _objectWithoutProperties(_ref2, ['label', 'input', 'autocomplete', 'componentClass', 'byField', 'onSelect', 'stylesInput']);

  return React.createElement(Input, _extends$1({
    id: label ? label.replace(/ /g, '') : input.name.replace(/ /g, ''),
    autoComplete: autocomplete ? 'on' : 'off',
    type: componentClass,
    style: stylesInput,
    value: input ? !byField ? input.value : input.value[byField] : null,
    onChange: function onChange(event) {
      input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
    } //eslint-disable-line
    , onBlur: input && input.onBlur,
    onFocus: input && input.onFocus
  }, props));
};

FieldInput.defaultProps = {
  autocomplete: false
};

FieldInput.propTypes = {
  label: PropTypes.string,
  byField: PropTypes.any,
  componentClass: PropTypes.string,
  input: PropTypes.object,
  onSelect: PropTypes.func,
  autocomplete: PropTypes.bool,
  stylesInput: PropTypes.object
};

var FieldGroup = function FieldGroup(_ref3) {
  var horizontal = _ref3.horizontal,
      required = _ref3.required,
      meta = _ref3.meta,
      info = _ref3.info,
      className = _ref3.className,
      props = _objectWithoutProperties(_ref3, ['horizontal', 'required', 'meta', 'info', 'className']);

  return React.createElement(
    FormGroup,
    {
      color: meta && !meta.touched ? '' : meta && meta.valid ? '' : 'danger',
      row: horizontal ? true : undefined,
      className: className
    },
    props.label && React.createElement(
      Label,
      {
        'for': props.label.replace(/ /g, ''),
        xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
        sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
        md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
        lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
        xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
      },
      props.label,
      ' ',
      required && React.createElement(
        'span',
        { className: 'text-danger' },
        '*'
      ),
      '\xA0',
      info && info !== '' && React.createElement(
        OverlayTrigger,
        {
          placement: 'right',
          overlay: _renderTooltip(info)
        },
        React.createElement(
          'wrapper',
          null,
          React.createElement(Icon, { bootstrap: 'info' })
        )
      )
    ),
    horizontal && React.createElement(
      Col,
      {
        xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
        sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
        md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
        lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
        xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
      },
      props.mask && FieldInputMask(props),
      !props.mask && FieldInput(props),
      meta && meta.touched && meta.error && React.createElement(
        FormFeedback,
        null,
        meta.error
      )
    ),
    !horizontal && props.mask && FieldInputMask(props),
    !horizontal && !props.mask && FieldInput(props),
    !horizontal && meta && meta.touched && meta.error && React.createElement(
      FormFeedback,
      null,
      meta.error
    )
  );
};

FieldGroup.defaultProps = {};

FieldGroup.propTypes = {
  label: PropTypes.string,
  mask: PropTypes.string,
  required: PropTypes.bool,
  meta: PropTypes.object,
  horizontal: PropTypes.object,
  info: PropTypes.string,
  className: PropTypes.string
};

function _renderTooltip$1(text) {
  return React.createElement(
    Tooltip,
    { id: 'tooltip' },
    React.createElement(
      'strong',
      null,
      text
    )
  );
}

var FieldInputMask$1 = function FieldInputMask(_ref) {
  var autocomplete = _ref.autocomplete,
      className = _ref.className,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      label = _ref.label,
      byField = _ref.byField,
      componentClass = _ref.componentClass,
      input = _ref.input,
      onSelect = _ref.onSelect,
      stylesInput = _ref.stylesInput,
      props = _objectWithoutProperties(_ref, ['autocomplete', 'className', 'iconLeft', 'iconRight', 'label', 'byField', 'componentClass', 'input', 'onSelect', 'stylesInput']);

  return React.createElement(
    InputGroup,
    { className: className },
    iconLeft && React.createElement(
      InputGroupAddon,
      null,
      iconLeft.bootstrap || iconLeft.awesome ? React.createElement(Icon, {
        bootstrap: iconLeft.bootstrap,
        awesome: iconLeft.awesome,
        style: iconLeft.style
      }) : iconLeft()
    ),
    React.createElement(InputMask, _extends$1({
      id: label && label.replace(/ /g, ''),
      className: 'form-control',
      autoComplete: autocomplete ? 'on' : 'off',
      type: componentClass,
      style: stylesInput,
      value: input ? !byField ? input.value : input.value[byField] : null,
      onChange: function onChange(event) {
        input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
      } //eslint-disable-line
      , onBlur: input && input.onBlur,
      onFocus: input && input.onFocus
    }, props)),
    iconRight && React.createElement(
      InputGroupAddon,
      null,
      (typeof iconRight === 'undefined' ? 'undefined' : _typeof(iconRight)) === 'object' ? React.createElement(Icon, {
        bootstrap: iconRight.bootstrap,
        awesome: iconRight.awesome,
        style: iconRight.style
      }) : iconRight()
    )
  );
};

FieldInputMask$1.defaultProps = {
  autocomplete: false
};

FieldInputMask$1.propTypes = {
  label: PropTypes.string,
  byField: PropTypes.any,
  componentClass: PropTypes.string,
  input: PropTypes.object,
  meta: PropTypes.object,
  onSelect: PropTypes.func,
  className: PropTypes.string,
  iconLeft: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  iconRight: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  autocomplete: PropTypes.bool,
  stylesInput: PropTypes.object
};

var FieldInput$1 = function FieldInput(_ref2) {
  var autocomplete = _ref2.autocomplete,
      className = _ref2.className,
      iconLeft = _ref2.iconLeft,
      iconRight = _ref2.iconRight,
      label = _ref2.label,
      byField = _ref2.byField,
      componentClass = _ref2.componentClass,
      input = _ref2.input,
      onSelect = _ref2.onSelect,
      stylesInput = _ref2.stylesInput,
      props = _objectWithoutProperties(_ref2, ['autocomplete', 'className', 'iconLeft', 'iconRight', 'label', 'byField', 'componentClass', 'input', 'onSelect', 'stylesInput']);

  return React.createElement(
    InputGroup,
    { className: className },
    iconLeft && React.createElement(
      InputGroupAddon,
      null,
      iconLeft.bootstrap || iconLeft.awesome ? React.createElement(Icon, {
        bootstrap: iconLeft.bootstrap,
        awesome: iconLeft.awesome,
        style: iconLeft.style
      }) : iconLeft()
    ),
    React.createElement(Input, _extends$1({
      id: label && label.replace(/ /g, ''),
      autoComplete: autocomplete ? 'on' : 'off',
      type: componentClass,
      style: stylesInput,
      value: input ? !byField ? input.value : input.value[byField] : null,
      onChange: function onChange(event) {
        input.onChange(event.target.value);onSelect ? onSelect(event.target.value !== '' ? { id: parseInt(event.target.value, 10) } : '') : null;
      } //eslint-disable-line
      , onBlur: input && input.onBlur,
      onFocus: input && input.onFocus
    }, props)),
    iconRight && React.createElement(
      InputGroupAddon,
      null,
      (typeof iconRight === 'undefined' ? 'undefined' : _typeof(iconRight)) === 'object' ? React.createElement(Icon, {
        bootstrap: iconRight.bootstrap,
        awesome: iconRight.awesome,
        style: iconRight.style
      }) : iconRight()
    )
  );
};

FieldInput$1.defaultProps = {
  autocomplete: false
};

FieldInput$1.propTypes = {
  label: PropTypes.string,
  byField: PropTypes.any,
  componentClass: PropTypes.string,
  input: PropTypes.object,
  meta: PropTypes.object,
  onSelect: PropTypes.func,
  className: PropTypes.string,
  iconLeft: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  iconRight: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),
  autocomplete: PropTypes.bool,
  stylesInput: PropTypes.object
};

var FieldGroupIcon = function FieldGroupIcon(_ref3) {
  var horizontal = _ref3.horizontal,
      required = _ref3.required,
      meta = _ref3.meta,
      info = _ref3.info,
      className = _ref3.className,
      props = _objectWithoutProperties(_ref3, ['horizontal', 'required', 'meta', 'info', 'className']);

  return React.createElement(
    FormGroup,
    {
      color: meta && !meta.touched ? '' : meta && meta.valid ? '' : 'danger',
      row: horizontal ? true : undefined,
      className: className
    },
    props.label && React.createElement(
      Label,
      {
        'for': props.label.replace(/ /g, ''),
        xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
        sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
        md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
        lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
        xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
      },
      props.label,
      ' ',
      required && React.createElement(
        'span',
        { className: 'text-danger' },
        '*'
      ),
      '\xA0',
      info && info !== '' && React.createElement(
        OverlayTrigger,
        {
          placement: 'right',
          overlay: _renderTooltip$1(info)
        },
        React.createElement(
          'wrapper',
          null,
          React.createElement(Icon, { bootstrap: 'info' })
        )
      )
    ),
    horizontal && React.createElement(
      Col,
      {
        xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
        sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
        md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
        lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
        xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
      },
      props.mask && FieldInputMask$1(props),
      !props.mask && FieldInput$1(props),
      meta && meta.touched && meta.error && React.createElement(
        FormFeedback,
        null,
        meta.error
      )
    ),
    !horizontal && props.mask && FieldInputMask$1(props),
    !horizontal && !props.mask && FieldInput$1(props),
    !horizontal && meta && meta.touched && meta.error && React.createElement(
      FormFeedback,
      null,
      meta.error
    )
  );
};

FieldGroupIcon.defaultProps = {};

FieldGroupIcon.propTypes = {
  label: PropTypes.string,
  mask: PropTypes.string,
  required: PropTypes.bool,
  meta: PropTypes.object,
  horizontal: PropTypes.object,
  info: PropTypes.string,
  className: PropTypes.string
};

var FieldGroupFile = function (_Component) {
  _inherits(FieldGroupFile, _Component);

  function FieldGroupFile(props) {
    _classCallCheck(this, FieldGroupFile);

    var _this = _possibleConstructorReturn(this, (FieldGroupFile.__proto__ || Object.getPrototypeOf(FieldGroupFile)).call(this, props));

    var file = false;
    var restore = false;
    if (props.input) {
      file = props.input.value;
      restore = props.input.value;
    }

    _this.state = {
      file: file,
      restore: restore,
      btnRestore: false
    };
    _this.onDrop = _this.onDrop.bind(_this);
    _this.deleteFILE = _this.deleteFILE.bind(_this);
    _this.restoreFILE = _this.restoreFILE.bind(_this);
    return _this;
  }

  _createClass(FieldGroupFile, [{
    key: 'onDrop',
    value: function onDrop(file, reject) {
      var _this2 = this;

      var promise = new Promise(function (resolve, reject) {
        var reader = new FileReader(); // eslint-disable-line
        reader.readAsDataURL(file[0]);
        reader.onload = function () {
          if (reader.result) {
            resolve(reader.result);
          } else {
            reject(Error('Failed converting to base64'));
          }
        };
      });
      promise.then(function (result) {
        _this2.setState({
          file: {
            fileName: file[0].name,
            fileSize: file[0].size,
            fileType: file[0].type,
            base64: result.split(',')[1]
          },
          btnRestore: true
        }, function () {
          _this2.props.input && _this2.props.input.onChange(_this2.state.file);
          _this2.props.onSelect && _this2.props.onSelect(_this2.state.file);
        });
      }, function (err) {
        console.log(err);
      });
    }
  }, {
    key: 'deleteFILE',
    value: function deleteFILE(e) {
      var _this3 = this;

      e.stopPropagation();
      this.setState({
        file: false,
        btnRestore: true
      }, function () {
        _this3.props.input && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur('');
        _this3.props.onSelect && _this3.props.onSelect('');
      });
    }
  }, {
    key: 'restoreFILE',
    value: function restoreFILE(e) {
      var _this4 = this;

      e.stopPropagation();
      this.setState({
        file: this.state.restore,
        btnRestore: false
      }, function () {
        _this4.props.input && _this4.props.input.onChange(_this4.state.file);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: '_renderFieldInput',
    value: function _renderFieldInput(_ref) {
      var autocomplete = _ref.autocomplete,
          icon = _ref.icon,
          label = _ref.label,
          input = _ref.input,
          stylesInput = _ref.stylesInput,
          props = _objectWithoutProperties(_ref, ['autocomplete', 'icon', 'label', 'input', 'stylesInput']);

      return React.createElement(
        InputGroup,
        null,
        React.createElement(
          OverlayTrigger,
          {
            placement: 'top',
            overlay: this._renderTooltip('Agregar archivo')
          },
          React.createElement(
            InputGroupAddon,
            {
              style: {
                cursor: 'pointer',
                overflow: 'hidden',
                position: 'relative'
              }
            },
            React.createElement(Dropzone, {
              onDrop: this.onDrop,
              multiple: false,
              accept: this.props.accept,
              name: this.props.name,
              style: {
                position: 'absolute',
                top: 0,
                left: 0,
                right: 0,
                bottom: 0
              }
            }),
            (icon.bootstrap || icon.awesome) && React.createElement(Icon, {
              bootstrap: icon.bootstrap,
              awesome: icon.awesome,
              style: icon.style
            })
          )
        ),
        React.createElement(Input, {
          id: label && label.replace(/ /g, ''),
          autoComplete: autocomplete ? 'on' : 'off',
          type: 'text',
          style: stylesInput,
          value: this.state.file ? this.state.file.fileName : '',
          readOnly: true
        }),
        this.state.restore && this.state.btnRestore && React.createElement(
          InputGroupAddon,
          { style: { display: 'flex', padding: 0 } },
          React.createElement(
            OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Restaurar original')
            },
            React.createElement(
              Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'info',
                onClick: this.restoreFILE
              },
              React.createElement(Icon, { bootstrap: 'action-undo' })
            )
          )
        ),
        this.state.file && this.state.file.uri && React.createElement(
          InputGroupAddon,
          { style: { display: 'flex', padding: 0, position: 'relative' } },
          React.createElement(
            OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Descargar')
            },
            React.createElement(
              Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'success',
                onClick: function onClick(e) {
                  return e.stopPropagation();
                }
              },
              React.createElement('a', {
                href: this.state.file.uri,
                download: this.state.file.fileName,
                style: {
                  position: 'absolute',
                  top: 0,
                  bottom: 0,
                  left: 0,
                  right: 0
                }
              }),
              React.createElement(Icon, { bootstrap: 'cloud-download' })
            )
          )
        ),
        this.state.file && React.createElement(
          InputGroupAddon,
          { style: { display: 'flex', padding: 0 } },
          React.createElement(
            OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Eliminar')
            },
            React.createElement(
              Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'danger',
                onClick: this.deleteFILE
              },
              React.createElement(Icon, { bootstrap: 'trash' })
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          horizontal = _props.horizontal,
          required = _props.required,
          meta = _props.meta,
          info = _props.info,
          className = _props.className,
          props = _objectWithoutProperties(_props, ['horizontal', 'required', 'meta', 'info', 'className']);

      return React.createElement(
        FormGroup,
        {
          color: meta && !meta.touched ? '' : meta && meta.valid ? '' : 'danger',
          row: horizontal ? true : undefined,
          className: className
        },
        props.label && React.createElement(
          Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          ),
          '\xA0',
          info && info !== '' && React.createElement(
            OverlayTrigger,
            {
              placement: 'right',
              overlay: this._renderTooltip(info)
            },
            React.createElement(
              'wrapper',
              null,
              React.createElement(Icon, { bootstrap: 'info' })
            )
          )
        ),
        horizontal && React.createElement(
          Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderFieldInput(props),
          meta && meta.touched && meta.error && React.createElement(
            FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderFieldInput(props),
        !horizontal && meta && meta.touched && meta.error && React.createElement(
          FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldGroupFile;
}(Component);

FieldGroupFile.defaultProps = {
  autocomplete: false,
  icon: { bootstrap: 'doc' }
};

FieldGroupFile.propTypes = {
  accept: PropTypes.string,
  name: PropTypes.string,
  input: PropTypes.object,
  meta: PropTypes.object,
  className: PropTypes.string,
  label: PropTypes.string,
  required: PropTypes.bool,
  horizontal: PropTypes.bool,
  info: PropTypes.string,
  onSelect: PropTypes.func
};

var FieldSwitch = function (_Component) {
  _inherits(FieldSwitch, _Component);

  function FieldSwitch(props) {
    _classCallCheck(this, FieldSwitch);

    var _this = _possibleConstructorReturn(this, (FieldSwitch.__proto__ || Object.getPrototypeOf(FieldSwitch)).call(this, props));

    _this.state = {
      value: props.input.value !== '' && props.input.value !== false
    };
    _this.handlerChange = _this.handlerChange.bind(_this);
    return _this;
  }

  _createClass(FieldSwitch, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value !== '' && nextProps.input.value !== this.state.value) {
        this.setState({
          value: nextProps.input.value
        });
      }
    }
  }, {
    key: 'handlerChange',
    value: function handlerChange(e) {
      var _this2 = this;

      this.setState({
        value: e.currentTarget.value === 'false'
      }, function () {
        _this2.props.input.onChange && _this2.props.input.onChange(_this2.state.value);
        _this2.props.onChanged && _this2.props.onChanged(_this2.state.value);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          disabled = _props.disabled,
          size = _props.size,
          style = _props.style,
          label = _props.label,
          horizontal = _props.horizontal,
          right = _props.right,
          withText = _props.withText,
          pill = _props.pill,
          color = _props.color,
          outline = _props.outline,
          outlineAlt = _props.outlineAlt,
          onChanged = _props.onChanged,
          input = _props.input,
          meta = _props.meta,
          props = _objectWithoutProperties(_props, ['disabled', 'size', 'style', 'label', 'horizontal', 'right', 'withText', 'pill', 'color', 'outline', 'outlineAlt', 'onChanged', 'input', 'meta']); // eslint-disable-line


      return React.createElement(
        FormGroup,
        {
          check: true,
          className: right && 'overflow-hidden',
          style: style
        },
        !horizontal && label && React.createElement(
          'wrapper',
          null,
          React.createElement(
            Label,
            { 'for': label.replace(/ /g, '') },
            label
          ),
          React.createElement('br', null)
        ),
        horizontal && label && React.createElement(
          'wrapper',
          null,
          React.createElement(
            'span',
            { className: right ? 'pull-left' : '', style: { maxWidth: right ? '75%' : 'initial' } },
            label
          ),
          !right && React.createElement(
            'wrapper',
            null,
            '\xA0\xA0'
          )
        ),
        React.createElement(
          'label',
          {
            className: 'switch' + (right ? ' pull-right' : '') + (withText ? ' switch-text' : ' switch-default') + (pill ? ' switch-pill' : '') + (color ? ' switch-' + color : '') + (outline ? '-outline' : '') + (outlineAlt ? '-outline-alt' : '') + (size ? ' switch-' + size : ''),
            style: { cursor: disabled ? 'not-allowed' : '' }
          },
          React.createElement(Input, {
            className: 'switch-input',
            type: props.type,
            checked: this.state.value,
            value: this.state.value,
            onChange: this.handlerChange,
            disabled: disabled
          }),
          React.createElement('span', {
            className: 'switch-label' + (disabled ? ' switch-disabled' : ''),
            'data-on': withText && withText.on,
            'data-off': withText && withText.off }),
          React.createElement('span', { className: 'switch-handle' })
        )
      );
    }
  }]);

  return FieldSwitch;
}(Component);

FieldSwitch.defaultProps = {
  color: 'primary',
  size: 'md',
  disabled: false
};

FieldSwitch.propTypes = {
  label: PropTypes.string,
  right: PropTypes.bool,
  withText: PropTypes.object,
  pill: PropTypes.bool,
  color: PropTypes.string,
  outline: PropTypes.bool,
  outlineAlt: PropTypes.bool,
  input: PropTypes.object,
  meta: PropTypes.object,
  horizontal: PropTypes.bool,
  style: PropTypes.object,
  size: PropTypes.string,
  disabled: PropTypes.bool,
  onChanged: PropTypes.func
};

var FieldCaptcha = function (_Component) {
  _inherits(FieldCaptcha, _Component);

  function FieldCaptcha(props) {
    _classCallCheck(this, FieldCaptcha);

    var _this = _possibleConstructorReturn(this, (FieldCaptcha.__proto__ || Object.getPrototypeOf(FieldCaptcha)).call(this, props));

    _this.state = {
      captcha: null,
      loadImg: false,
      endpoint: ''
    };
    _this.reloadCaptcha = _this.reloadCaptcha.bind(_this);
    _this._renderIMG = _this._renderIMG.bind(_this);
    _this._renderInput = _this._renderInput.bind(_this);
    return _this;
  }

  _createClass(FieldCaptcha, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.endpoint && nextProps.captcha !== this.state.captcha) {
        this.setState({
          captcha: nextProps.captcha
        });
        this.reloadCaptcha(nextProps.captcha);
      }
    }
  }, {
    key: 'randomNumber',
    value: function randomNumber() {
      return Math.floor(Math.random() * 1000 + 1);
    }
  }, {
    key: 'reloadCaptcha',
    value: function reloadCaptcha(captcha) {
      var _this2 = this;

      this.setState({
        loadImg: false
      }, function () {
        _this2.setState({
          loadImg: true,
          endpoint: _this2.props.endpoint + '?random=' + captcha
        });
      });
    }
  }, {
    key: '_renderIMG',
    value: function _renderIMG() {
      return React.createElement('img', {
        style: {
          marginTop: '-1.5rem',
          WebkitUserSelect: 'none',
          KhtmlUserSelect: 'none',
          MozUserSelect: 'none',
          OUserSelect: 'none',
          msUserSelect: 'none',
          userSelect: 'none'
        },
        src: this.state.endpoint,
        alt: ''
      });
    }
  }, {
    key: '_renderInput',
    value: function _renderInput() {
      var _this3 = this;

      var _props = this.props,
          autocomplete = _props.autocomplete,
          className = _props.className,
          label = _props.label,
          byField = _props.byField,
          componentClass = _props.componentClass,
          input = _props.input,
          onSelect = _props.onSelect,
          captcha = _props.captcha,
          meta = _props.meta,
          endpoint = _props.endpoint,
          props = _objectWithoutProperties(_props, ['autocomplete', 'className', 'label', 'byField', 'componentClass', 'input', 'onSelect', 'captcha', 'meta', 'endpoint']); // eslint-disable-line


      return React.createElement(
        InputGroup,
        { className: className },
        React.createElement(Input, _extends$1({
          id: label && label.replace(/ /g, ''),
          autoComplete: autocomplete ? 'on' : 'off',
          type: componentClass,
          value: input ? !byField ? input.value : input.value[byField] : null,
          onChange: function onChange(event) {
            input.onChange(event.target.value);onSelect ? onSelect(event.target.value) : null;
          } //eslint-disable-line
          , onBlur: input && input.onBlur,
          onFocus: input && input.onFocus
        }, props)),
        React.createElement(
          InputGroupAddon,
          {
            onClick: function onClick() {
              return _this3.reloadCaptcha(_this3.randomNumber());
            },
            style: { cursor: 'pointer' }
          },
          React.createElement(Icon, {
            bootstrap: 'refresh'
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          horizontal = _props2.horizontal,
          required = _props2.required,
          meta = _props2.meta,
          props = _objectWithoutProperties(_props2, ['horizontal', 'required', 'meta']);

      return React.createElement(
        FormGroup,
        {
          color: !meta.touched ? '' : meta.valid ? '' : 'danger',
          row: horizontal ? true : undefined
        },
        props.label && React.createElement(
          Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        horizontal && React.createElement(
          Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderInput(),
          this.state.loadImg && this._renderIMG(),
          meta.touched && meta.error && React.createElement(
            FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderInput(),
        !horizontal && this.state.loadImg && this._renderIMG(),
        !horizontal && meta.touched && meta.error && React.createElement(
          FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldCaptcha;
}(Component);

FieldCaptcha.defaultProps = {
  autocomplete: false
};

FieldCaptcha.propTypes = {
  label: PropTypes.string,
  mask: PropTypes.string,
  required: PropTypes.bool,
  meta: PropTypes.object,
  horizontal: PropTypes.object,
  byField: PropTypes.any,
  componentClass: PropTypes.string,
  input: PropTypes.object,
  onSelect: PropTypes.func,
  className: PropTypes.string,
  autocomplete: PropTypes.bool,
  endpoint: PropTypes.string,
  captcha: PropTypes.number
};

var FieldBusqueda = function (_Component) {
  _inherits(FieldBusqueda, _Component);

  function FieldBusqueda(props) {
    _classCallCheck(this, FieldBusqueda);

    var _this = _possibleConstructorReturn(this, (FieldBusqueda.__proto__ || Object.getPrototypeOf(FieldBusqueda)).call(this, props));

    var value = '';
    if (props.input.value && props.datalist[0]) {
      value = props.itemValueShow ? typeof props.itemValueShow === 'function' ? props.itemValueShow(props.input.value) : objectPath.get(props.datalist[0], props.itemValue) !== undefined ? objectPath.get(props.datalist[0], props.itemValueShow) : typeof props.itemValueDefault === 'function' ? props.itemValueDefault(props.datalist[0]) : props.itemValueDefault : typeof props.itemValue === 'function' ? props.itemValue(props.datalist[0]) : objectPath.get(props.datalist[0], props.itemValue) !== undefined ? objectPath.get(props.datalist[0], props.itemValue) : typeof props.itemValueDefault === 'function' ? props.itemValueDefault(props.datalist[0]) : props.itemValueDefault;
    }

    var searchDebounce = 0;
    if (!props.withButton) {
      searchDebounce = props.searchDebounce;
    }

    _this.state = {
      dropdownOpen: false,
      value: value,
      firstSearch: false,
      searchDebounce: searchDebounce
    };
    _this.toggle = _this.toggle.bind(_this);
    _this._renderInput = _this._renderInput.bind(_this);
    _this._renderResult = _this._renderResult.bind(_this);
    _this.handlerChangeSearch = _this.handlerChangeSearch.bind(_this);
    _this.handlerSelectItem = _this.handlerSelectItem.bind(_this);
    _this.handlerKeyPress = _this.handlerKeyPress.bind(_this);
    _this.handlerClickSearch = _this.handlerClickSearch.bind(_this);
    _this.handleCleanBuscador = _this.handleCleanBuscador.bind(_this);
    return _this;
  }

  _createClass(FieldBusqueda, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.fieldArray && !this.props.noRescue && this.props.input && this.props.input.value) {
        this.props.input.onChange && this.props.input.onChange({ itemKey: this.props.input.value, itemValue: this.state.value });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input && nextProps.input.value === '') {
        this.setState({
          value: ''
        });
      } else if (nextProps.input && nextProps.input.value !== '' && _typeof(nextProps.input.value) === 'object' && nextProps.input.value.itemValue && nextProps.input.value.itemValue !== this.state.value) {
        this.setState({
          value: nextProps.input.value.itemValue
        });
      }
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      var _this2 = this;

      this.setState({
        dropdownOpen: !this.state.dropdownOpen
      }, function () {
        _this2.inputSearch.focus();
      });
    }
  }, {
    key: 'handlerChangeSearch',
    value: function handlerChangeSearch(value) {
      var props = this.props;
      window.clearTimeout(this.timeoutField);
      this.timeoutField = window.setTimeout(function () {
        props.onSearch(value);
      }, this.state.searchDebounce);
    }
  }, {
    key: 'handlerSelectItem',
    value: function handlerSelectItem(value) {
      var _this3 = this;

      var itemValueShow = this.props.itemValueShow ? typeof this.props.itemValueShow === 'function' ? this.props.itemValueShow(value) : objectPath.get(value, this.props.itemValue) !== undefined ? objectPath.get(value, this.props.itemValueShow) : typeof this.props.itemValueDefault === 'function' ? this.props.itemValueDefault(value) : this.props.itemValueDefault : typeof this.props.itemValue === 'function' ? this.props.itemValue(value) : objectPath.get(value, this.props.itemValue) !== undefined ? objectPath.get(value, this.props.itemValue) : typeof this.props.itemValueDefault === 'function' ? this.props.itemValueDefault(value) : this.props.itemValueDefault;
      this.setState({
        value: itemValueShow,
        dropdownOpen: false
      }, function () {
        if (_this3.props.fieldArray) {
          _this3.props.input && _this3.props.input.onChange && _this3.props.input.onChange({ itemKey: objectPath.get(value, _this3.props.itemKey), itemValue: objectPath.get(value, _this3.props.itemValue) });
        } else {
          _this3.props.input && _this3.props.input.onChange && _this3.props.input.onChange(objectPath.get(value, _this3.props.itemKey));
        }
        _this3.props.input && _this3.props.input.onBlur && _this3.props.input.onBlur();
        _this3.props.onChanged && _this3.props.onChanged(objectPath.get(value, _this3.props.itemKey));
      });
    }
  }, {
    key: 'handlerKeyPress',
    value: function handlerKeyPress(e) {
      if (e.which === 13 || e.charCode === 13 || e.keyCode === 13) {
        e.preventDefault();
        if (this.props.withButton) {
          this.handlerChangeSearch(e.currentTarget.value);
        }
      }
    }
  }, {
    key: 'handlerClickSearch',
    value: function handlerClickSearch(e) {
      e.preventDefault();
      this.handlerChangeSearch(this.inputSearch.value);
    }
  }, {
    key: 'handleCleanBuscador',
    value: function handleCleanBuscador() {
      var _this4 = this;

      this.setState({
        value: '',
        dropdownOpen: false
      }, function () {
        _this4.props.input && _this4.props.input.onChange && _this4.props.input.onChange('');
        _this4.props.input && _this4.props.input.onBlur && _this4.props.input.onBlur('');
        _this4.props.onChanged && _this4.props.onChanged('');
      });
    }
  }, {
    key: '_renderResult',
    value: function _renderResult(r, k) {
      var _this5 = this;

      return React.createElement(
        'li',
        { key: k, role: 'presentation' },
        React.createElement(
          'a',
          {
            role: 'menuitem',
            tabIndex: '-1',
            onClick: function onClick() {
              return _this5.handlerSelectItem(r);
            }
          },
          typeof this.props.itemValue === 'function' ? this.props.itemValue(r) : objectPath.get(r, this.props.itemValue) !== undefined ? objectPath.get(r, this.props.itemValue) : typeof this.props.itemValueDefault === 'function' ? this.props.itemValueDefault(r) : this.props.itemValueDefault
        )
      );
    }
  }, {
    key: '_renderInput',
    value: function _renderInput() {
      var _this6 = this;

      var _props = this.props,
          datalist = _props.datalist,
          itemKey = _props.itemKey,
          itemValue = _props.itemValue,
          onSearch = _props.onSearch,
          autocomplete = _props.autocomplete,
          componentClass = _props.componentClass,
          onChanged = _props.onChanged,
          noRescue = _props.noRescue,
          stylesInput = _props.stylesInput,
          className = _props.className,
          label = _props.label,
          onSelect = _props.onSelect,
          withButton = _props.withButton,
          byField = _props.byField,
          disabled = _props.disabled,
          motiveDisabled = _props.motiveDisabled,
          fieldArray = _props.fieldArray,
          input = _props.input,
          meta = _props.meta,
          required = _props.required,
          fetching = _props.fetching,
          searchDebounce = _props.searchDebounce,
          itemValueDefault = _props.itemValueDefault,
          itemValueShow = _props.itemValueShow,
          props = _objectWithoutProperties(_props, ['datalist', 'itemKey', 'itemValue', 'onSearch', 'autocomplete', 'componentClass', 'onChanged', 'noRescue', 'stylesInput', 'className', 'label', 'onSelect', 'withButton', 'byField', 'disabled', 'motiveDisabled', 'fieldArray', 'input', 'meta', 'required', 'fetching', 'searchDebounce', 'itemValueDefault', 'itemValueShow']); // eslint-disable-line


      return React.createElement(
        InputGroup,
        { className: className + ' FieldBusqueda' },
        React.createElement(
          InputGroupAddon,
          null,
          React.createElement(Icon, {
            bootstrap: 'magnifier'
          })
        ),
        React.createElement(
          'div',
          { style: { width: '100%' } },
          React.createElement(Input, _extends$1({
            id: label ? label.replace(/ /g, '') : input.name.replace(/ /g, ''),
            autoComplete: autocomplete ? 'on' : 'off',
            type: componentClass,
            style: _extends$1({}, stylesInput, { width: '100%' }),
            value: this.state.value,
            readOnly: true
          }, props)),
          React.createElement(
            Dropdown,
            { isOpen: this.state.dropdownOpen, toggle: this.toggle },
            React.createElement(
              DropdownMenu,
              null,
              React.createElement(
                FormGroup,
                { style: { margin: 7 } },
                React.createElement(
                  InputGroup,
                  null,
                  React.createElement('input', {
                    ref: function ref(inputSearch) {
                      _this6.inputSearch = inputSearch;
                    },
                    type: 'search',
                    placeholder: 'Buscar ...',
                    className: 'form-control',
                    style: { width: '100%', padding: '0.3rem 0.75rem' },
                    onChange: function onChange(e) {
                      return !_this6.props.withButton && _this6.handlerChangeSearch(e.currentTarget.value);
                    },
                    onKeyPress: this.handlerKeyPress
                  }),
                  this.props.withButton && React.createElement(
                    Button,
                    {
                      size: 'sm',
                      color: 'primary',
                      onClick: this.handlerClickSearch
                    },
                    'Buscar'
                  ),
                  React.createElement(
                    Button,
                    {
                      size: 'sm',
                      onClick: this.toggle
                    },
                    'Cerrar'
                  )
                )
              ),
              React.createElement('hr', { style: { margin: '5px 7px' } }),
              React.createElement(
                'ul',
                { role: 'menu' },
                React.createElement(
                  'li',
                  { role: 'presentation',
                    className: datalist.length || fetching ? 'disabled' : ''
                  },
                  fetching && React.createElement(
                    'a',
                    { role: 'menuitem', tabIndex: '-1' },
                    'Buscando ...'
                  ),
                  datalist.length === 0 && !fetching && React.createElement(
                    'a',
                    { role: 'menuitem', tabIndex: '-1' },
                    'No se encuentran resultados'
                  )
                ),
                datalist.length !== 0 && !fetching && datalist.map(this._renderResult)
              )
            )
          )
        ),
        disabled && motiveDisabled && React.createElement(
          OverlayTrigger,
          {
            placement: 'top',
            overlay: this._renderTooltip(motiveDisabled)
          },
          React.createElement(
            InputGroupAddon,
            { style: { cursor: 'not-allowed' }
            },
            React.createElement(Icon, {
              bootstrap: 'arrow-down'
            })
          )
        ),
        disabled && !motiveDisabled && React.createElement(
          InputGroupAddon,
          {
            style: { cursor: 'not-allowed' }
          },
          React.createElement(Icon, {
            bootstrap: 'arrow-down'
          })
        ),
        !disabled && React.createElement(
          OverlayTrigger,
          {
            placement: 'top',
            overlay: this._renderTooltip('Abrir buscador')
          },
          React.createElement(
            InputGroupAddon,
            {
              style: { cursor: 'pointer' },
              onClick: this.toggle
            },
            React.createElement(Icon, {
              bootstrap: 'arrow-down'
            })
          )
        ),
        !required && React.createElement(
          OverlayTrigger,
          {
            placement: 'top',
            overlay: this._renderTooltip('Limpiar')
          },
          React.createElement(
            InputGroupAddon,
            { style: { cursor: 'pointer' }, onClick: this.handleCleanBuscador },
            React.createElement(Icon, {
              bootstrap: 'close'
            })
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          horizontal = _props2.horizontal,
          required = _props2.required,
          meta = _props2.meta,
          props = _objectWithoutProperties(_props2, ['horizontal', 'required', 'meta']);

      return React.createElement(
        FormGroup,
        {
          color: !meta.touched ? '' : meta.valid ? '' : 'danger',
          row: horizontal ? true : undefined
        },
        props.label && React.createElement(
          Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        horizontal && React.createElement(
          Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderInput(),
          meta.touched && meta.error && React.createElement(
            FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderInput(),
        !horizontal && meta.touched && meta.error && React.createElement(
          FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldBusqueda;
}(Component);

FieldBusqueda.defaultProps = {
  autocomplete: false,
  searchDebounce: 300,
  fetching: false,
  datalist: [],
  noRescue: false
};

FieldBusqueda.propTypes = {
  label: PropTypes.string,
  mask: PropTypes.string,
  required: PropTypes.bool,
  meta: PropTypes.object,
  horizontal: PropTypes.object,
  byField: PropTypes.any,
  input: PropTypes.object,
  onSelect: PropTypes.func,
  className: PropTypes.string,
  autocomplete: PropTypes.bool,
  itemReactKeyPropName: PropTypes.string,
  itemValuePropName: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  searchDebounce: PropTypes.number,
  fetching: PropTypes.bool,
  onSearchValue: PropTypes.func,
  datalist: PropTypes.array,
  withButton: PropTypes.any,
  placeholder: PropTypes.string,
  disabled: PropTypes.any,
  motiveDisabled: PropTypes.string,
  itemValueShow: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  itemValue: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  itemValueDefault: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  itemKey: PropTypes.string,
  onSearch: PropTypes.func,
  componentClass: PropTypes.string,
  stylesInput: PropTypes.object,
  onChanged: PropTypes.func,
  fieldArray: PropTypes.bool,
  noRescue: PropTypes.bool
};

var FieldFileUpload = function (_Component) {
  _inherits(FieldFileUpload, _Component);

  function FieldFileUpload(props) {
    _classCallCheck(this, FieldFileUpload);

    var _this = _possibleConstructorReturn(this, (FieldFileUpload.__proto__ || Object.getPrototypeOf(FieldFileUpload)).call(this, props));

    var file = false;
    var restore = false;
    if (props.input) {
      file = props.input.value;
      restore = props.input.value;
    }

    _this.state = {
      file: file,
      restore: restore,
      btnRestore: false
    };
    _this.onDrop = _this.onDrop.bind(_this);
    _this.deleteIMG = _this.deleteIMG.bind(_this);
    _this.restoreIMG = _this.restoreIMG.bind(_this);
    return _this;
  }

  _createClass(FieldFileUpload, [{
    key: 'onDrop',
    value: function onDrop(file, reject) {
      var _this2 = this;

      var promise = new Promise(function (resolve, reject) {
        var reader = new FileReader(); // eslint-disable-line
        reader.readAsDataURL(file[0]);
        reader.onload = function () {
          if (reader.result) {
            resolve(reader.result);
          } else {
            reject(Error('Failed converting to base64'));
          }
        };
      });
      promise.then(function (result) {
        _this2.setState({
          file: {
            fileName: file[0].name,
            fileSize: file[0].size,
            fileType: file[0].type,
            preview: file[0].preview,
            base64: result.split(',')[1]
          },
          btnRestore: true
        }, function () {
          _this2.props.input && _this2.props.input.onChange(merge(_this2.state.file, { preview: undefined }));
        });
      }, function (err) {
        console.log(err);
      });
    }
  }, {
    key: 'deleteIMG',
    value: function deleteIMG(e) {
      var _this3 = this;

      e.stopPropagation();
      if (this.state.file.preview) {
        window.URL.revokeObjectURL(this.state.file.preview);
      }
      this.setState({
        file: false,
        btnRestore: true
      }, function () {
        _this3.props.input && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur('');
      });
    }
  }, {
    key: 'restoreIMG',
    value: function restoreIMG(e) {
      var _this4 = this;

      e.stopPropagation();
      this.setState({
        file: this.state.restore,
        btnRestore: false
      }, function () {
        _this4.props.input && _this4.props.input.onChange(_this4.state.file);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        Dropzone,
        {
          onDrop: this.onDrop,
          multiple: false,
          accept: this.props.accept,
          name: this.props.name,
          style: _extends$1({
            width: '100%',
            height: 200,
            borderWidth: 2,
            borderColor: 'rgb(102, 102, 102)',
            borderStyle: 'dashed',
            borderRadius: 5,
            position: 'relative',
            overflow: 'hidden',
            background: '#c5c5c5',
            cursor: 'pointer',
            marginBottom: '1rem'
          }, this.props.style)
        },
        !this.state.file && React.createElement('img', {
          alt: '',
          src: '/icons/icon-avatar.png',
          style: {
            width: '100%',
            height: '100%',
            objectFit: 'contain'
          }
        }),
        this.state.file && React.createElement('img', {
          alt: '',
          src: this.state.file.preview ? this.state.file.preview : this.state.file.uri,
          style: _extends$1({
            width: '100%',
            height: '100%',
            objectFit: 'cover'
          }, this.props.styleImg)
        }),
        React.createElement('div', {
          style: {
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0
          }
        }),
        React.createElement(
          'div',
          {
            style: _extends$1({
              position: 'absolute',
              top: 0,
              width: '100%',
              textAlign: 'right'
            }, this.props.styleButtons)
          },
          this.state.restore && this.state.btnRestore && React.createElement(
            OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Restaurar original')
            },
            React.createElement(
              Button,
              {
                size: 'sm',
                color: 'info',
                onClick: this.restoreIMG
              },
              React.createElement(Icon, { bootstrap: 'action-undo' })
            )
          ),
          this.state.file && React.createElement(
            OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Eliminar')
            },
            React.createElement(
              Button,
              {
                size: 'sm',
                color: 'danger',
                onClick: this.deleteIMG
              },
              React.createElement(Icon, { bootstrap: 'trash' })
            )
          )
        )
      );
    }
  }]);

  return FieldFileUpload;
}(Component);

FieldFileUpload.defaultProps = {
  accept: 'image/png, image/jpeg, image/jpg',
  style: {},
  styleButtons: {},
  styleImg: {}
};

FieldFileUpload.propTypes = {
  accept: PropTypes.string,
  name: PropTypes.string,
  style: PropTypes.object,
  styleButtons: PropTypes.object,
  styleImg: PropTypes.object,
  input: PropTypes.object
};

var StylesInput = {
  padding: '8px 0 0.3rem',
  backgroundColor: 'transparent',
  outline: 'none',
  border: 'none',
  borderBottom: '1px solid rgba(0, 0, 0, 0.15)',
  textAlign: 'center',
  display: 'inline-block'
};

var FieldTime = function (_Component) {
  _inherits(FieldTime, _Component);

  function FieldTime(props) {
    _classCallCheck(this, FieldTime);

    var _this = _possibleConstructorReturn(this, (FieldTime.__proto__ || Object.getPrototypeOf(FieldTime)).call(this, props));

    var value = {
      hora: '00',
      minutos: '00'
    };
    if (props.input.value && props.input.value !== '') {
      value = props.input.value.split(':');
      value = {
        hora: value[0],
        minutos: value[1]
      };
    }

    _this.state = {
      value: value,
      hora: _this.generateTime(24),
      minutos: _this.generateTime(60)
    };
    _this.handlerChangeHora = _this.handlerChangeHora.bind(_this);
    _this.handlerChangeMinutos = _this.handlerChangeMinutos.bind(_this);
    _this.setValue = _this.setValue.bind(_this);
    _this._renderInput = _this._renderInput.bind(_this);
    return _this;
  }

  _createClass(FieldTime, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value && nextProps.input.value !== '' && !deepEqual(nextProps.input.value, this.state.value)) {
        var value = nextProps.input.value.split(':');
        value = {
          hora: value[0],
          minutos: value[1]
        };
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: 'generateTime',
    value: function generateTime(hasta) {
      var cantidad = [];
      for (var i = 0; i < hasta; i++) {
        if (i < 10) {
          i = '0' + i;
        }
        cantidad.push(i.toString());
      }
      return cantidad;
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'handlerChangeHora',
    value: function handlerChangeHora(e) {
      var _this2 = this;

      this.setState({
        value: merge(this.state.value, { hora: e.currentTarget.value })
      }, function () {
        _this2.setValue();
      });
    }
  }, {
    key: 'handlerChangeMinutos',
    value: function handlerChangeMinutos(e) {
      var _this3 = this;

      this.setState({
        value: merge(this.state.value, { minutos: e.currentTarget.value })
      }, function () {
        _this3.setValue();
      });
    }
  }, {
    key: 'setValue',
    value: function setValue() {
      var value = this.state.value.hora + ':' + this.state.value.minutos;
      this.props.input && this.props.input.onChange && this.props.input.onChange(value);
      this.props.onChanged && this.props.onChanged(value);
    }
  }, {
    key: '_renderInput',
    value: function _renderInput() {
      return React.createElement(
        'div',
        { style: { display: 'flex' } },
        React.createElement(
          'select',
          {
            style: StylesInput,
            className: 'form-control',
            value: this.state.value.hora,
            onChange: this.handlerChangeHora
          },
          this.state.hora.map(function (h, k) {
            return React.createElement(
              'option',
              { key: k, value: h },
              h
            );
          })
        ),
        React.createElement(
          'span',
          { className: 'font-xl' },
          ':'
        ),
        React.createElement(
          'select',
          {
            style: StylesInput,
            className: 'form-control',
            value: this.state.value.minutos,
            onChange: this.handlerChangeMinutos
          },
          this.state.minutos.map(function (m, k) {
            return React.createElement(
              'option',
              { key: k, value: m },
              m
            );
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          horizontal = _props.horizontal,
          required = _props.required,
          meta = _props.meta,
          info = _props.info,
          className = _props.className,
          props = _objectWithoutProperties(_props, ['horizontal', 'required', 'meta', 'info', 'className']);

      return React.createElement(
        FormGroup,
        {
          color: meta ? !meta.touched ? '' : meta.valid ? '' : 'danger' : '',
          row: horizontal ? true : undefined,
          className: className
        },
        props.label && React.createElement(
          Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && React.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          ),
          '\xA0',
          info && info !== '' && React.createElement(
            OverlayTrigger,
            {
              placement: 'right',
              overlay: this._renderTooltip(info)
            },
            React.createElement(
              'wrapper',
              null,
              React.createElement(Icon, { bootstrap: 'info' })
            )
          )
        ),
        horizontal && React.createElement(
          Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderInput(),
          meta && meta.touched && meta.error && React.createElement(
            FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderInput(),
        !horizontal && meta && meta.touched && meta.error && React.createElement(
          FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldTime;
}(Component);

FieldTime.defaultProps = {};

FieldTime.propTypes = {
  label: PropTypes.string,
  required: PropTypes.bool,
  meta: PropTypes.object,
  horizontal: PropTypes.object,
  info: PropTypes.string,
  className: PropTypes.string,
  onChanged: PropTypes.func,
  input: PropTypes.object
};

// function isInt(n){
//     return Number(n) === n && n % 1 === 0;
// }

function isFloat(n) {
  return Number(n) === n && n % 1 !== 0;
}

function required(value) {
  return value === undefined || value === '' ? 'Requerido' : null;
}

function validarMaximo(maximo, minimo) {
  if (maximo !== undefined && maximo !== '' && (Number(maximo) || maximo === 0) && minimo !== undefined && minimo !== '' && (Number(minimo) || minimo === 0) && Number(maximo) < Number(minimo)) {
    return 'El máximo debe ser mayor o igual al mínimo';
  } else {
    return null;
  }
}

function validarMaximoInclusive(maximo, minimo) {
  if (maximo !== undefined && maximo !== '' && (Number(maximo) || maximo === 0) && minimo !== undefined && minimo !== '' && (Number(minimo) || minimo === 0) && Number(maximo) <= Number(minimo)) {
    return 'El máximo debe ser mayor al mínimo';
  } else {
    return null;
  }
}

function onlyNumber(value) {
  if (value !== undefined && value !== '' && isNaN(Number(value))) {
    return 'Solo números';
  } else {
    return null;
  }
}

function onlyEnteros(value) {
  if (value !== undefined && value !== '' && isFloat(Number(value))) {
    return 'Solo enteros';
  } else {
    return null;
  }
}

function menorQue(value, parametro) {
  if (value !== undefined && value !== '' && (Number(value) || value === 0) && parametro !== undefined && parametro !== '' && (Number(parametro) || parametro === 0) && Number(value) >= Number(parametro)) {
    return 'Debe ser menor que ' + parametro;
  } else {
    return null;
  }
}

function menorQueInclusive(value, parametro) {
  if (value !== undefined && value !== '' && (Number(value) || value === 0) && parametro !== undefined && parametro !== '' && (Number(parametro) || parametro === 0) && Number(value) > Number(parametro)) {
    return 'Debe ser menor que o igual a ' + parametro;
  } else {
    return null;
  }
}

function mayorQue(value, parametro) {
  if (value !== undefined && value !== '' && (Number(value) || value === 0) && parametro !== undefined && parametro !== '' && (Number(parametro) || parametro === 0) && Number(value) <= Number(parametro)) {
    return 'Debe ser mayor que ' + parametro;
  } else {
    return null;
  }
}

function mayorQueInclusive(value, parametro) {
  if (value !== undefined && value !== '' && (Number(value) || value === 0) && parametro !== undefined && parametro !== '' && (Number(parametro) || parametro === 0) && Number(value) < Number(parametro)) {
    return 'Debe ser mayor que o igual a ' + parametro;
  } else {
    return null;
  }
}

function maxLength(value, parametro) {
  if (value !== undefined && value !== '') {
    var primerBlanco = /^ /;
    var ultimoBlanco = / $/;
    var variosBlancos = /[ ]+/g;
    value = value.toString();
    value = value.replace(variosBlancos, ' ');
    value = value.replace(primerBlanco, '');
    value = value.replace(ultimoBlanco, '');
    if (value.length > parametro) {
      return 'El máximo es de ' + parametro + ' caracteres';
    } else {
      return null;
    }
  } else {
    return null;
  }
}

function minLength(value, parametro) {
  if (value !== undefined && value !== '') {
    var primerBlanco = /^ /;
    var ultimoBlanco = / $/;
    var variosBlancos = /[ ]+/g;
    value = value.toString();
    value = value.replace(variosBlancos, ' ');
    value = value.replace(primerBlanco, '');
    value = value.replace(ultimoBlanco, '');
    if (value.length < parametro) {
      return 'El mínimo es de ' + parametro + ' caracteres';
    } else {
      return null;
    }
  } else {
    return null;
  }
}

function isEmail(value) {
  if (value !== undefined && value !== '' && !/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(value)) {
    return 'Email incorrecto';
  } else {
    return null;
  }
}

var index$1 = {
  required: required,
  validarMaximo: validarMaximo,
  validarMaximoInclusive: validarMaximoInclusive,
  onlyNumber: onlyNumber,
  onlyEnteros: onlyEnteros,
  menorQue: menorQue,
  menorQueInclusive: menorQueInclusive,
  mayorQue: mayorQue,
  mayorQueInclusive: mayorQueInclusive,
  maxLength: maxLength,
  minLength: minLength,
  isEmail: isEmail
};

function cleanWhiteSpace(value) {
  var primerBlanco = /^ /;
  var variosBlancos = /[ ]+/g;
  value = value.replace(variosBlancos, ' ');
  value = value.replace(primerBlanco, '');
  return value;
}

function toInt(value, vDefault) {
  return value !== undefined && value !== '' && !isNaN(Number(value)) ? parseInt(value, 10) : vDefault !== undefined ? vDefault : value;
}

function toFloat(value, vDefault) {
  return value !== undefined && value !== '' && !isNaN(Number(value)) ? parseFloat(value, 10) : vDefault !== undefined ? vDefault : value;
}

function toBool(value) {
  return value === 'true';
}

var index$2 = {
  cleanWhiteSpace: cleanWhiteSpace,
  toInt: toInt,
  toFloat: toFloat,
  toBool: toBool
};

var Loader = function Loader(_ref) {
  var show = _ref.show;
  return React.createElement(
    'wrapper',
    { className: 'loader-body-fetching ' + (show ? 'loader-fadeIn' : 'loader-fadeOut') },
    React.createElement('div', { className: 'loader-content-fetching' }),
    React.createElement(
      'div',
      { className: 'showbox' },
      React.createElement(
        'div',
        { className: 'loader' },
        React.createElement(
          'svg',
          { className: 'circular', viewBox: '25 25 50 50' },
          React.createElement('circle', { className: 'path',
            cx: '50',
            cy: '50',
            r: '20',
            fill: 'none',
            strokeWidth: '2',
            strokeMiterlimit: '10'
          })
        )
      )
    )
  );
};

Loader.defaultProps = {
  show: false
};

Loader.propTypes = {
  show: PropTypes.bool
};

var FormCustomErrors = function (_Component) {
  _inherits(FormCustomErrors, _Component);

  function FormCustomErrors(props) {
    _classCallCheck(this, FormCustomErrors);

    var _this = _possibleConstructorReturn(this, (FormCustomErrors.__proto__ || Object.getPrototypeOf(FormCustomErrors)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(FormCustomErrors, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.getElementById('customError').scrollIntoView();
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'wrapper',
        {
          id: 'customError',
          className: 'mt-3 animated fadeInUp',
          style: { display: 'block' }
        },
        React.createElement('hr', null),
        React.createElement(
          Alert,
          {
            color: this.props.color
          },
          this.props.title
        )
      );
    }
  }]);

  return FormCustomErrors;
}(Component);

FormCustomErrors.defaultProps = {
  color: 'danger'
};

FormCustomErrors.propTypes = {
  title: PropTypes.string,
  color: PropTypes.string
};

// mandatory
// import 'react-s-alert/dist/s-alert-default.css'

// optional - you can choose the effect you want
// import 'react-s-alert/dist/s-alert-css-effects/slide.css'
// import 'react-s-alert/dist/s-alert-css-effects/scale.css'
// import 'react-s-alert/dist/s-alert-css-effects/bouncyflip.css'
// import 'react-s-alert/dist/s-alert-css-effects/flip.css'
// import 'react-s-alert/dist/s-alert-css-effects/genie.css'
// import 'react-s-alert/dist/s-alert-css-effects/jelly.css'
// import 'react-s-alert/dist/s-alert-css-effects/stackslide.css'

var AlertNotification = function (_Component) {
  _inherits(AlertNotification, _Component);

  function AlertNotification(props) {
    _classCallCheck(this, AlertNotification);

    var _this = _possibleConstructorReturn(this, (AlertNotification.__proto__ || Object.getPrototypeOf(AlertNotification)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(AlertNotification, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        null,
        React.createElement(
          'span',
          null,
          this.props.children
        ),
        React.createElement(Alert$1, this.props)
      );
    }
  }]);

  return AlertNotification;
}(Component);

AlertNotification.defaultProps = {};

AlertNotification.propTypes = {
  children: PropTypes.any
};

// Constants
var SPRING_CONFIG = [400, 28];

// Utility functions
function toRadians(degrees) {
  return degrees * 0.0174533;
}

var IconMotionMenu = function (_Component) {
  _inherits(IconMotionMenu, _Component);

  function IconMotionMenu(props) {
    _classCallCheck(this, IconMotionMenu);

    var _this = _possibleConstructorReturn(this, (IconMotionMenu.__proto__ || Object.getPrototypeOf(IconMotionMenu)).call(this, props));

    var button = React.cloneElement(props.button, {
      ref: function ref(iconMotionMenuBtn) {
        _this.iconMotionMenuBtn = iconMotionMenuBtn;
      },
      onClick: function onClick(e) {
        return _this.toggleMenu(e);
      }
    });

    var childrens = [];
    if (Array.isArray(props.children)) {
      childrens = props.children;
    } else {
      childrens.push(props.children);
    }
    childrens = childrens.filter(function (c) {
      return c;
    });
    var children = childrens.map(function (v, k) {
      v = React.cloneElement(v, {
        onClick: function onClick() {}
      });
      return v;
    });
    _this.state = {
      isOpen: false,
      button: button,
      childButtons: [],
      children: children,
      baseAngle: '',
      childPosition: { x: 15, y: 15 },
      childrens: childrens
    };
    _this.toggleMenu = _this.toggleMenu.bind(_this);
    _this.closeMenu = _this.closeMenu.bind(_this);
    _this.animateChildButtonsWithDelay = _this.animateChildButtonsWithDelay.bind(_this);
    _this.initialChildButtonStyles = _this.initialChildButtonStyles.bind(_this);
    _this.finalChildButtonStyles = _this.finalChildButtonStyles.bind(_this);
    _this.finalChildDeltaPositions = _this.finalChildDeltaPositions.bind(_this);
    _this.renderChildButton = _this.renderChildButton.bind(_this);
    return _this;
  }

  _createClass(IconMotionMenu, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var childButtons = [];
      this.state.children.map(function (button, index) {
        childButtons.push(_this2.renderChildButton(index));
        return button;
      });
      var element = ReactDOM.findDOMNode(this.iconMotionMenuBtn);
      var FAN_ANGLE = this.props.initAngle ? this.props.initAngle : (childButtons.length - 1) * this.props.separationAngle;
      if (element) {
        element.style.position = 'relative';
        element.style.zIndex = 1;
      }
      this.setState({
        childButtons: childButtons,
        baseAngle: (180 - FAN_ANGLE) / 2,
        childPosition: { x: element && element.offsetWidth / 2, y: 15 }
      });
    }
  }, {
    key: 'initialChildButtonStyles',
    value: function initialChildButtonStyles() {
      return {
        width: this.props.childButtonDiam,
        height: this.props.childButtonDiam,
        top: spring(this.state.childPosition.y - this.props.childButtonDiam / 2, SPRING_CONFIG),
        left: spring(this.state.childPosition.x - this.props.childButtonDiam / 2, SPRING_CONFIG),
        rotate: spring(-180, SPRING_CONFIG),
        scale: spring(0.5, SPRING_CONFIG),
        zIndex: 0
      };
    }
  }, {
    key: 'finalChildButtonStyles',
    value: function finalChildButtonStyles(childIndex) {
      var _finalChildDeltaPosit = this.finalChildDeltaPositions(childIndex),
          deltaX = _finalChildDeltaPosit.deltaX,
          deltaY = _finalChildDeltaPosit.deltaY;

      return {
        width: this.props.childButtonDiam,
        height: this.props.childButtonDiam,
        top: spring(this.state.childPosition.y - deltaY, SPRING_CONFIG),
        left: spring(this.state.childPosition.x + deltaX, SPRING_CONFIG),
        rotate: spring(0, SPRING_CONFIG),
        scale: spring(1, SPRING_CONFIG),
        zIndex: this.props.backlock ? 1042 : 0
      };
    }
  }, {
    key: 'finalChildDeltaPositions',
    value: function finalChildDeltaPositions(index) {
      var angle = this.state.baseAngle + index * this.props.separationAngle;
      var delta = Math.cos(toRadians(angle)) < 0 ? Math.cos(toRadians(angle)) * -1 : Math.cos(toRadians(angle)) * -1;
      return {
        deltaX: this.props.flyOutRadius * delta - this.props.childButtonDiam / 2,
        deltaY: this.props.flyOutRadius * Math.sin(toRadians(angle)) + this.props.childButtonDiam / 2
      };
    }
  }, {
    key: 'toggleMenu',
    value: function toggleMenu(e) {
      var _this3 = this;

      e.stopPropagation();
      this.setState({
        isOpen: !this.state.isOpen
      }, function () {
        var element = ReactDOM.findDOMNode(_this3.iconMotionMenuBtn);
        if (_this3.state.isOpen && _this3.props.backlock) {
          element.style.zIndex = 1043;
        } else {
          element.style.zIndex = 1;
        }
        _this3.state.isOpen ? document.body.classList.add('modal-open') : document.body.classList.remove('modal-open');
      });
      this.animateChildButtonsWithDelay();
    }
  }, {
    key: 'closeMenu',
    value: function closeMenu() {
      var _this4 = this;

      this.setState({
        isOpen: false
      }, function () {
        document.body.classList.remove('modal-open');
        var element = ReactDOM.findDOMNode(_this4.iconMotionMenuBtn);
        element.style.zIndex = 1;
      });
      this.animateChildButtonsWithDelay();
    }
  }, {
    key: 'animateChildButtonsWithDelay',
    value: function animateChildButtonsWithDelay() {
      var _this5 = this;

      this.state.childButtons.map(function (button, index) {
        var childButtons = _this5.state.childButtons;

        setTimeout(function () {
          if (_this5.props.animate.direccion === 'right') {
            var key = _this5.state.childButtons.length - index - 1;
            childButtons[key] = _this5.renderChildButton(key);
          } else {
            childButtons[index] = _this5.renderChildButton(index);
          }
        }, index * (_this5.props.animate.velocidad ? _this5.props.animate.velocidad : IconMotionMenu.defaultProps.animate.velocidad));
        return button;
      });
    }
  }, {
    key: 'renderChildButton',
    value: function renderChildButton(index) {
      var _this6 = this;

      var style = this.state.isOpen ? this.finalChildButtonStyles(index) : this.initialChildButtonStyles();
      return React.createElement(
        Motion,
        { style: style, key: index },
        function (_ref) {
          var width = _ref.width,
              height = _ref.height,
              top = _ref.top,
              left = _ref.left,
              rotate = _ref.rotate,
              scale = _ref.scale,
              zIndex = _ref.zIndex;
          return React.createElement(
            'div',
            {
              className: 'IconMotionMenu child-button',
              style: {
                width: width,
                height: height,
                top: top,
                left: left,
                transform: 'rotate(' + rotate + 'deg) scale(' + scale + ')',
                zIndex: zIndex
              },
              onClick: function onClick() {
                _this6.state.childrens[index].props.onClick();_this6.closeMenu();
              }
            },
            _this6.state.children[index]
          );
        }
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      var _state = this.state,
          isOpen = _state.isOpen,
          button = _state.button,
          childButtons = _state.childButtons;

      var mainButtonRotation = isOpen ? { rotate: spring(0, [500, 30]) } : { rotate: spring(-135, [500, 30]) };
      if (this.state.children.length !== 0) {
        return React.createElement(
          Motion,
          { style: mainButtonRotation },
          function (_ref2) {
            var rotate = _ref2.rotate;
            return React.createElement(
              'wrapper',
              {
                style: {
                  position: 'relative',
                  display: 'inline-block'
                }
              },
              _this7.props.backlock && React.createElement('div', {
                onClick: function onClick() {
                  return _this7.closeMenu();
                },
                style: {
                  visibility: _this7.state.isOpen ? 'visible' : 'hidden',
                  transition: !_this7.state.isOpen ? 'visibility 0s linear 0.5s,opacity 0.5s linear' : ''
                },
                className: 'modal-backdrop fade ' + (_this7.state.isOpen ? 'show' : '')
              }),
              React.createElement(
                'wrapper',
                {
                  style: {
                    zIndex: _this7.props.rotateButton ? _this7.props.backlock && _this7.state.isOpen ? 1043 : 1 : 'initial',
                    position: _this7.props.rotateButton ? 'absolute' : 'initial',
                    transform: _this7.props.rotateButton ? 'rotate(' + rotate + 'deg)' : ''
                  }
                },
                button
              ),
              childButtons.map(function (button) {
                return button;
              })
            );
          }
        );
      } else {
        return null;
      }
    }
  }]);

  return IconMotionMenu;
}(Component);

IconMotionMenu.defaultProps = {
  animate: {
    direccion: 'left',
    velocidad: 60
  },
  childButtonDiam: 30,
  separationAngle: 40,
  flyOutRadius: 60,
  backlock: true
};

IconMotionMenu.propTypes = {
  animate: PropTypes.object,
  children: PropTypes.any,
  button: PropTypes.any,
  rotateButton: PropTypes.bool,
  childButtonDiam: PropTypes.number,
  separationAngle: PropTypes.number,
  flyOutRadius: PropTypes.number,
  initAngle: PropTypes.number,
  backlock: PropTypes.bool
};

var MenuTopMotion = function (_Component) {
  _inherits(MenuTopMotion, _Component);

  function MenuTopMotion(props) {
    _classCallCheck(this, MenuTopMotion);

    var _this = _possibleConstructorReturn(this, (MenuTopMotion.__proto__ || Object.getPrototypeOf(MenuTopMotion)).call(this, props));

    _this.state = {
      buttons: null
    };
    return _this;
  }

  _createClass(MenuTopMotion, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.isOpen === true) {
        document.body.classList.add('modal-open');

        var buttons = [];
        if (nextProps.buttons && Array.isArray(nextProps.buttons.props.children)) {
          nextProps.buttons.props.children.map(function (b, bk) {
            if (b) {
              b = React.cloneElement(b, {
                key: 'button-' + bk,
                style: { flex: 1 }
              });
              buttons.push(b);
            }
            return b;
          });
        } else {
          var btn = React.cloneElement(nextProps.buttons, {
            key: 'button',
            style: { flex: 1 }
          });
          buttons.push(btn);
        }
        buttons.push(React.createElement(
          Button,
          {
            style: { flex: 1 },
            key: 'close',
            size: 'md',
            onClick: function onClick() {
              return _this2.props.closeMenu(false);
            },
            name: 'close'
          },
          'Cerrar'
        ));

        this.setState({
          buttons: buttons
        });
      } else {
        document.body.classList.remove('modal-open');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React.createElement(
        'wrapper',
        {
          className: 'MenuTopMotion',
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 1s,opacity 1s linear' : ''
          }
        },
        this.props.backlock && React.createElement('div', {
          onClick: function onClick() {
            return _this3.props.closeMenu(false);
          },
          style: {
            visibility: this.props.isOpen ? 'visible' : 'hidden',
            transition: !this.props.isOpen ? 'visibility 0s linear 0.5s,opacity 0.5s linear' : ''
          },
          className: 'modal-backdrop fade ' + (this.props.isOpen ? 'show' : '')
        }),
        React.createElement(
          Navbar,
          { color: this.props.backgroundColor,
            toggleable: true,
            className: 'animated-3 ' + (this.props.isOpen ? this.props.animation.open : this.props.animation.close)
          },
          this.props.children,
          React.createElement(
            'wrapper',
            {
              style: {
                display: 'flex',
                alignSelf: 'flex-start',
                flexWrap: 'wrap'
              }
            },
            this.state.buttons
          )
        )
      );
    }
  }]);

  return MenuTopMotion;
}(Component);

MenuTopMotion.defaultProps = {
  backlock: true,
  backgroundColor: 'faded',
  animation: { open: 'slideInDown', close: 'slideOutUp' }
};

MenuTopMotion.propTypes = {
  backgroundColor: PropTypes.string,
  backlock: PropTypes.bool,
  animation: PropTypes.object,
  isOpen: PropTypes.bool,
  closeMenu: PropTypes.func,
  children: PropTypes.any,
  buttons: PropTypes.any
};

var ContentDetail = function (_Component) {
  _inherits(ContentDetail, _Component);

  function ContentDetail(props) {
    _classCallCheck(this, ContentDetail);

    var _this = _possibleConstructorReturn(this, (ContentDetail.__proto__ || Object.getPrototypeOf(ContentDetail)).call(this, props));

    var descripciones = [];
    for (var key in props.descripciones) {
      descripciones.push({ key: key, valor: props.descripciones[key] });
    }

    var contenido = {};
    if (props.contenido && Object.keys(props.contenido).length !== 0) {
      contenido = props.contenido;
    }

    _this.state = {
      descripciones: descripciones,
      contenido: contenido
    };
    _this._renderLi = _this._renderLi.bind(_this);
    return _this;
  }

  _createClass(ContentDetail, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.contenido && Object.keys(nextProps.contenido).length !== 0) {
        this.setState({ contenido: nextProps.contenido });
      }
    }
  }, {
    key: '_renderLi',
    value: function _renderLi(dato, key, total) {
      var value = '-';
      if (this.props.formatContenido[dato.key]) {
        if (typeof this.props.formatContenido[dato.key] === 'function') {
          value = this.props.formatContenido[dato.key](objectPath.get(this.state.contenido, dato.key), this.state.contenido);
        } else {
          value = objectPath.get(this.props.formatContenido, dato.key);
        }
      } else if (objectPath.get(this.state.contenido, dato.key) && objectPath.get(this.state.contenido, dato.key) !== '' || objectPath.get(this.state.contenido, dato.key) === 0 || objectPath.get(this.state.contenido, dato.key) === false) {
        if (objectPath.get(this.state.contenido, dato.key) === true) {
          value = this.props.defaultBooleanTxt.true;
        } else if (objectPath.get(this.state.contenido, dato.key) === false) {
          value = this.props.defaultBooleanTxt.false;
        } else {
          value = objectPath.get(this.state.contenido, dato.key);
        }
      }
      return React.createElement(
        'li',
        { key: key,
          style: {
            overflow: 'hidden',
            borderBottom: key === total - 1 ? 'none' : '1px solid #999999',
            paddingTop: 10
          }
        },
        React.createElement(
          'label',
          { className: 'pull-left' },
          dato.valor
        ),
        React.createElement(
          'strong',
          { className: 'pull-right' },
          value
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        'wrapper',
        { style: { width: '100%' } },
        Object.keys(this.state.contenido).length === 0 && React.createElement(
          'h5',
          null,
          'Cargando ...'
        ),
        Object.keys(this.state.contenido).length !== 0 && React.createElement(
          'ul',
          { style: { listStyleType: 'none', paddingLeft: 0 } },
          this.state.descripciones.map(function (v, k) {
            return _this2._renderLi(v, k, _this2.state.descripciones.length);
          })
        ),
        this.props.children
      );
    }
  }]);

  return ContentDetail;
}(Component);

ContentDetail.defaultProps = {
  descripciones: {},
  contenido: {},
  formatContenido: {},
  defaultBooleanTxt: { true: 'Si', false: 'No' }
};

ContentDetail.propTypes = {
  descripciones: PropTypes.object,
  contenido: PropTypes.object,
  formatContenido: PropTypes.object,
  children: PropTypes.any,
  defaultBooleanTxt: PropTypes.object
};

var Callout = function (_Component) {
  _inherits(Callout, _Component);

  function Callout(props) {
    _classCallCheck(this, Callout);

    var _this = _possibleConstructorReturn(this, (Callout.__proto__ || Object.getPrototypeOf(Callout)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Callout, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        Col,
        {
          className: 'col-' + (this.props.size.xs ? this.props.size.xs : this.props.size.sm ? this.props.size.sm : this.props.size.md ? this.props.size.md : this.props.size.lg ? this.props.size.lg : this.props.size.xl ? this.props.size.xl : 12),
          style: _extends$1({ padding: this.props.fullWidth && 0 }, this.props.style),
          xs: this.props.size.xs,
          sm: this.props.size.sm,
          md: this.props.size.md,
          lg: this.props.size.lg,
          xl: this.props.size.xl
        },
        React.createElement(
          'div',
          { className: 'callout callout-' + this.props.color },
          this.props.small && typeof this.props.small === 'function' && this.props.small(),
          this.props.small && typeof this.props.small === 'string' && React.createElement(
            'small',
            { className: 'text-muted' },
            this.props.small
          ),
          this.props.small && typeof this.props.small === 'string' && React.createElement('br', null),
          this.props.title && typeof this.props.title === 'function' && this.props.title(),
          this.props.title && typeof this.props.title === 'string' && React.createElement(
            'strong',
            { className: 'h4' },
            this.props.title
          )
        )
      );
    }
  }]);

  return Callout;
}(Component);

Callout.defaultProps = {
  size: {},
  color: 'info'
};

Callout.propTypes = {
  small: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  color: PropTypes.string,
  size: PropTypes.object,
  style: PropTypes.object,
  fullWidth: PropTypes.bool
};

var ContentDocumentos = function (_Component) {
  _inherits(ContentDocumentos, _Component);

  function ContentDocumentos(props) {
    _classCallCheck(this, ContentDocumentos);

    var _this = _possibleConstructorReturn(this, (ContentDocumentos.__proto__ || Object.getPrototypeOf(ContentDocumentos)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(ContentDocumentos, [{
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return React.createElement(
        Tooltip,
        { id: 'tooltip' },
        React.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        Col,
        {
          className: 'col-12',
          lg: this.props.size
        },
        React.createElement(
          Interactive,
          {
            as: 'div',
            active: {
              transition: '.2s all ease-in-out',
              transform: 'scale(.95)'
            },
            style: {
              transition: '.2s all ease-out'
            }
          },
          React.createElement(Callout, {
            fullWidth: true,
            title: function title() {
              return React.createElement(
                'wrapper',
                { style: {
                    display: 'block',
                    padding: '5px 0px'
                  }
                },
                _this2.props.children,
                React.createElement('hr', null),
                React.createElement(
                  Row,
                  {
                    style: {
                      display: 'flex',
                      marginBottom: -5,
                      marginTop: 10
                    }
                  },
                  _this2.props.download && React.createElement(
                    OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Descargar documento')
                    },
                    React.createElement(
                      Button,
                      {
                        style: {
                          flex: 1,
                          position: 'relative'
                        },
                        size: 'sm',
                        color: 'success',
                        onClick: function onClick(e) {
                          return e.stopPropagation();
                        }
                      },
                      React.createElement('a', {
                        href: _this2.props.download.uri,
                        download: _this2.props.download.fileName,
                        style: {
                          position: 'absolute',
                          top: 0,
                          bottom: 0,
                          left: 0,
                          right: 0
                        }
                      }),
                      React.createElement(Icon, { bootstrap: 'cloud-download' })
                    )
                  ),
                  _this2.props.download && React.createElement(
                    'wrapper',
                    null,
                    '\xA0\xA0'
                  ),
                  _this2.props.edit && React.createElement(
                    OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Editar documento')
                    },
                    React.createElement(
                      Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        onClick: _this2.props.edit
                      },
                      React.createElement(Icon, { bootstrap: 'pencil' })
                    )
                  ),
                  _this2.props.edit && React.createElement(
                    'wrapper',
                    null,
                    '\xA0\xA0'
                  ),
                  _this2.props.delete && React.createElement(
                    OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Eliminar documento')
                    },
                    React.createElement(
                      Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        color: 'danger',
                        onClick: _this2.props.delete
                      },
                      React.createElement(Icon, { bootstrap: 'trash' })
                    )
                  ),
                  _this2.props.rescue && React.createElement(
                    OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Recuperar documento')
                    },
                    React.createElement(
                      Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        color: 'info',
                        onClick: _this2.props.rescue
                      },
                      React.createElement(Icon, { bootstrap: 'action-undo' })
                    )
                  )
                )
              );
            },
            color: 'primary'
          })
        )
      );
    }
  }]);

  return ContentDocumentos;
}(Component);

ContentDocumentos.defaultProps = {
  size: '3'
};

ContentDocumentos.propTypes = {
  children: PropTypes.any,
  size: PropTypes.string,
  download: PropTypes.object,
  edit: PropTypes.func,
  delete: PropTypes.func,
  rescue: PropTypes.func
};

var ScrollTop = function (_Component) {
  _inherits(ScrollTop, _Component);

  function ScrollTop(props) {
    _classCallCheck(this, ScrollTop);

    var _this = _possibleConstructorReturn(this, (ScrollTop.__proto__ || Object.getPrototypeOf(ScrollTop)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(ScrollTop, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        ScrollToTop,
        _extends$1({}, this.props, {
          style: {
            position: 'fixed',
            bottom: 50,
            right: 30,
            cursor: 'pointer',
            transitionDuration: '0.2s',
            transitionTimingFunction: 'linear',
            transitionDelay: '0s',
            zIndex: 1
          }
        }),
        React.createElement(Icon, {
          style: {
            fontSize: 33,
            background: '#20a8d8',
            color: 'white',
            padding: '4px 6px',
            borderRadius: 7
          },
          className: 'hidden-print',
          bootstrap: 'arrow-up-circle' })
      );
    }
  }]);

  return ScrollTop;
}(Component);

ScrollTop.defaultProps = {};

ScrollTop.propTypes = {};

var Form = function (_Component) {
  _inherits(Form, _Component);

  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Form, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        'form',
        {
          noValidate: true,
          onSubmit: this.props.onSubmit,
          className: this.props.className,
          ref: function ref(e) {
            return _this2.props.refs(e);
          },
          style: { width: '100%' }
        },
        !this.props.disabled && React.createElement('button', { type: 'sumbit', style: { display: 'none' } }),
        this.props.children
      );
    }
  }]);

  return Form;
}(Component);

Form.defaultProps = {
  refs: function refs() {}
};

Form.propTypes = {
  children: PropTypes.any,
  onSubmit: PropTypes.func,
  className: PropTypes.string,
  refs: PropTypes.func,
  disabled: PropTypes.bool
};

// Translate month names
var MONTHS$2 = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT$2 = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG$2 = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

var CalendarYear = function (_Component) {
  _inherits(CalendarYear, _Component);

  function CalendarYear(props) {
    _classCallCheck(this, CalendarYear);

    var _this = _possibleConstructorReturn(this, (CalendarYear.__proto__ || Object.getPrototypeOf(CalendarYear)).call(this, props));

    var year = props.calendarios[0];
    if (props.initCalendario) {
      year = props.initCalendario;
    }

    _this.state = {
      year: year,
      calendarios: []
    };
    _this.showPrevious = _this.showPrevious.bind(_this);
    _this.showNext = _this.showNext.bind(_this);
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    return _this;
  }

  _createClass(CalendarYear, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.calendarios.length !== 0 && this.state.calendarios.length === 0) {
        var year = nextProps.calendarios[0];
        if (nextProps.initCalendario) {
          year = nextProps.initCalendario;
        }

        nextProps.changeCalendario(year);
        this.setState({
          year: year,
          calendarios: nextProps.calendarios
        });
      }
    }
  }, {
    key: 'showPrevious',
    value: function showPrevious() {
      this.props.changeCalendario(this.state.year - 1);
      this.setState({
        year: this.state.year - 1
      });
    }
  }, {
    key: 'showNext',
    value: function showNext() {
      this.props.changeCalendario(this.state.year + 1);
      this.setState({
        year: this.state.year + 1
      });
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, modifiers, _ref) {
      var disabled = _ref.disabled,
          selected = _ref.selected;

      if (disabled) {
        return;
      }
      this.props.onSelected && this.props.onSelected(moment(day));
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'YearCalendar' },
        this.props.calendarios.length !== 0 && React.createElement(
          'h1',
          null,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year - 1)] && React.createElement(
            'a',
            { onClick: this.showPrevious },
            this.state.year - 1
          ),
          this.state.year,
          this.props.calendarios[this.props.calendarios.indexOf(this.state.year + 1)] && React.createElement(
            'a',
            { onClick: this.showNext },
            this.state.year + 1
          )
        ),
        this.props.calendarios.length !== 0 && React.createElement('hr', null),
        !this.props.fetching && this.props.fetchingDias && this.props.calendarios.length !== 0 && React.createElement(DayPicker, {
          locale: 'es',
          months: MONTHS$2,
          weekdaysLong: WEEKDAYS_LONG$2,
          weekdaysShort: WEEKDAYS_SHORT$2,
          onDayClick: this.handleDayClick,
          canChangeMonth: false,
          month: new Date(this.state.year, 0, 1),
          numberOfMonths: 12,
          modifiers: this.props.modifiers,
          renderDay: this.props.renderDay && this.props.renderDay
        }),
        this.props.fetching && React.createElement(
          'h3',
          { style: { color: '#596464' } },
          'Cargando ...'
        ),
        !this.props.fetching && this.props.calendarios.length === 0 && React.createElement(
          'p',
          { style: { color: '#596464' } },
          React.createElement(
            'strong',
            null,
            'No existen calendarios cargados'
          )
        )
      );
    }
  }]);

  return CalendarYear;
}(Component);

CalendarYear.defaultProps = {
  calendarios: []
};

CalendarYear.propTypes = {
  calendarios: PropTypes.array,
  initCalendario: PropTypes.number,
  fetching: PropTypes.bool,
  fetchingDias: PropTypes.bool,
  onSelected: PropTypes.func,
  renderDay: PropTypes.func,
  changeCalendario: PropTypes.func,
  modifiers: PropTypes.object
};

var NavLink$1 = function (_Component) {
  _inherits(NavLink$$1, _Component);

  function NavLink$$1(props) {
    _classCallCheck(this, NavLink$$1);

    var _this = _possibleConstructorReturn(this, (NavLink$$1.__proto__ || Object.getPrototypeOf(NavLink$$1)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(NavLink$$1, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        NavLink,
        {
          className: (this.props.tab !== undefined && this.props.tab === this.props.active ? 'active' : '') + (this.props.required ? ' text-danger' : ''),
          disabled: this.props.disabled,
          onClick: function onClick() {
            return _this2.props.onClick(_this2.props.tab);
          },
          onBlur: this.props.onBlur,
          onFocus: this.props.onFocus,
          onMouseOut: this.props.onMouseOut,
          onMouseOver: this.props.onMouseOver
        },
        this.props.children,
        this.props.required && React.createElement(
          'span',
          { className: 'text-danger' },
          '\xA0!'
        )
      );
    }
  }]);

  return NavLink$$1;
}(Component);

NavLink$1.defaultProps = {
  onClick: function onClick() {},
  onBlur: function onBlur() {},
  onFocus: function onFocus() {},
  onMouseOut: function onMouseOut() {},
  onMouseOver: function onMouseOver() {}
};

NavLink$1.propTypes = {
  children: PropTypes.any,
  required: PropTypes.bool,
  disabled: PropTypes.bool,
  tab: PropTypes.string,
  active: PropTypes.string,
  onClick: PropTypes.func,
  onBlur: PropTypes.func,
  onFocus: PropTypes.func,
  onMouseOut: PropTypes.func,
  onMouseOver: PropTypes.func
};

var Vr = function (_Component) {
  _inherits(Vr, _Component);

  function Vr(props) {
    _classCallCheck(this, Vr);

    var _this = _possibleConstructorReturn(this, (Vr.__proto__ || Object.getPrototypeOf(Vr)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Vr, [{
    key: 'render',
    value: function render() {
      return React.createElement('vr', {
        style: _extends$1({
          marginRight: -1,
          width: 1,
          background: 'rgba(0, 0, 0, 0.1)',
          marginBottom: '-1rem',
          marginTop: '-1rem'
        }, this.props.style),
        className: this.props.className
      });
    }
  }]);

  return Vr;
}(Component);

Vr.defaultProps = {
  style: {}
};

Vr.propTypes = {
  className: PropTypes.string,
  style: PropTypes.object
};

var TabPane$1 = function (_Component) {
  _inherits(TabPane$$1, _Component);

  function TabPane$$1(props, context) {
    _classCallCheck(this, TabPane$$1);

    var _this = _possibleConstructorReturn(this, (TabPane$$1.__proto__ || Object.getPrototypeOf(TabPane$$1)).call(this, props, context));

    _this.state = {
      tabIsShow: props.tabId === context.activeTabId || context.form
    };
    return _this;
  }

  _createClass(TabPane$$1, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextConstext) {
      if (!this.state.tabIsShow && nextProps.tabId === nextConstext.activeTabId) {
        this.setState({
          tabIsShow: true
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.tabIsShow) {
        return React.createElement(
          TabPane,
          { tabId: this.props.tabId },
          this.props.children
        );
      }
      return null;
    }
  }]);

  return TabPane$$1;
}(Component);

TabPane$1.contextTypes = {
  activeTabId: PropTypes.any,
  form: PropTypes.bool
};

TabPane$1.defaultProps = {};

TabPane$1.propTypes = {
  children: PropTypes.any,
  tabId: PropTypes.string,
  form: PropTypes.bool
};

var TabContent$1 = function (_Component) {
  _inherits(TabContent$$1, _Component);

  function TabContent$$1(props) {
    _classCallCheck(this, TabContent$$1);

    var _this = _possibleConstructorReturn(this, (TabContent$$1.__proto__ || Object.getPrototypeOf(TabContent$$1)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(TabContent$$1, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        activeTabId: this.props.activeTab,
        form: this.props.form
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'tab-content ' + this.props.className },
        this.props.children
      );
    }
  }]);

  return TabContent$$1;
}(Component);

TabContent$1.childContextTypes = {
  activeTabId: PropTypes.any,
  form: PropTypes.bool
};

TabContent$1.defaultProps = {
  form: false,
  className: ''
};

TabContent$1.propTypes = {
  activeTab: PropTypes.any,
  children: PropTypes.any,
  className: PropTypes.string,
  form: PropTypes.bool
};

// import FieldDateEvent from './FieldDateEvent'
// import FieldDragDropBoxes from './FieldDragDropBoxes'

export { Header, Body, Footer, Aside, Sidebar, Breadcrumb, ViewAnimated, Card, CardImgFull, CardLittle, CardLittleIcon, Modal$1 as Modal, index as Table, TableCard, Icon, FieldGroup, FieldGroupIcon, FieldGroupFile, FieldSwitch, FieldCaptcha, FieldDate, FieldDateTime, FieldBusqueda, FieldFileUpload as FieldImgProfile, FieldTime, index$1 as FieldValidate, index$2 as FieldNormalize, Loader, FormCustomErrors as FormCustomError, AlertNotification, IconMotionMenu, MenuTopMotion, ContentDetail, ContentDocumentos, ScrollTop, Callout, Form, CalendarYear, NavLink$1 as NavLink, Vr, TabPane$1 as TabPane, TabContent$1 as TabContent };
//# sourceMappingURL=react-coreui-component.es.js.map
